/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)cdr_log.h    generated by: makeheader    Sat Mar  9 09:37:57 2024
 *
 *		built from:	log.ifc
 */

#ifndef cdr_log_h
#define cdr_log_h


  #ifndef cdr_dll_h
    #include "cdr/cdr_dll.h"
  #endif
  #ifndef log_common_h
    #include "log/log_common.h"
  #endif
  #ifndef log_category_h
    #include "log/log_category.h"
  #endif
  #ifndef reda_worker_h
    #include "reda/reda_worker.h"
  #endif
  #ifndef osapi_activityContext_h
    #include "osapi/osapi_activityContext.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif


/*e \ingroup RTICdrLog
  Submodule ID for error code */
  #define SUBMODULE_CDR_STREAM                  (0x0000)
  #define SUBMODULE_CDR_TYPE_CODE               (0x0001)
  #define SUBMODULE_CDR_TYPE_OBJECT             (0x0002)


/*e \ingroup RTICdrLog
  Stream submodule mask for logging.
*/
  #define RTI_CDR_SUBMODULE_MASK_STREAM         (0x0001)
/*e \ingroup RTICdrLog
  Type code submodule mask for logging.
*/
  #define RTI_CDR_SUBMODULE_MASK_TYPE_CODE      (0x0002)  

/*e \ingroup RTICdrLog
  TypeObject submodule mask for logging.
*/
  #define RTI_CDR_SUBMODULE_MASK_TYPE_OBJECT      (0x0004)  

/*e \ingroup RTICdrLog
  Mask for turning on logging for all submodules.
*/
  #define RTI_CDR_SUBMODULE_MASK_ALL RTI_LOG_SUBMODULE_MASK_ALL

extern RTICdrDllExport
void RTICdrLog_setDependencyInstrumentationMask(RTILogBitmap verbosity);

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_SERIALIZE_FAILURE_s;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_DESERIALIZE_FAILURE_s;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_SKIP_FAILURE_s;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_INVALID_ENCAPSULATION_ID_d;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_EXCEED_SEQ_MAX_LENGTH_dd;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_EXCEED_MAX_CHANNEL_LENGTH_uu;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_SERIALIZE_INVALID_ENUMERATOR_ds;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_DESERIALIZE_INVALID_ENUMERATOR_ds;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_DESERIALIZE_UNCOMPRESSED_LENGTH_FAILURE_uu;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_UNASSIGNABLE_SAMPLE_OF_TYPE_s;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_XTYPES_DESERIALIZE_UNKNOWN_ENUM_ORDINAL_sssdd;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_XTYPES_DESERIALIZE_UNKNOWN_UNION_DISCRIMINATOR_s;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_XTYPES_DESERIALIZE_UNKNOWN_UNION_DISCRIMINATOR_sss;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_NOT_ASSIGNABLE_sss;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_NOT_ASSIGNABLE_ss;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_MEMBER_NOT_ASSIGNABLE_ssd;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_COLLECTION_BOUNDS_NOT_ASSIGNABLE_dd;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_UNION_LABEL_NOT_ASSIGNABLE_dss;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_NOT_ASSIGNABLE_s;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_ERROR_ds;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_NOT_EQUIVALENT_ss;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_NOT_EQUAL_ss;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_MEMBER_NOT_EQUAL_ssd;

extern RTICdrDllVariable const struct RTILogMessage RTI_CDR_LOG_TYPE_OBJECT_NOT_EQUAL_s;



/*i
 * \ingroup RTICdrLog
 * @brief See \ref RTILogCategory_log
 */
#define RTICdrLogger_log(instrumentationBit__, logMessage__, worker__, ...) \
  RTILogCategory_log( \
          RTICdrLog_g_instrumentationMask, \
          RTICdrLog_g_submoduleMask, \
          RTI_CDR_CURRENT_SUBMODULE, \
          (instrumentationBit__), \
          MODULE_CDR, \
          (logMessage__), \
          (worker__), \
          __VA_ARGS__)

#define RTICdrLogMessage_log(INSTRUMENT_BIT, ...) \
    RTILogMessage_log( \
            RTICdrLog_g_instrumentationMask, \
            RTICdrLog_g_submoduleMask, \
            RTI_CDR_CURRENT_SUBMODULE, \
            RTI_LOG_PRINT_FORMAT_MASK_ALL, \
            (INSTRUMENT_BIT), \
            MODULE_CDR, \
            __VA_ARGS__)

#define RTICdrLog_logWithFunctionName(INSTRUMENT_BIT, FUNCTION_NAME, ...) \
    RTILogMessage_logWithFunctionName( \
            RTICdrLog_g_instrumentationMask, \
            RTICdrLog_g_submoduleMask, \
            RTI_CDR_CURRENT_SUBMODULE, \
            RTI_LOG_PRINT_FORMAT_MASK_ALL, \
            (INSTRUMENT_BIT), \
            MODULE_CDR, \
            (FUNCTION_NAME), \
            __VA_ARGS__)

#define RTICdrLog_fatal(...) \
    RTICdrLogMessage_log(RTI_LOG_BIT_FATAL_ERROR, __VA_ARGS__)

#define RTICdrLog_exception(...) \
    RTICdrLogMessage_log(RTI_LOG_BIT_EXCEPTION, __VA_ARGS__)

#define RTICdrLog_warn(...) \
    RTICdrLogMessage_log(RTI_LOG_BIT_WARN, __VA_ARGS__)



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* cdr_log_h */
