/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)commend_readerStatistics.h    generated by: makeheader    Sat Mar  9 09:38:24 2024
 *
 *		built from:	readerStatistics.ifc
 */

#ifndef commend_readerStatistics_h
#define commend_readerStatistics_h



#include "osapi/osapi_type.h"

#ifdef __cplusplus
    extern "C" {
#endif

struct COMMENDReaderServiceLocalReaderStatistics {
    RTI_INT64 samplesReceivedCount;
    RTI_INT64 samplesReceivedCountChange;
    RTI_INT64 samplesReceivedBytes;
    RTI_INT64 samplesReceivedBytesChange;
    RTI_INT64 samplesReceivedAgainCount;
    RTI_INT64 samplesReceivedAgainCountChange;
    RTI_INT64 samplesReceivedAgainBytes;
    RTI_INT64 samplesReceivedAgainBytesChange;
    RTI_INT64 samplesFilteredCount;
    RTI_INT64 samplesFilteredCountChange;
    RTI_INT64 samplesFilteredBytes;
    RTI_INT64 samplesFilteredBytesChange;
    RTI_INT64 heartbeatsReceivedCount;
    RTI_INT64 heartbeatsReceivedCountChange;
    RTI_INT64 heartbeatsReceivedBytes;
    RTI_INT64 heartbeatsReceivedBytesChange;
    RTI_INT64 acksSentCount;
    RTI_INT64 acksSentCountChange;
    RTI_INT64 acksSentBytes;
    RTI_INT64 acksSentBytesChange;
    RTI_INT64 nacksSentCount;
    RTI_INT64 nacksSentCountChange;
    RTI_INT64 nacksSentBytes;
    RTI_INT64 nacksSentBytesChange;
    RTI_INT64 gapsReceivedCount;
    RTI_INT64 gapsReceivedCountChange;
    RTI_INT64 gapsReceivedBytes;
    RTI_INT64 gapsReceivedBytesChange;
    RTI_INT64 samplesRejectedCount;
    RTI_INT64 samplesRejectedCountChange;
    RTI_INT64 outOfRangeRejectedSampleCount;
    /* Statistics associated with fragmented data */
    RTI_INT64 fragmentsReceivedCount;
    RTI_INT64 fragmentsDroppedCount;
    RTI_INT64 samplesReassembledCount;
    RTI_INT64 nackFragmentsSentCount;
    RTI_INT64 nackFragmentsSentBytes;
};


#define COMMEND_READER_SERVICE_LOCAL_READER_STATISTICS_INITIALIZER { \
0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  \
0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  \
0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  \
0, 0, 0, 0, 0, 0               \
}

struct COMMENDReaderServiceMatchedWriterStatistics {
    RTI_INT64 samplesReceivedCount;
    RTI_INT64 samplesReceivedCountChange;
    RTI_INT64 samplesReceivedBytes;
    RTI_INT64 samplesReceivedBytesChange;
    RTI_INT64 samplesReceivedAgainCount;
    RTI_INT64 samplesReceivedAgainCountChange;
    RTI_INT64 samplesReceivedAgainBytes;
    RTI_INT64 samplesReceivedAgainBytesChange;
    RTI_INT64 heartbeatsReceivedCount;
    RTI_INT64 heartbeatsReceivedCountChange;
    RTI_INT64 heartbeatsReceivedBytes;
    RTI_INT64 heartbeatsReceivedBytesChange;
    RTI_INT64 acksSentCount;
    RTI_INT64 acksSentCountChange;
    RTI_INT64 acksSentBytes;
    RTI_INT64 acksSentBytesChange;
    RTI_INT64 nacksSentCount;
    RTI_INT64 nacksSentCountChange;
    RTI_INT64 nacksSentBytes;
    RTI_INT64 nacksSentBytesChange;
    RTI_INT64 gapsReceivedCount;
    RTI_INT64 gapsReceivedCountChange;
    RTI_INT64 gapsReceivedBytes;
    RTI_INT64 gapsReceivedBytesChange;
    RTI_INT64 samplesRejectedCount;
    RTI_INT64 samplesRejectedCountChange;
    struct REDASequenceNumber firstAvailableSn;
    struct REDASequenceNumber lastAvailableSn;
    struct REDASequenceNumber lastCommittedSn;
    RTI_INT32 samplesUncommittedCount;
    RTI_INT64 outOfRangeRejectedSampleCount;
    RTI_INT64 fragmentsReceivedCount;
    RTI_INT64 fragmentsDroppedCount;
    RTI_INT64 samplesReassembledCount;
    RTI_INT64 nackFragmentsSentCount;
    RTI_INT64 nackFragmentsSentBytes;
};


#define COMMEND_READER_SERVICE_MATCHED_WRITER_STATISTICS_INITIALIZER { \
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \
0, 0, 0, 0, 0, 0, \
REDA_SEQUENCE_NUMBER_ZERO, \
REDA_SEQUENCE_NUMBER_ZERO, \
REDA_SEQUENCE_NUMBER_ZERO, \
0, 0, 0, 0, 0, 0, 0        \
}


#ifdef __cplusplus
    }	/* extern "C" */
#endif

    #include "commend/commend_readerStatistics_impl.h"


#endif /* commend_readerStatistics_h */
