/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)dds_c_domain.h    generated by: makeheader    Sat Mar  9 09:39:08 2024
 *
 *		built from:	domain.ifc
 */

#ifndef dds_c_domain_h
#define dds_c_domain_h


  #ifndef property_propertyNames_h
    #include "property/property_propertyNames.h"
  #endif
  #ifndef dds_c_infrastructure_h
    #include "dds_c/dds_c_infrastructure.h"
  #endif
  #ifndef dds_c_topic_h
    #include "dds_c/dds_c_topic.h"
  #endif
  #ifndef dds_c_typecode_h
    #include "dds_c/dds_c_typecode.h"
  #endif
  #ifndef dds_c_publication_h
    #include "dds_c/dds_c_publication.h"
  #endif
  #ifndef dds_c_subscription_h
    #include "dds_c/dds_c_subscription.h"
  #endif
  #ifndef dds_c_flowcontroller_h
    #include "dds_c/dds_c_flowcontroller.h"
  #endif
  #ifndef dds_c_dll_h
    #include "dds_c/dds_c_dll.h"
  #endif
  #ifndef ndds_config_c_h
    #include "ndds/ndds_config_c.h"
  #endif
  #ifndef ndds_utility_c_h
    #include "ndds/ndds_utility_c.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif

typedef DDS_DOMAINID_TYPE_NATIVE     DDS_DomainId_t;

 extern DDSCDllVariable const struct DDS_DomainParticipantFactoryQos 
    *DDS_DOMAINPARTICIPANTFACTORY_QOS_PRINT_ALL;

 extern DDSCDllVariable const struct DDS_DomainParticipantQos 
    *DDS_DOMAINPARTICIPANT_QOS_PRINT_ALL;

struct DDS_DomainParticipantQos;

struct DDS_PublisherQos;

struct DDS_SubscriberQos;

struct DDS_DataReaderQos;

struct DDS_DataWriterQos;

struct DDS_TopicQos;

struct DDS_DomainParticipantListener;

struct DDS_PublisherListener;

struct DDS_SubscriberListener;

struct DDS_DataReaderListener;

struct DDS_DataWriterListener;

struct DDS_TopicListener;

typedef void* 
    (*DDS_DomainParticipantEntityListener_OnBeforeCreateCallback)(
                DDS_DomainId_t domainId,
                struct DDS_DomainParticipantQos* qos,
                struct DDS_DomainParticipantListener* listener,
                DDS_StatusMask *mask,
                DDS_ReturnCode_t *ret_retcode,
                void *param);

typedef void 
    (*DDS_DomainParticipantEntityListener_OnAfterCreateCallback)(
                            DDS_DomainParticipant *participant,
                            DDS_ReturnCode_t retcode,
                            void *return_param,
                            void *param);

typedef void* 
    (*DDS_DomainParticipantEntityListener_OnBeforeDeleteCallback)(
                DDS_DomainParticipant *participant,
                DDS_ReturnCode_t *ret_retcode,
                void *param);

typedef void 
    (*DDS_DomainParticipantEntityListener_OnAfterDeleteCallback)(
	    DDS_DomainParticipant *participant,
	    DDS_ReturnCode_t retcode, 
	    void *return_param,
	    void *param);

typedef void* 
    (*DDS_DomainParticipantEntityListener_OnBeforeSetQosCallback)(
        DDS_DomainParticipant *participant,
        struct DDS_DomainParticipantQos* qos,
        DDS_ReturnCode_t *ret_retcode,
        void *param);

typedef void 
    (*DDS_DomainParticipantEntityListener_OnAfterSetQosCallback)(
	    DDS_DomainParticipant *participant,
	    DDS_ReturnCode_t retcode,
	    void *return_param,
	    void *param);

typedef void*
    (*DDS_DomainParticipantEntityListener_OnBeforeDeleteContainedCallback)
       (DDS_DomainParticipant *participant,
        DDS_ReturnCode_t *ret_retcode,
        void *param);

typedef void
    (*DDS_DomainParticipantEntityListener_OnAfterDeleteContainedCallback)
       (DDS_DomainParticipant *participant,
        DDS_ReturnCode_t ret_retcode,
        void *return_param,
        void *param);

typedef void* (*DDS_DomainParticipantEntityListener_OnBeforeSetListenerCallback)(
                        DDS_DomainParticipant *participant,
                        struct DDS_DomainParticipantListener *listener,
                        DDS_StatusMask *mask,
                        DDS_ReturnCode_t *ret_retcode,
                        void *param);

typedef void (*DDS_DomainParticipantEntityListener_OnAfterSetListenerCallback)(  
                                    DDS_DomainParticipant *participant,
                                    DDS_ReturnCode_t ret_retcode,
                                    void *return_param,
                                    void *param);

struct DDS_InvalidLocalIdentityAdvanceNoticeStatus {
    /*e \dref_InvalidLocalIdentityAdvanceNoticeStatus_expiration_time
     */
    struct DDS_Time_t expiration_time;
};


#define DDS_InvalidLocalIdentityAdvanceNoticeStatus_INITIALIZER { \
    DDS_TIME_ZERO /* expiration_time */ \
}

extern DDSCDllExport DDS_ReturnCode_t
DDS_InvalidLocalIdentityAdvanceNoticeStatus_initialize(
        struct DDS_InvalidLocalIdentityAdvanceNoticeStatus *self);

extern DDSCDllExport DDS_ReturnCode_t DDS_InvalidLocalIdentityAdvanceNoticeStatus_copy(
        struct DDS_InvalidLocalIdentityAdvanceNoticeStatus *self,
        const struct DDS_InvalidLocalIdentityAdvanceNoticeStatus *source);

extern DDSCDllExport DDS_ReturnCode_t
DDS_InvalidLocalIdentityAdvanceNoticeStatus_finalize(
        struct DDS_InvalidLocalIdentityAdvanceNoticeStatus *self);

typedef void (*DDS_DomainParticipantListener_InvalidLocalIdentityAdvanceNoticeStatusCallback)(
        void *listener_data,
        DDS_DomainParticipant *participant,
        const struct DDS_InvalidLocalIdentityAdvanceNoticeStatus *invalid_local_identity_advance_notice_status);

extern DDSCDllExport void
DDS_DomainParticipantListener_on_invalid_local_identity_status_advance_notice_noop(
        void *listener_data,
        DDS_DomainParticipant *participant,
        const struct DDS_InvalidLocalIdentityAdvanceNoticeStatus
                *invalid_local_identity_advance_notice_status);

extern DDSCDllExport DDS_Boolean DDS_InvalidLocalIdentityAdvanceNoticeStatus_equals(
        const struct DDS_InvalidLocalIdentityAdvanceNoticeStatus *left,
        const struct DDS_InvalidLocalIdentityAdvanceNoticeStatus *right);

struct DDS_DomainParticipantListener {
    /*ce \dref_DomainParticipantListener_as_listener
     */
    struct DDS_Listener as_listener;

    /*ce \dref_DomainParticipantListener_as_topiclistener
     */
    struct DDS_TopicListener        as_topiclistener;

    /*ce \dref_DomainParticipantListener_as_publisherlistener
     */
    struct DDS_PublisherListener    as_publisherlistener;
    
    /*ce \dref_DomainParticipantListener_as_subscriberlistener
     */
    struct DDS_SubscriberListener   as_subscriberlistener;

    /*ce \dref_DomainParticipantListener_on_invalid_local_identity_status_advance_notice
     */
    DDS_DomainParticipantListener_InvalidLocalIdentityAdvanceNoticeStatusCallback
            on_invalid_local_identity_status_advance_notice;
};


#define DDS_DomainParticipantListener_INITIALIZER { \
    DDS_Listener_INITIALIZER, \
    DDS_TopicListener_INITIALIZER, \
    DDS_PublisherListener_INITIALIZER, \
    DDS_SubscriberListener_INITIALIZER, \
    NULL /* on_invalid_local_identity_status_advance_notice */ \
}


#define DDS_DomainParticipantListener_NOOP_INITIALIZER { \
    DDS_Listener_INITIALIZER, \
    DDS_TopicListener_NOOP_INITIALIZER, \
    DDS_PublisherListener_NOOP_INITIALIZER, \
    DDS_SubscriberListener_NOOP_INITIALIZER, \
    DDS_DomainParticipantListener_on_invalid_local_identity_status_advance_notice_noop \
}

typedef struct DDS_DomainParticipantListener 
        (*DDS_DomainParticipantEntityListener_OnGetListenerCallback)(  
                        DDS_DomainParticipant *participant,void *param);

typedef void* (*DDS_PublisherEntityListener_OnBeforeCreateCallback)(
    DDS_DomainParticipant *participant,
	struct DDS_PublisherQos *qos,
	struct DDS_PublisherListener* listener,
	DDS_StatusMask *mask,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void 
    (*DDS_PublisherEntityListener_OnAfterCreateCallback)(
        DDS_Publisher *publisher,
        DDS_ReturnCode_t ret_retcode,
        void *return_param,
        void *param);

typedef void* (*DDS_PublisherEntityListener_OnBeforeDeleteCallback)(
	DDS_DomainParticipant *participant,
	DDS_Publisher *publisher,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_PublisherEntityListener_OnAfterDeleteCallback)(
	DDS_DomainParticipant *participant,
	DDS_Publisher *publisher,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_PublisherEntityListener_OnBeforeSetQosCallback)(
	DDS_Publisher *publisher,
	struct DDS_PublisherQos* qos,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_PublisherEntityListener_OnAfterSetQosCallback)(
	DDS_Publisher *publisher,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void*
    (*DDS_PublisherEntityListener_OnBeforeDeleteContainedCallback)
    (DDS_Publisher *publisher,
    DDS_ReturnCode_t *ret_retcode,
     void *param);

typedef void
    (*DDS_PublisherEntityListener_OnAfterDeleteContainedCallback)
        (DDS_Publisher *publisher,
         DDS_ReturnCode_t ret_retcode,
         void *return_param,
         void *param);

typedef void* (*DDS_PublisherEntityListener_OnBeforeSetListenerCallback)(
                        DDS_Publisher *publisher,
                        struct DDS_PublisherListener *listener,
                        DDS_StatusMask *mask,
                        DDS_ReturnCode_t *ret_retcode,
                        void *param);

typedef void (*DDS_PublisherEntityListener_OnAfterSetListenerCallback)(  
                        DDS_Publisher *publisher,
                        DDS_ReturnCode_t ret_retcode,
                        void *return_param,
                        void *param);

typedef struct DDS_PublisherListener 
        (*DDS_PublisherEntityListener_OnGetListenerCallback)(  
                                        DDS_Publisher *publisher,void *param);

typedef void* (*DDS_SubscriberEntityListener_OnBeforeCreateCallback)(
    DDS_DomainParticipant *participant,
    struct DDS_SubscriberQos *qos,
    struct DDS_SubscriberListener* listener,
    DDS_StatusMask *mask,
    DDS_ReturnCode_t *ret_retcode,
    void *param);

typedef void (*DDS_SubscriberEntityListener_OnAfterCreateCallback)(
	DDS_Subscriber *subscriber,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_SubscriberEntityListener_OnBeforeDeleteCallback)(
	DDS_DomainParticipant *participant,
	DDS_Subscriber *subscriber,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_SubscriberEntityListener_OnAfterDeleteCallback)(
	DDS_DomainParticipant *participant,
	DDS_Subscriber *subscriber,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_SubscriberEntityListener_OnBeforeSetQosCallback)(
	DDS_Subscriber *subscriber,
	struct DDS_SubscriberQos* qos,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_SubscriberEntityListener_OnAfterSetQosCallback)(
	DDS_Subscriber *subscriber,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void*
    (*DDS_SubscriberEntityListener_OnBeforeDeleteContainedCallback)
    (DDS_Subscriber *subscriber,
     DDS_ReturnCode_t *ret_retcode,
     void *param);

typedef void
    (*DDS_SubscriberEntityListener_OnAfterDeleteContainedCallback)
        (DDS_Subscriber *subscriber,
         DDS_ReturnCode_t ret_retcode,
         void *return_param,
         void *param);

typedef void* (*DDS_SubscriberEntityListener_OnBeforeSetListenerCallback)(
                    DDS_Subscriber *subscriber,
                    struct DDS_SubscriberListener *listener,
                    DDS_StatusMask *mask,
                    DDS_ReturnCode_t *ret_retcode,
                    void *param);

typedef void (*DDS_SubscriberEntityListener_OnAfterSetListenerCallback)(  
                    DDS_Subscriber *subscriber,
                    DDS_ReturnCode_t ret_retcode,
                    void *return_param,
                    void *param);

typedef struct DDS_SubscriberListener 
    (*DDS_SubscriberEntityListener_OnGetListenerCallback)(  
                                    DDS_Subscriber *subscriber,void *param);

typedef void* (*DDS_DataWriterEntityListener_OnBeforeCreateCallback)(
    DDS_Publisher *publisher,
	DDS_Topic *topic,
	struct DDS_DataWriterQos *qos,
	struct DDS_DataWriterListener* listener,
	DDS_StatusMask *mask,
    DDS_ReturnCode_t *retcode,
	void *param);

typedef void (*DDS_DataWriterEntityListener_OnAfterCreateCallback)(
	DDS_DataWriter *writer,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_DataWriterEntityListener_OnBeforeDeleteCallback)(
	DDS_Publisher *publisher,
	DDS_DataWriter *subscriber,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_DataWriterEntityListener_OnAfterDeleteCallback)(
	DDS_Publisher *publisher,
	DDS_DataWriter *writer,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_DataWriterEntityListener_OnBeforeSetQosCallback)(
	DDS_DataWriter *writer,
	struct DDS_DataWriterQos* qos,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_DataWriterEntityListener_OnAfterSetQosCallback)(
	DDS_DataWriter *writer,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_DataWriterEntityListener_OnBeforeSetListenerCallback)(
                                        DDS_DataWriter *writer,
                                        struct DDS_DataWriterListener *listener,
                                        DDS_StatusMask *mask,
                                        DDS_ReturnCode_t *retcode,
                                        void *param);

typedef void (*DDS_DataWriterEntityListener_OnAfterSetListenerCallback)(  
                                        DDS_DataWriter *writer,
                                        DDS_ReturnCode_t ret_retcode,
                                        void *return_param,
                                        void *param);

typedef struct DDS_DataWriterListener 
            (*DDS_DataWriterEntityListener_OnGetListenerCallback)(  
                                        DDS_DataWriter *writer,void *param);

typedef void* (*DDS_DataReaderEntityListener_OnBeforeCreateCallback)(
    DDS_Subscriber *subscriber,
	DDS_TopicDescription *topic,
	struct DDS_DataReaderQos *qos,
	struct DDS_DataReaderListener* listener,
	DDS_StatusMask *mask,
    DDS_ReturnCode_t *retcode,
	void *param);

typedef void (*DDS_DataReaderEntityListener_OnAfterCreateCallback)(
	DDS_DataReader *reader,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_DataReaderEntityListener_OnBeforeDeleteCallback)(
	DDS_Subscriber *subscriber,
	DDS_DataReader *reader,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_DataReaderEntityListener_OnAfterDeleteCallback)(
	DDS_Subscriber *subscriber,
	DDS_DataReader *reader,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_DataReaderEntityListener_OnBeforeSetQosCallback)(
	DDS_DataReader *reader,
	struct DDS_DataReaderQos* qos,
    DDS_ReturnCode_t *retcode,
	void *param);

typedef void (*DDS_DataReaderEntityListener_OnAfterSetQosCallback)(
	DDS_DataReader *reader,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_DataReaderEntityListener_OnBeforeSetListenerCallback)(
                                DDS_DataReader *reader,
                                struct DDS_DataReaderListener *listener,
                                DDS_StatusMask *mask,
                                DDS_ReturnCode_t *retcode,
                                void *param);

typedef void (*DDS_DataReaderEntityListener_OnAfterSetListenerCallback)(  
                                DDS_DataReader *reader,
                                DDS_ReturnCode_t ret_retcode,
                                void *return_param,
                                void *param);

typedef struct DDS_DataReaderListener 
            (*DDS_DataReaderEntityListener_OnGetListenerCallback)(  
                                            DDS_DataReader *reader,void *param);

typedef void* (*DDS_TopicEntityListener_OnBeforeCreateCallback)(
    DDS_DomainParticipant *participant,
	const char *topic_name,
	const char *type_name,
	struct DDS_TopicQos *qos,
	struct DDS_TopicListener* listener,
	DDS_StatusMask *mask,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_TopicEntityListener_OnAfterCreateCallback)(
	DDS_Topic *topic,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_TopicEntityListener_OnBeforeDeleteCallback)(
	DDS_DomainParticipant *participant,
	DDS_Topic *topic,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_TopicEntityListener_OnAfterDeleteCallback)(
	DDS_DomainParticipant *participant,
	DDS_Topic *topic,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_TopicEntityListener_OnBeforeSetQosCallback)(
	DDS_Topic *topic,
	struct DDS_TopicQos* qos,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_TopicEntityListener_OnAfterSetQosCallback)(
	DDS_Topic *topic,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

typedef void* (*DDS_TopicEntityListener_OnBeforeSetListenerCallback)(
                                    DDS_Topic *topic,
                                    struct DDS_TopicListener *listener,
                                    DDS_StatusMask *mask,
                                    DDS_ReturnCode_t *ret_retcode,
                                    void *param);

typedef void (*DDS_TopicEntityListener_OnAfterSetListenerCallback)(  
                                    DDS_Topic *topic,
                                    DDS_ReturnCode_t ret_retcode,
                                    void *return_param,
                                    void *param);

typedef struct DDS_TopicListener 
                            (*DDS_TopicEntityListener_OnGetListenerCallback)(  
                                                DDS_Topic *topic,void *param);

typedef void* (*DDS_EntityListener_OnBeforeEnableCallback)(
	DDS_Entity *self,
    DDS_ReturnCode_t *ret_retcode,
	void *param);

typedef void (*DDS_EntityListener_OnAfterEnableCallback)(
	DDS_Entity *self,
    DDS_ReturnCode_t ret_retcode,
	void *return_param,
	void *param);

struct DDS_DomainParticipantEntityListener {
    
    /*ci dref_DomainParticipantEntityListener_on_before_create
     */
    DDS_DomainParticipantEntityListener_OnBeforeCreateCallback 
	on_before_create;
    
    /*ci dref_DomainParticipantEntityListener_on_after_create
     */
    DDS_DomainParticipantEntityListener_OnAfterCreateCallback 
    on_after_create;
    
    /*ci dref_DomainParticipantEntityListener_on_before_delete
     */
    DDS_DomainParticipantEntityListener_OnBeforeDeleteCallback 
    on_before_delete;
    
    /*ci dref_DomainParticipantEntityListener_on_after_delete
     */
    DDS_DomainParticipantEntityListener_OnAfterDeleteCallback 
    on_after_delete;
    
    /*ci dref_DomainParticipantEntityListener_on_before_set_qos
     */
    DDS_DomainParticipantEntityListener_OnBeforeSetQosCallback 
    on_before_set_qos;
    
    /*ci dref_DomainParticipantEntityListener_on_after_set_qos
     */
    DDS_DomainParticipantEntityListener_OnAfterSetQosCallback 
    on_after_set_qos;
    
    /*ci dref_DomainParticipantEntityListener_on_before_delete_contained
     */
    DDS_DomainParticipantEntityListener_OnBeforeDeleteContainedCallback
    on_before_delete_contained;
    
    /*ci dref_DomainParticipantEntityListener_on_after_delete_contained
     */
    DDS_DomainParticipantEntityListener_OnAfterDeleteContainedCallback
    on_after_delete_contained;

    /*ci dref_DomainParticipantEntityListener_on_before_set_listener
     */
    DDS_DomainParticipantEntityListener_OnBeforeSetListenerCallback 
    on_before_set_listener;
    
    /*ci dref_DomainParticipantEntityListener_on_after_set_listener
     */
    DDS_DomainParticipantEntityListener_OnAfterSetListenerCallback 
    on_after_set_listener;    

    /*ci dref_DomainParticipantEntityListener_on_get_listener
     */
    DDS_DomainParticipantEntityListener_OnGetListenerCallback
    on_get_listener;    
};

struct DDS_TopicEntityListener {
    /*ci dref_TopicEntityListener_on_before_create
     */
    DDS_TopicEntityListener_OnBeforeCreateCallback 
	on_before_create;
    
    /*ci dref_TopicEntityListener_on_after_create
     */
    DDS_TopicEntityListener_OnAfterCreateCallback 
    on_after_create;
    
    /*ci dref_TopicEntityListener_on_before_delete
     */
    DDS_TopicEntityListener_OnBeforeDeleteCallback 
    on_before_delete;
    
    /*ci dref_TopicEntityListener_on_after_delete
     */
    DDS_TopicEntityListener_OnAfterDeleteCallback 
    on_after_delete;
    
    /*ci dref_TopicEntityListener_on_before_set_qos
     */
    DDS_TopicEntityListener_OnBeforeSetQosCallback 
    on_before_set_qos;
    
    /*ci dref_TopicEntityListener_on_after_set_qos
     */
    DDS_TopicEntityListener_OnAfterSetQosCallback 
    on_after_set_qos;    
    
    /*ci dref_TopicEntityListener_on_before_set_listener
     */
    DDS_TopicEntityListener_OnBeforeSetListenerCallback
    on_before_set_listener;
    
    /*ci dref_TopicEntityListener_on_after_set_listener
     */
    DDS_TopicEntityListener_OnAfterSetListenerCallback
    on_after_set_listener;    

    /*ci dref_TopicEntityListener_on_get_listener
     */
    DDS_TopicEntityListener_OnGetListenerCallback
    on_get_listener;        
};

struct DDS_PublisherEntityListener {
    /*ci dref_PublisherEntityListener_on_before_create
     */
    DDS_PublisherEntityListener_OnBeforeCreateCallback 
	on_before_create;
    
    /*ci dref_PublisherEntityListener_on_after_create
     */
    DDS_PublisherEntityListener_OnAfterCreateCallback 
    on_after_create;
    
    /*ci dref_PublisherEntityListener_on_before_delete
     */
    DDS_PublisherEntityListener_OnBeforeDeleteCallback 
    on_before_delete;
    
    /*ci dref_PublisherEntityListener_on_after_delete
     */
    DDS_PublisherEntityListener_OnAfterDeleteCallback 
    on_after_delete;
    
    /*ci dref_PublisherEntityListener_on_before_set_qos
     */
    DDS_PublisherEntityListener_OnBeforeSetQosCallback 
    on_before_set_qos;
    
    /*ci dref_PublisherEntityListener_on_after_set_qos
     */
    DDS_PublisherEntityListener_OnAfterSetQosCallback 
    on_after_set_qos;
    
    /*ci dref_PublisherEntityListener_on_before_delete_contained
     */
    DDS_PublisherEntityListener_OnBeforeDeleteContainedCallback
    on_before_delete_contained;
    
    /*ci dref_PublisherEntityListener_on_after_delete_contained
     */
    DDS_PublisherEntityListener_OnAfterDeleteContainedCallback
    on_after_delete_contained;   

    /*ci dref_PublisherEntityListener_on_before_set_listener
     */
    DDS_PublisherEntityListener_OnBeforeSetListenerCallback
    on_before_set_listener;
    
    /*ci dref_PublisherEntityListener_on_after_set_listener
     */
    DDS_PublisherEntityListener_OnAfterSetListenerCallback
    on_after_set_listener;        
    
    /*ci dref_PublisherEntityListener_on_get_listener
     */
    DDS_PublisherEntityListener_OnGetListenerCallback
    on_get_listener;        
};

struct DDS_SubscriberEntityListener {
    /*ci dref_SubscriberEntityListener_on_before_create
     */
    DDS_SubscriberEntityListener_OnBeforeCreateCallback 
	on_before_create;
    
    /*ci dref_SubscriberEntityListener_on_after_create
     */
    DDS_SubscriberEntityListener_OnAfterCreateCallback 
    on_after_create;
    
    /*ci dref_SubscriberEntityListener_on_before_delete
     */
    DDS_SubscriberEntityListener_OnBeforeDeleteCallback 
    on_before_delete;
    
    /*ci dref_SubscriberEntityListener_on_after_delete
     */
    DDS_SubscriberEntityListener_OnAfterDeleteCallback 
    on_after_delete;
    
    /*ci dref_SubscriberEntityListener_on_before_set_qos
     */
    DDS_SubscriberEntityListener_OnBeforeSetQosCallback 
    on_before_set_qos;
    
    /*ci dref_SubscriberEntityListener_on_after_set_qos
     */
    DDS_SubscriberEntityListener_OnAfterSetQosCallback 
    on_after_set_qos;
    
    /*ci dref_SubscriberEntityListener_on_before_delete_contained
     */
    DDS_SubscriberEntityListener_OnBeforeDeleteContainedCallback
    on_before_delete_contained;
    
    /*ci dref_SubscriberEntityListener_on_after_delete_contained
     */
    DDS_SubscriberEntityListener_OnAfterDeleteContainedCallback
    on_after_delete_contained;

    /*ci dref_SubscriberEntityListener_on_before_set_listener
     */
    DDS_SubscriberEntityListener_OnBeforeSetListenerCallback
    on_before_set_listener;
    
    /*ci dref_SubscriberEntityListener_on_after_set_listener
     */
    DDS_SubscriberEntityListener_OnAfterSetListenerCallback
    on_after_set_listener;  

    /*ci dref_SubscriberEntityListener_on_get_listener
     */
    DDS_SubscriberEntityListener_OnGetListenerCallback
    on_get_listener;            
};

struct DDS_DataReaderEntityListener {
    /*ci dref_DataReaderEntityListener_on_before_create
     */
    DDS_DataReaderEntityListener_OnBeforeCreateCallback 
	on_before_create;
    
    /*ci dref_DataReaderEntityListener_on_after_create
     */
    DDS_DataReaderEntityListener_OnAfterCreateCallback 
    on_after_create;
    
    /*ci dref_DataReaderEntityListener_on_before_delete
     */
    DDS_DataReaderEntityListener_OnBeforeDeleteCallback 
    on_before_delete;
    
    /*ci dref_DataReaderEntityListener_on_after_delete
     */
    DDS_DataReaderEntityListener_OnAfterDeleteCallback 
    on_after_delete;
    
    /*ci dref_DataReaderEntityListener_on_before_set_qos
     */
    DDS_DataReaderEntityListener_OnBeforeSetQosCallback 
    on_before_set_qos;
    
    /*ci dref_DataReaderEntityListener_on_after_set_qos
     */
    DDS_DataReaderEntityListener_OnAfterSetQosCallback 
    on_after_set_qos;
    
    /*ci dref_DataReaderEntityListener_on_before_set_listener
     */
    DDS_DataReaderEntityListener_OnBeforeSetListenerCallback
    on_before_set_listener;
    
    /*ci dref_DataReaderEntityListener_on_after_set_listener
     */
    DDS_DataReaderEntityListener_OnAfterSetListenerCallback
    on_after_set_listener;

    /*ci dref_DataReaderEntityListener_on_get_listener
     */
    DDS_DataReaderEntityListener_OnGetListenerCallback
    on_get_listener;        
};

struct DDS_DataWriterEntityListener {
    /*ci dref_DataWriterEntityListener_on_before_create
     */
    DDS_DataWriterEntityListener_OnBeforeCreateCallback 
	on_before_create;
    
    /*ci dref_DataWriterEntityListener_on_after_create;
     */
    DDS_DataWriterEntityListener_OnAfterCreateCallback 
    on_after_create;
    
    /*ci dref_DataWriterEntityListener_on_before_delete;
     */
    DDS_DataWriterEntityListener_OnBeforeDeleteCallback 
    on_before_delete;
    
    /*ci dref_DataWriterEntityListener_on_after_delete
     */
    DDS_DataWriterEntityListener_OnAfterDeleteCallback 
    on_after_delete;
    
    /*ci dref_DataWriterEntityListener_on_before_set_qos
     */
    DDS_DataWriterEntityListener_OnBeforeSetQosCallback 
    on_before_set_qos;
    
    /*ci dref_DataWriterEntityListener_on_after_set_qos
     */
    DDS_DataWriterEntityListener_OnAfterSetQosCallback 
    on_after_set_qos;    
    
    /*ci dref_DataWriterEntityListener_on_before_set_listener
     */
    DDS_DataWriterEntityListener_OnBeforeSetListenerCallback
    on_before_set_listener;

    /*ci dref_DataWriterEntityListener_on_after_set_listener
     */
    DDS_DataWriterEntityListener_OnAfterSetListenerCallback
    on_after_set_listener;
    
    /*ci dref_DataWriterEntityListener_on_get_listener
     */
    DDS_DataWriterEntityListener_OnGetListenerCallback
    on_get_listener;    
};

struct DDS_EntityListener {
    /*ci dref_EntityListener_on_before_enable
    */
    DDS_EntityListener_OnBeforeEnableCallback 
	on_before_enable;
    
    /*ci dref_EntityListener_on_after_enable
    */
    DDS_EntityListener_OnAfterEnableCallback 
    on_after_enable;    
};

struct DDS_DomainParticipantFactoryEntityListener {
    /*ci dref_DomainParticipantFactoryEntityListener_participant
     */    
    struct DDS_DomainParticipantEntityListener participant;
    /*ci dref_DomainParticipantFactoryEntityListener_publisher
     */
    struct DDS_PublisherEntityListener publisher;
    /*ci dref_DomainParticipantFactoryEntityListener_subscriber
     */
    struct DDS_SubscriberEntityListener subscriber;
    /*ci dref_DomainParticipantFactoryEntityListener_datawriter
     */
    struct DDS_DataWriterEntityListener datawriter;
    /*ci dref_DomainParticipantFactoryEntityListener_datareader
        */
    struct DDS_DataReaderEntityListener datareader;    
    /*ci dref_DomainParticipantFactoryEntityListener_topic
     */
    struct DDS_TopicEntityListener topic;
    /*ci dref_DomainParticipantFactoryEntityListener_entity
     */
    struct DDS_EntityListener entity;
    /*ci dref_DomainParticipantFactoryEntityListener_param
     */
    void *param;
};


#define DDS_DomainParticipantFactoryEntityListener_INITIALIZER \
{ {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL},/* Participant */\
  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL},/* Publisher   */\
  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL},/* Subscriber  */\
  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL}, /* DataWriter  */\
  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL}, /* DataReader  */\
  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL}, /* Topic       */\
  {NULL, NULL},                         /* Entity      */\
  NULL                                  /* param       */\
}


/* This property is used by the RTI Services to send the service version.
 * Although in most cases, the service version will be equal to the 
 * core Library version that is not necessarily the case when shipping
 * patches */
#define DDS_SERVICE_VERSION_PROPERTY_NAME "rti.service.version"

#define DDS_DOMAIN_PARTICIPANT_MAX_LOCATOR_LIST_SIZE_PROPERTY \
    PROPERTY_NAME_DDS_DOMAIN_PARTICIPANT_MAX_ANNOUNCED_LOCATOR_LIST_SIZE

#define DDS_DOMAIN_PARTICIPANT_ASYNCHRONOUS_PUBLISHER_THREAD_DESTRUCTION_TIMEOUT_PROPERTY \
    PROPERTY_NAME_DDS_DOMAIN_PARTICIPANT_ASYNCHRONOUS_PUBLISHER_THREAD_DESTRUCTION_TIMEOUT

#define DDS_DOMAIN_PARTICIPANT_MAX_LOCATOR_LIST_SIZE_DEFAULT \
    (PRES_PARTICIPANT_IPADDRESS_COUNT_MAX)

/* Assert Period */
#define DDS_DOMAIN_PARTICIPANT_LOCATOR_REACHABILTY_ASSERT_PERIOD_DEFAULT \
    PRES_LOCATOR_PING_CHANNEL_ASSERT_REACHABILITY_PERIOD_DEFAULT
    
/* Lease duration */
#define DDS_DOMAIN_PARTICIPANT_LOCATOR_REACHABILTY_LEASE_DURATION_DEFAULT \
    DDS_DURATION_INFINITE_VALUE
    
/* Change detection period */
#define DDS_DOMAIN_PARTICIPANT_LOCATOR_REACHABILTY_CHANGE_DETECTION_PERIOD_DEFAULT \
    PRES_LOCATOR_PING_CHANNEL_CHANGE_DETECTION_PERIOD_DEFAULT
    

struct DDS_DomainParticipantQos;

extern DDSCDllExport DDS_Boolean DDS_DomainParticipantQos_equals(
   const struct DDS_DomainParticipantQos *self,
   const struct DDS_DomainParticipantQos *other);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantQos_print(
        const struct DDS_DomainParticipantQos *self);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantQos_to_string(
        const struct DDS_DomainParticipantQos *self,
        char *string,
        DDS_UnsignedLong *string_size);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantQos_to_string_w_params(
        const struct DDS_DomainParticipantQos *self,
        char *string,
        DDS_UnsignedLong *string_size,
        const struct DDS_DomainParticipantQos *base,
        const struct DDS_QosPrintFormat *format);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipantQos_initialize(
        struct DDS_DomainParticipantQos *self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipantQos_finalize(
    struct DDS_DomainParticipantQos *self);

struct DDS_DomainParticipantQos {

    /*e \dref_DomainParticipantQos_user_data
     */
    struct DDS_UserDataQosPolicy  user_data;

    /*e \dref_DomainParticipantQos_entity_factory
     */
    struct DDS_EntityFactoryQosPolicy  entity_factory;

    /* -------------------------------------------------------------- */
    
    /*e \dref_DomainParticipantQos_wire_protocol
    */
    struct DDS_WireProtocolQosPolicy wire_protocol;
               
    /*e \dref_DomainParticipantQos_transport_builtin
    */     
    struct DDS_TransportBuiltinQosPolicy transport_builtin; 

    /*e \dref_DomainParticipantQos_default_unicast
    */     
    struct DDS_TransportUnicastQosPolicy default_unicast; 
    
    /*e \dref_DomainParticipantQos_discovery
     */    
    struct DDS_DiscoveryQosPolicy discovery;   
    
    /*e \dref_DomainParticipantQos_resource_limits
     */    
    struct DDS_DomainParticipantResourceLimitsQosPolicy resource_limits;

    /*e \dref_DomainParticipantQos_event
     */    
    struct DDS_EventQosPolicy event;

    /*e \dref_DomainParticipantQos_receiver_pool
     */    
    struct DDS_ReceiverPoolQosPolicy receiver_pool;

    /*e \dref_DomainParticipantQos_database
     */    
    struct DDS_DatabaseQosPolicy database;

    /*e \dref_DomainParticipantQos_discovery_config
     */    
    struct DDS_DiscoveryConfigQosPolicy discovery_config;
    
    /*i \dref_DomainParticipantQos_exclusive_area
     */
    struct DDS_ExclusiveAreaQosPolicy exclusive_area;
    
    /*e \dref_DomainParticipantQos_property
     */
    struct DDS_PropertyQosPolicy property;

    /*e \dref_DomainParticipantQos_participant_name
     */
    struct DDS_EntityNameQosPolicy participant_name;

    /*e \dref_DomainParticipantQos_multicast_mapping
     */
    struct DDS_TransportMulticastMappingQosPolicy multicast_mapping;

    /*e \dref_DomainParticipantQos_service
     */
    struct DDS_ServiceQosPolicy service;

    /*e \dref_DomainParticipantQos_partition
     */    
    struct DDS_PartitionQosPolicy partition;

    /* ========================================== */
    /* leave type_support and user_object at last */
    /* ========================================== */

    /*i \dref_DomainParticipantQos_user_object
     */
    struct DDS_UserObjectQosPolicy user_object;

    /*i \dref_DomainParticipantProtocolQosPolicy
     */
    struct DDS_DomainParticipantProtocolQosPolicy protocol;

    /*i type_support has to be the last field */

    /*e \dref_DomainParticipantQos_type_support
     */
    struct DDS_TypeSupportQosPolicy type_support;

#ifdef RTI_CPP
    /*e 
      @brief Compares two DomainParticipantQos objects for inequality
      @see DDS_DomainParticipantQos_equals
    */ 
    inline bool operator==(const DDS_DomainParticipantQos& r) const {
        if (DDS_DomainParticipantQos_equals(this, &r)) {
            return true;
        }

        return false;
    };

    /*e 
      @brief Compares two DomainParticipantQos objects for inequality
      @see DDS_DomainParticipantQos_equals
    */ 
    inline bool operator!=(const DDS_DomainParticipantQos& r) const {
        if (DDS_DomainParticipantQos_equals(this, &r)) {
            return false;
        }

        return true;
    };

    /*e \dref_DomainParticipantQos_print */
    DDS_ReturnCode_t print() const {
        return DDS_DomainParticipantQos_print(this);
    }

    /*e \dref_DomainParticipantQos_to_string */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size) const {
        return DDS_DomainParticipantQos_to_string(this, string, &string_size);
    }

    /*e \dref_DomainParticipantQos_to_string_w_base */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_DomainParticipantQos& base) const {
        const DDS_QosPrintFormat format = DDS_QosPrintFormat_INITIALIZER;
        return DDS_DomainParticipantQos_to_string_w_params(
                this,
                string,
                &string_size,
                &base,
                &format);
    }

    /*e \dref_DomainParticipantQos_to_string_w_format */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_QosPrintFormat& format) const {
        DDS_ReturnCode_t retcode = DDS_RETCODE_ERROR;
        DDS_DomainParticipantQos base;
        retcode = DDS_DomainParticipantQos_initialize(&base);
        if (retcode != DDS_RETCODE_OK) {
            return retcode;
        }
        retcode = DDS_DomainParticipantQos_to_string_w_params(
                this,
                string,
                &string_size,
                &base,
                &format);
        DDS_DomainParticipantQos_finalize(&base);
        return retcode;
    }

    /*e \dref_DomainParticipantQos_to_string_w_params */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_DomainParticipantQos& base,
            const DDS_QosPrintFormat& format) const {
        return DDS_DomainParticipantQos_to_string_w_params(
                this,
                string,
                &string_size,
                &base,
                &format);
    }

    /*e \dref_DomainParticipantQos_to_string_w_print_all */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_QosPrintAll_t&) const {
        const DDS_QosPrintFormat format = DDS_QosPrintFormat_INITIALIZER;
        return DDS_DomainParticipantQos_to_string_w_params(
                this,
                string,
                &string_size,
                DDS_DOMAINPARTICIPANT_QOS_PRINT_ALL,
                &format);
    }

    /*e \dref_DomainParticipantQos_to_string_w_format_print_all */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_QosPrintAll_t&,
            const DDS_QosPrintFormat& format) const {
        return DDS_DomainParticipantQos_to_string_w_params(
                this,
                string,
                &string_size,
                DDS_DOMAINPARTICIPANT_QOS_PRINT_ALL,
                &format);
    }
#endif
};


#define DDS_DomainParticipantQos_INITIALIZER                  	\
{ DDS_USER_DATA_QOS_POLICY_DEFAULT,                           	\
  DDS_ENTITY_FACTORY_QOS_POLICY_DEFAULT,                      	\
  DDS_WIRE_PROTOCOL_QOS_POLICY_DEFAULT,                     	\
  DDS_TRANSPORT_BUILTIN_QOS_POLICY_DEFAULT,                 	\
  DDS_TRANSPORT_UNICAST_QOS_POLICY_DEFAULT,                 	\
  DDS_DISCOVERY_QOS_POLICY_DEFAULT,                         	\
  DDS_DOMAIN_PARTICIPANT_RESOURCE_LIMITS_QOS_POLICY_DEFAULT,	\
  DDS_EVENT_QOS_POLICY_DEFAULT,                             	\
  DDS_RECEIVER_POOL_QOS_POLICY_DEFAULT,                     	\
  DDS_DATABASE_QOS_POLICY_DEFAULT,                          	\
  DDS_DISCOVERY_CONFIG_QOS_POLICY_DEFAULT,                  	\
  DDS_EXCLUSIVE_AREA_QOS_POLICY_DEFAULT,                    	\
  DDS_PROPERTY_QOS_POLICY_DEFAULT,                          	\
  DDS_ENTITY_NAME_QOS_POLICY_DEFAULT,                       	\
  DDS_TRANSPORT_MULTICAST_MAPPING_QOS_POLICY_DEFAULT,           \
  DDS_SERVICE_QOS_POLICY_DEFAULT,                               \
  DDS_PARTITION_QOS_POLICY_DEFAULT,                             \
  DDS_USER_OBJECT_QOS_POLICY_DEFAULT,                       	\
  DDS_DOMAIN_PARTICIPANT_PROTOCOL_QOS_POLICY_DEFAULT,	        \
  DDS_TYPESUPPORT_QOS_POLICY_DEFAULT                      	    \
}

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipantQos_initialize(
        struct DDS_DomainParticipantQos *self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipantQos_finalize(
    struct DDS_DomainParticipantQos *self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipantQos_copy(
    struct DDS_DomainParticipantQos *self,
    const struct DDS_DomainParticipantQos *source);

extern DDSCDllExport
void DDS_DomainParticipantQos_save(
        const struct DDS_DomainParticipantQos* self, 
        const struct DDS_DomainParticipantQos* base, 
        const char *name,
        struct RTIXMLSaveContext* dst,
        const struct DDS_QosPrintFormat *format);

extern DDSCDllExport
DDS_Boolean DDS_DomainParticipantQos_is_security_enabled(
        const struct DDS_DomainParticipantQos *self);

struct DDS_DomainParticipantFactoryQos;

extern DDSCDllExport DDS_Boolean DDS_DomainParticipantFactoryQos_equals(
    const struct DDS_DomainParticipantFactoryQos *self,
    const struct DDS_DomainParticipantFactoryQos *other);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantFactoryQos_print(
        const struct DDS_DomainParticipantFactoryQos *self);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantFactoryQos_to_string(
        const struct DDS_DomainParticipantFactoryQos *self,
        char *string,
        DDS_UnsignedLong *string_size);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantFactoryQos_to_string_w_params(
        const struct DDS_DomainParticipantFactoryQos *self,
        char *string,
        DDS_UnsignedLong *string_size,
        const struct DDS_DomainParticipantFactoryQos *base,
        const struct DDS_QosPrintFormat *format);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_DomainParticipantFactoryQos_initialize(
        struct DDS_DomainParticipantFactoryQos *self);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_DomainParticipantFactoryQos_finalize(
        struct DDS_DomainParticipantFactoryQos *self);

struct DDS_DomainParticipantFactoryQos {

    /*e \dref_DomainParticipantFactoryQos_entity_factory
     */
    struct DDS_EntityFactoryQosPolicy  entity_factory;

    /*e \dref_DomainParticipantFactoryQos_resource_limits
     */
    struct DDS_SystemResourceLimitsQosPolicy  resource_limits;    

    /*e \dref_DomainParticipantFactoryQos_profile
    */
    struct DDS_ProfileQosPolicy profile;

    /*e \dref_DomainParticipantFactoryQos_logging
    */
    struct DDS_LoggingQosPolicy logging;

    /*e \dref_DomainParticipantFactoryQos_monitoring
    */
    struct DDS_MonitoringQosPolicy monitoring;

#ifdef RTI_CPP
    /*e 
      @brief Compares two DomainParticipantFactoryQos objects for equality
      @see DDS_DomainParticipantFactoryQos_equals
    */ 
    inline bool operator==(const DDS_DomainParticipantFactoryQos& r) const {
        if (DDS_DomainParticipantFactoryQos_equals(this, &r)) {
            return true;
        }

        return false;
    };

    /*e 
      @brief Compares two DomainParticipantFactoryQos objects for inequality
      @see DDS_DomainParticipantFactoryQos_equals
    */ 
    inline bool operator!=(const DDS_DomainParticipantFactoryQos& r) const {
        if (DDS_DomainParticipantFactoryQos_equals(this, &r)) {
            return false;
        }

        return true;
    };

    /*e \dref_DomainParticipantFactoryQos_print */
    DDS_ReturnCode_t print() const {
        return DDS_DomainParticipantFactoryQos_print(this);
    }

    /*e \dref_DomainParticipantFactoryQos_to_string */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size) const {
        return DDS_DomainParticipantFactoryQos_to_string(this, string, &string_size);
    }


    /*e \dref_DomainParticipantFactoryQos_to_string_w_base */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_DomainParticipantFactoryQos& base) const {
        const DDS_QosPrintFormat format = DDS_QosPrintFormat_INITIALIZER;
        return DDS_DomainParticipantFactoryQos_to_string_w_params(
                this,
                string,
                &string_size,
                &base,
                &format);
    }

    /*e \dref_DomainParticipantFactoryQos_to_string_w_format */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_QosPrintFormat& format) const {
        DDS_ReturnCode_t retcode = DDS_RETCODE_ERROR;
        DDS_DomainParticipantFactoryQos base;
        retcode = DDS_DomainParticipantFactoryQos_initialize(&base);
        if (retcode != DDS_RETCODE_OK) {
            return retcode;
        }
        retcode = DDS_DomainParticipantFactoryQos_to_string_w_params(
                this,
                string,
                &string_size,
                &base,
                &format);
        DDS_DomainParticipantFactoryQos_finalize(&base);
        return retcode;
    }

    /*e \dref_DomainParticipantFactoryQos_to_string_w_params */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_DomainParticipantFactoryQos& base,
            const DDS_QosPrintFormat& format) const {
        return DDS_DomainParticipantFactoryQos_to_string_w_params(
                this,
                string,
                &string_size,
                &base,
                &format);
    }

    /*e \dref_DomainParticipantFactoryQos_to_string_w_print_all */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_QosPrintAll_t&) const {
        const DDS_QosPrintFormat format = DDS_QosPrintFormat_INITIALIZER;
        return DDS_DomainParticipantFactoryQos_to_string_w_params(
                this,
                string,
                &string_size,
                DDS_DOMAINPARTICIPANTFACTORY_QOS_PRINT_ALL,
                &format);
    }

    /*e \dref_DomainParticipantFactoryQos_to_string_w_format_print_all */
    DDS_ReturnCode_t to_string(
            char *string,
            DDS_UnsignedLong& string_size,
            const DDS_QosPrintAll_t&,
            const DDS_QosPrintFormat& format) const {
        return DDS_DomainParticipantFactoryQos_to_string_w_params(
                this,
                string,
                &string_size,
                DDS_DOMAINPARTICIPANTFACTORY_QOS_PRINT_ALL,
                &format);
    }
#endif
};

extern DDSCDllExport 
DDS_ReturnCode_t DDS_DomainParticipantFactoryQos_initialize(
        struct DDS_DomainParticipantFactoryQos *self);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_DomainParticipantFactoryQos_finalize(
        struct DDS_DomainParticipantFactoryQos *self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipantFactoryQos_copy(
    struct DDS_DomainParticipantFactoryQos *self,
    const struct DDS_DomainParticipantFactoryQos *source);

extern DDSCDllExport
void DDS_DomainParticipantFactoryQos_save(
        const struct DDS_DomainParticipantFactoryQos *self,
        const struct DDS_DomainParticipantFactoryQos *base,
        const char *name,
        struct RTIXMLSaveContext *dst,
        const struct DDS_QosPrintFormat *format);


#define DDS_DomainParticipantFactoryQos_INITIALIZER { \
    DDS_ENTITY_FACTORY_QOS_POLICY_DEFAULT, \
    DDS_SYSTEM_RESOURCE_LIMITS_QOS_POLICY_DEFAULT, \
    DDS_PROFILE_QOS_POLICY_DEFAULT, \
    DDS_LOGGING_QOS_POLICY_DEFAULT, \
    DDS_MonitoringQosPolicy_INITIALIZER}

 extern DDSCDllVariable const struct DDS_TopicQos
DDS_TOPIC_QOS_DEFAULT;

 extern DDSCDllVariable const struct DDS_PublisherQos
DDS_PUBLISHER_QOS_DEFAULT;

 extern DDSCDllVariable const struct DDS_SubscriberQos 
DDS_SUBSCRIBER_QOS_DEFAULT;

 extern DDSCDllVariable const struct DDS_DomainParticipantFactoryQos 
DDS_DOMAINPARTICIPANTFACTORY_QOS_DEFAULT;

 extern DDSCDllVariable const struct DDS_FlowControllerProperty_t
DDS_FLOW_CONTROLLER_PROPERTY_DEFAULT;


#define DDS_DomainParticipant_as_entity(domainPtr) \
            ((DDS_Entity *) (domainPtr))

struct DDS_DomainParticipantProtocolStatus {
    /*e \dref_DomainParticipantProtocolStatus_corrupted_rtps_message_count
     */
    DDS_LongLong corrupted_rtps_message_count;
    /*e \dref_DomainParticipantProtocolStatus_corrupted_rtps_message_count_change
     */
    DDS_LongLong corrupted_rtps_message_count_change;
    /*e \dref_DomainParticipantProtocolStatus_last_corrupted_message_timestamp
     */
    struct DDS_Time_t last_corrupted_message_timestamp;
};


#define DDS_DomainParticipantProtocolStatus_INITIALIZER    \
{ 0, /* corrupted_rtps_message_count */                    \
  0, /* corrupted_rtps_message_count_change */             \
  DDS_TIME_INVALID_VALUE /* last_corrupted_message_timestamp */            \
}

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantProtocolStatus_initialize(
    struct DDS_DomainParticipantProtocolStatus *self);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantProtocolStatus_copy(
    struct DDS_DomainParticipantProtocolStatus *self,
    const struct DDS_DomainParticipantProtocolStatus *source);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantProtocolStatus_finalize(
    struct DDS_DomainParticipantProtocolStatus *self);

extern DDSCDllExport DDS_Boolean DDS_DomainParticipantProtocolStatus_equals(
        const struct DDS_DomainParticipantProtocolStatus *left,
        const struct DDS_DomainParticipantProtocolStatus *right);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_topic_qos(
    DDS_DomainParticipant* self, struct DDS_TopicQos* qos);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_topic_qos_w_topic_name(
    DDS_DomainParticipant* self, 
    struct DDS_TopicQos* qos, 
    const char *topic_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_topic_qos(
    DDS_DomainParticipant* self, const struct DDS_TopicQos* qos);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_topic_qos_with_profile(
    DDS_DomainParticipant* self, 
    const char *library_name, const char * profile_name);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_publisher_qos(
    DDS_DomainParticipant* self, struct DDS_PublisherQos* qos);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_publisher_qos(
    DDS_DomainParticipant* self, const struct DDS_PublisherQos* qos);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_publisher_qos_with_profile(
    DDS_DomainParticipant* self, 
    const char *library_name, const char * profile_name);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_datawriter_qos(
    DDS_DomainParticipant* self, struct DDS_DataWriterQos* qos);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_datawriter_qos_w_topic_name(
    DDS_DomainParticipant* self, 
    struct DDS_DataWriterQos* qos,
    const char* topic_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_datawriter_qos(
    DDS_DomainParticipant* self, const struct DDS_DataWriterQos* qos);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_datawriter_qos_with_profile(
    DDS_DomainParticipant* self, 
    const char *library_name, const char * profile_name);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_subscriber_qos(
    DDS_DomainParticipant* self, struct DDS_SubscriberQos* qos);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_subscriber_qos(
    DDS_DomainParticipant* self, const struct DDS_SubscriberQos* qos);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_subscriber_qos_with_profile(
    DDS_DomainParticipant* self, 
    const char *library_name, const char * profile_name);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_datareader_qos(
    DDS_DomainParticipant* self, struct DDS_DataReaderQos* qos);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_datareader_qos_w_topic_name(
    DDS_DomainParticipant* self, 
    struct DDS_DataReaderQos* qos,
    const char* topic_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_datareader_qos(
    DDS_DomainParticipant* self, const struct DDS_DataReaderQos* qos);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_set_default_datareader_qos_with_profile(
    DDS_DomainParticipant* self, 
    const char *library_name, const char * profile_name);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_default_flowcontroller_property(
    DDS_DomainParticipant* self, struct DDS_FlowControllerProperty_t *prop);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_set_default_flowcontroller_property(
    DDS_DomainParticipant* self, const struct DDS_FlowControllerProperty_t *prop);

extern DDSCDllExport
const char * DDS_DomainParticipant_get_default_library(
                DDS_DomainParticipant *self);

extern DDSCDllExport
const char * DDS_DomainParticipant_get_default_profile(
                DDS_DomainParticipant *self);

extern DDSCDllExport
const char * DDS_DomainParticipant_get_default_profile_library(
                DDS_DomainParticipant *self);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_set_default_library(
                DDS_DomainParticipant *self,
                const char * library_name);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_set_default_profile(
                DDS_DomainParticipant *self,const char *library_name,
                const char* profile_name);

extern DDSCDllExport DDS_Publisher* DDS_DomainParticipant_create_publisher(
    DDS_DomainParticipant* self,
    const struct DDS_PublisherQos* qos, 
    const struct DDS_PublisherListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_Publisher* DDS_DomainParticipant_create_publisher_with_profile(
    DDS_DomainParticipant* self,
    const char* library_name, 
    const char* profile_name, 
    const struct DDS_PublisherListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_create_publishers_from_config(
    DDS_DomainParticipant * self,
    struct DDS_PublisherSeq * publishers,
    const char * configuration_name);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_delete_publisher(
    DDS_DomainParticipant* self, DDS_Publisher* p);

extern DDSCDllExport DDS_Subscriber* DDS_DomainParticipant_create_subscriber(
    DDS_DomainParticipant* self,
    const struct DDS_SubscriberQos* qos,
    const struct DDS_SubscriberListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_Subscriber* DDS_DomainParticipant_create_subscriber_with_profile(
        DDS_DomainParticipant* self,
        const char *library_name,
        const char *profile_name,
        const struct DDS_SubscriberListener* listener,
        DDS_StatusMask mask);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_create_subscribers_from_config(
    DDS_DomainParticipant * self,
    struct DDS_SubscriberSeq * subscribers,
    const char * configuration_name);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_delete_subscriber(
    DDS_DomainParticipant* self, DDS_Subscriber* s);

extern DDSCDllExport DDS_DataWriter* DDS_DomainParticipant_create_datawriter(
    DDS_DomainParticipant* self,
    DDS_Topic* topic, const struct DDS_DataWriterQos* qos,
    const struct DDS_DataWriterListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_DataWriter* DDS_DomainParticipant_create_datawriter_with_profile(
    DDS_DomainParticipant* self,
    DDS_Topic* topic, const char *library_name,const char* profile_name,
    const struct DDS_DataWriterListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_create_datawriters_from_config(
    DDS_DomainParticipant * self,
    struct DDS_DataWriterSeq * writers,
    const char * configuration_name);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_delete_datawriter(
    DDS_DomainParticipant* self, DDS_DataWriter * a_datawriter);

extern DDSCDllExport DDS_DataReader* DDS_DomainParticipant_create_datareader(
    DDS_DomainParticipant* self,
    DDS_TopicDescription* topic, 
    const struct DDS_DataReaderQos* qos,
    const struct DDS_DataReaderListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_DataReader* DDS_DomainParticipant_create_datareader_with_profile(
    DDS_DomainParticipant* self,
    DDS_TopicDescription* topic, 
    const char *library_name,
    const char* profile_name,
    const struct DDS_DataReaderListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_create_datareaders_from_config(
    DDS_DomainParticipant * self,
    struct DDS_DataReaderSeq * readers,
    const char * configuration_name);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_delete_datareader(
    DDS_DomainParticipant* self, DDS_DataReader * a_datareader);

extern DDSCDllExport DDS_Topic* DDS_DomainParticipant_create_topic(
    DDS_DomainParticipant* self, const char* topic_name, 
    const char* type_name, const struct DDS_TopicQos* qos, 
    const struct DDS_TopicListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_Topic* DDS_DomainParticipant_create_topic_with_profile(
    DDS_DomainParticipant* self, const char* topic_name, 
    const char* type_name, 
    const char* library_name,
    const char* profile_name, 
    const struct DDS_TopicListener* listener,
    DDS_StatusMask mask);

extern DDSCDllExport DDS_Topic * DDS_DomainParticipant_create_topic_from_config(
    DDS_DomainParticipant * self,
    const char * configuration_name);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_delete_topic(
    DDS_DomainParticipant* self, DDS_Topic* topic);

extern DDSCDllExport DDS_ContentFilteredTopic* DDS_DomainParticipant_create_contentfilteredtopic(
        DDS_DomainParticipant* self, const char* name,
        DDS_Topic* related_topic, const char* filter_expression, 
        const struct DDS_StringSeq* expression_parameters);

extern DDSCDllExport DDS_ContentFilteredTopic* DDS_DomainParticipant_create_contentfilteredtopic_with_filter(
        DDS_DomainParticipant* self, const char* name,
        const DDS_Topic* related_topic, const char* filter_expression, 
        const struct DDS_StringSeq* expression_parameters,const char* filter_name);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_delete_contentfilteredtopic(
    DDS_DomainParticipant* self,
    DDS_ContentFilteredTopic* a_contentfilteredtopic);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_register_contentfilter(
    DDS_DomainParticipant* self,
    const char *filter_name,
    const struct DDS_ContentFilter *contentfilter);

extern DDSCDllExport void* DDS_DomainParticipant_lookup_contentfilter(
    DDS_DomainParticipant* self,
    const char *filter_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_registered_contentfilters(
    DDS_DomainParticipant* self,
    struct DDS_StringSeq* filter_names);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_unregister_contentfilter(
    DDS_DomainParticipant* self,
    const char *filter_name);

extern DDSCDllExport DDS_MultiTopic* DDS_DomainParticipant_create_multitopic(
    DDS_DomainParticipant* self, const char* name,
    const char* type_name, const char* subscription_expression, 
    const struct DDS_StringSeq* expression_parameters);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_delete_multitopic(
    DDS_DomainParticipant* self, DDS_MultiTopic* a_multitopic);

extern DDSCDllExport
DDS_FlowController *DDS_DomainParticipant_create_flowcontroller(
    DDS_DomainParticipant* self, const char *name,
    const struct DDS_FlowControllerProperty_t *prop);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_delete_flowcontroller(
    DDS_DomainParticipant* self, DDS_FlowController *fc);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_register_type(
    DDS_DomainParticipant* self, 
    const char *type_name, 
    const struct PRESTypePlugin *type_plugin,
    void *registration_data);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_unregister_type(
    DDS_DomainParticipant* self, 
    const char *type_name);

extern DDSCDllExport 
const DDS_TypeCode * DDS_DomainParticipant_get_typecode(
    DDS_DomainParticipant * self, 
    const char * type_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_get_topics(
    DDS_DomainParticipant* self,
    struct DDS_TopicSeq* topics);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_contentfilteredtopics(
    DDS_DomainParticipant* self,
    struct DDS_ContentFilteredTopicSeq* content_filtered_topics);

extern DDSCDllExport struct PRESTypePlugin *
DDS_DomainParticipant_get_type_pluginI(
    DDS_DomainParticipant *self,
    const char* type_name);

extern DDSCDllExport DDS_Topic* DDS_DomainParticipant_find_topic(
    DDS_DomainParticipant* self, const char* topic_name,
    const struct DDS_Duration_t* timeout);

extern DDSCDllExport DDS_Topic* DDS_DomainParticipant_find_topic_w_type_name(
    DDS_DomainParticipant* self, 
    const char* topic_name,
    const char* type_name,
    const struct DDS_Duration_t* timeout);

extern DDSCDllExport DDS_TopicDescription*
DDS_DomainParticipant_lookup_topicdescription(
    DDS_DomainParticipant* self, const char* topic_name);

extern DDSCDllExport DDS_Entity*
DDS_DomainParticipant_lookup_entity(
    DDS_DomainParticipant* self, DDS_BuiltinTopicKey_t *key);

extern DDSCDllExport
DDS_FlowController *DDS_DomainParticipant_lookup_flowcontroller(
    DDS_DomainParticipant* self, const char *name);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_flowcontrollers(
    DDS_DomainParticipant* self,
    struct DDS_FlowControllerSeq* flow_controllers);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_participant_protocol_status(
    DDS_DomainParticipant *self,
    struct DDS_DomainParticipantProtocolStatus *status);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_participant_protocol_status_ex(
    DDS_DomainParticipant *self,
    struct DDS_DomainParticipantProtocolStatus *status,
    DDS_Boolean clear_change);

extern DDSCDllExport DDS_Subscriber* 
DDS_DomainParticipant_get_builtin_subscriber(
    DDS_DomainParticipant* self);

extern DDSCDllExport DDS_Publisher* 
DDS_DomainParticipant_get_builtin_publisher(
    DDS_DomainParticipant* self);

extern DDSCDllExport DDS_Publisher*
DDS_DomainParticipant_get_implicit_publisher(DDS_DomainParticipant* self);

extern DDSCDllExport DDS_Subscriber*
DDS_DomainParticipant_get_implicit_subscriber(DDS_DomainParticipant* self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_ignore_participant(
    DDS_DomainParticipant* self, const DDS_InstanceHandle_t* handle);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_ignore_topic(
    DDS_DomainParticipant* self, const DDS_InstanceHandle_t* handle);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_ignore_publication(
    DDS_DomainParticipant* self, const DDS_InstanceHandle_t* handle);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_ignore_subscription(
    DDS_DomainParticipant* self, const DDS_InstanceHandle_t* handle);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_banish_ignored_participants(
        DDS_DomainParticipant *self);

extern DDSCDllExport DDS_DomainId_t DDS_DomainParticipant_get_domain_id(
    DDS_DomainParticipant* self);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_delete_contained_entities(
    DDS_DomainParticipant* self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_assert_liveliness(
    DDS_DomainParticipant* self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_get_publishers(
    DDS_DomainParticipant* self,
    struct DDS_PublisherSeq* publishers);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_get_subscribers(
    DDS_DomainParticipant* self,
    struct DDS_SubscriberSeq* subscribers);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_get_current_time(
    DDS_DomainParticipant* self,
    struct DDS_Time_t* current_time);

extern DDSCDllExport DDS_Boolean
DDS_DomainParticipant_contains_entity(
    DDS_DomainParticipant* self,
    const DDS_InstanceHandle_t* a_handle);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_builtin_topic_key(const DDS_DomainParticipant* self,
                                            DDS_BuiltinTopicKey_t *key);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_register_durable_subscription(
    DDS_DomainParticipant* self,
    const struct DDS_EndpointGroup_t *group,
    const char *topic_name);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_delete_durable_subscription(
    DDS_DomainParticipant* self,
    const struct DDS_EndpointGroup_t *group);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_DomainParticipant_resume_endpoint_discovery(
    DDS_DomainParticipant * self,
    const DDS_InstanceHandle_t * remote_participant_handle);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_set_dns_tracker_polling_period(
        DDS_DomainParticipant *self,
        const struct DDS_Duration_t *polling_period);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_get_dns_tracker_polling_period(
        DDS_DomainParticipant *self,
        struct DDS_Duration_t *polling_period);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_discovered_participants(
    DDS_DomainParticipant* self,
    struct DDS_InstanceHandleSeq* participant_handles);

extern DDSCDllExport 
DDS_ReturnCode_t
DDS_DomainParticipant_get_discovered_participants_from_subject_name(
        DDS_DomainParticipant *self,
        struct DDS_InstanceHandleSeq *participant_handles,
        const char *subject_name);

struct DDS_ParticipantBuiltinTopicData;

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_discovered_participant_data(
    DDS_DomainParticipant* self,
    struct DDS_ParticipantBuiltinTopicData* participant_data,
    const DDS_InstanceHandle_t* participant_handle);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_DomainParticipant_get_discovered_participant_subject_name(
        DDS_DomainParticipant *self,
        char *subject_name,
        DDS_UnsignedLong *subject_name_size,
        const DDS_InstanceHandle_t *participant_handle);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_discovered_topics(
    DDS_DomainParticipant* self,
    struct DDS_InstanceHandleSeq* topic_handles);

struct DDS_TopicBuiltinTopicData;

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_discovered_topic_data(
    DDS_DomainParticipant* self,
    struct DDS_TopicBuiltinTopicData* topic_data,
    const DDS_InstanceHandle_t* topic_handle);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_take_discovery_snapshot(
        DDS_DomainParticipant *self,
        const char *file_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_publications(
    DDS_DomainParticipant* self,
    struct DDS_InstanceHandleSeq* publication_handles,
    DDS_Boolean include_contained_entities);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_publication_data(
    DDS_DomainParticipant* self,
    struct DDS_PublicationBuiltinTopicData* publication_data,
    const DDS_InstanceHandle_t* publication_handle);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_subscriptions(
    DDS_DomainParticipant* self,
    struct DDS_InstanceHandleSeq* subscription_handles,
    DDS_Boolean include_contained_entities);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipant_get_subscription_data(
    DDS_DomainParticipant* self,
    struct DDS_SubscriptionBuiltinTopicData* subscription_data,
    const DDS_InstanceHandle_t* subscription_handle);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_add_peer(
    DDS_DomainParticipant* self, const char* peer_desc_string);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_remove_peer(
    DDS_DomainParticipant* self, const char* peer_desc_string);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_set_qos(
    DDS_DomainParticipant* self, const struct DDS_DomainParticipantQos* qos);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_set_qos_with_profile(
    DDS_DomainParticipant* self, const char * library_name, const char* profile_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipant_get_qos(
    DDS_DomainParticipant* self, struct DDS_DomainParticipantQos* qos);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipant_set_property(
        DDS_DomainParticipant *self,
        const char *property_name,
        const char *value,
        DDS_Boolean propagate);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_set_listener(
    DDS_DomainParticipant* self,
    const struct DDS_DomainParticipantListener* l,
    DDS_StatusMask mask);

extern DDSCDllExport struct DDS_DomainParticipantListener
DDS_DomainParticipant_get_listener(DDS_DomainParticipant* self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipant_get_listenerX(
    DDS_DomainParticipant* self,
    struct DDS_DomainParticipantListener* listener);

extern DDSCDllExport 
DDS_Publisher * DDS_DomainParticipant_lookup_publisher_by_name(
        DDS_DomainParticipant * self,
        const char * publisher_name);

extern DDSCDllExport 
DDS_Subscriber * DDS_DomainParticipant_lookup_subscriber_by_name(
        DDS_DomainParticipant * self,
        const char * subscriber_name);

extern DDSCDllExport 
DDS_DataWriter * DDS_DomainParticipant_lookup_datawriter_by_name(
        DDS_DomainParticipant *self,
        const char * datawriter_full_name);

extern DDSCDllExport 
DDS_DataReader * DDS_DomainParticipant_lookup_datareader_by_name(
        DDS_DomainParticipant * self,
        const char * datareader_full_name);

 extern DDSCDllVariable const struct DDS_DomainParticipantQos 
    DDS_PARTICIPANT_QOS_DEFAULT;

typedef struct DDS_DomainParticipantFactoryImpl
    DDS_DomainParticipantFactory;

extern DDSCDllExport
DDS_DomainParticipantFactory * DDS_DomainParticipantFactory_get_instance(void);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantFactory_finalize_instance(void);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_set_entity_listener(
    DDS_DomainParticipantFactory* self,
    const struct DDS_DomainParticipantFactoryEntityListener *listener);

extern DDSCDllExport struct DDS_DomainParticipantFactoryEntityListener*
DDS_DomainParticipantFactory_get_entity_listener(
            DDS_DomainParticipantFactory* self);

extern DDSCDllExport struct DDS_Registry *
DDS_DomainParticipantFactory_get_registry(
    DDS_DomainParticipantFactory* self);


#define DDS_TheParticipantFactory DDS_DomainParticipantFactory_get_instance()

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_set_default_participant_qos(
    DDS_DomainParticipantFactory* self,
    const struct DDS_DomainParticipantQos* qos);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_set_default_participant_qos_with_profile(
    DDS_DomainParticipantFactory* self,
    const char *library_name,
    const char *profile_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipantFactory_get_default_participant_qos(
    DDS_DomainParticipantFactory* self,
    struct DDS_DomainParticipantQos* qos);

extern DDSCDllExport DDS_DomainParticipant* 
DDS_DomainParticipantFactory_create_participant(
        DDS_DomainParticipantFactory* self,
        DDS_DomainId_t domainId,
        const struct DDS_DomainParticipantQos* qos, 
        const struct DDS_DomainParticipantListener* listener,
	DDS_StatusMask mask);

extern DDSCDllExport DDS_DomainParticipant* 
DDS_DomainParticipantFactory_create_participant_with_profile(
        DDS_DomainParticipantFactory* self,
        DDS_DomainId_t domainId,
	const char* library_name,
        const char* profile_name, 
        const struct DDS_DomainParticipantListener* listener,
	DDS_StatusMask mask);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipantFactory_delete_participant(
    DDS_DomainParticipantFactory* self,
    DDS_DomainParticipant* a_participant);

extern DDSCDllExport DDS_DomainParticipant*
DDS_DomainParticipantFactory_lookup_participant(
    DDS_DomainParticipantFactory* self,
    DDS_DomainId_t domainId);

extern DDSCDllExport DDS_DomainParticipant*
DDS_DomainParticipantFactory_lookup_participant_by_builtin_topic_key(
    DDS_DomainParticipantFactory* self,
    DDS_BuiltinTopicKey_t *key);

extern DDSCDllExport DDS_Entity*
DDS_DomainParticipantFactory_lookup_entity(
    DDS_DomainParticipantFactory* self,
    DDS_BuiltinTopicKey_t *key);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipantFactory_get_qos(
    DDS_DomainParticipantFactory* self,
    struct DDS_DomainParticipantFactoryQos* qos);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipantFactory_set_qos(
    DDS_DomainParticipantFactory* self,
    const struct DDS_DomainParticipantFactoryQos* qos);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_load_profiles(
                DDS_DomainParticipantFactory *self);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_reload_profiles(
                DDS_DomainParticipantFactory *self);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_unload_profiles(
                DDS_DomainParticipantFactory *self);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipantFactory_set_default_library(
    DDS_DomainParticipantFactory *self,
    const char *library_name);

extern DDSCDllExport DDS_ReturnCode_t DDS_DomainParticipantFactory_set_default_profile(
    DDS_DomainParticipantFactory *self,
    const char* library_name, 
    const char* profile_name);

extern DDSCDllExport const char * DDS_DomainParticipantFactory_get_default_library(
    DDS_DomainParticipantFactory *self);

extern DDSCDllExport const char * DDS_DomainParticipantFactory_get_default_profile(
    DDS_DomainParticipantFactory *self);

extern DDSCDllExport const char * DDS_DomainParticipantFactory_get_default_profile_library(
    DDS_DomainParticipantFactory *self);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_participant_factory_qos_from_profile(
        DDS_DomainParticipantFactory *self,
        struct DDS_DomainParticipantFactoryQos *qos,
        const char *library_name,
        const char *profile_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_participant_qos_from_profile(
        DDS_DomainParticipantFactory *self,
        struct DDS_DomainParticipantQos *qos,
        const char *library_name,
        const char *profile_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_publisher_qos_from_profile(
        DDS_DomainParticipantFactory *self,
	struct DDS_PublisherQos *qos,
        const char *library_name,
        const char *profile_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_subscriber_qos_from_profile(
        DDS_DomainParticipantFactory *self,
	struct DDS_SubscriberQos *qos,
        const char *library_name,
        const char *profile_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_datareader_qos_from_profile(
        DDS_DomainParticipantFactory *self,
	struct DDS_DataReaderQos *qos,
        const char *library_name,
        const char *profile_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_datareader_qos_from_profile_w_topic_name(
        DDS_DomainParticipantFactory *self,
	struct DDS_DataReaderQos *qos,
        const char *library_name,
        const char *profile_name,
        const char *topic_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_datawriter_qos_from_profile(
        DDS_DomainParticipantFactory *self,
	struct DDS_DataWriterQos *qos,
        const char *library_name,
        const char *profile_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_datawriter_qos_from_profile_w_topic_name(
        DDS_DomainParticipantFactory *self,
	struct DDS_DataWriterQos *qos,
        const char *library_name,
        const char *profile_name,
        const char *topic_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_topic_qos_from_profile(
        DDS_DomainParticipantFactory *self,
	struct DDS_TopicQos *qos,
        const char *library_name,
        const char *profile_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_topic_qos_from_profile_w_topic_name(
        DDS_DomainParticipantFactory *self,
	struct DDS_TopicQos *qos,
        const char *library_name,
        const char *profile_name,
        const char *topic_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_qos_profile_libraries(
        DDS_DomainParticipantFactory *self,
        struct DDS_StringSeq *library_names);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_qos_profiles(
        DDS_DomainParticipantFactory *self,
        struct DDS_StringSeq *profile_names,
        const char *library_name);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_unregister_thread(
        DDS_DomainParticipantFactory *self);

extern DDSCDllExport DDS_ReturnCode_t
DDS_DomainParticipantFactory_get_type_libraries(
        DDS_DomainParticipantFactory *self,
        struct DDS_StringSeq* library_names);

extern DDSCDllExport const DDS_TypeCode *
DDS_DomainParticipantFactory_get_typecode_from_type_library(
        DDS_DomainParticipantFactory *self,
        const char *library_name,
        const char *type_name);

extern DDSCDllExport const DDS_TypeCode *
DDS_DomainParticipantFactory_get_typecode_from_config(
        DDS_DomainParticipantFactory *self,
        const char *type_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipantFactory_load_xml_element(
        DDS_DomainParticipantFactory * self,
        const char ** xml_element_full_name,
        const char * xml_parent_full_name,
        const char * xml_element_str);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipantFactory_unload_xml_element(
        DDS_DomainParticipantFactory * self,
        const char * xml_element_full_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipantFactory_save_xml_element(
        DDS_DomainParticipantFactory * self,
        struct RTIXMLSaveContext * save_context,
        const char * xml_element_full_name);

extern DDSCDllExport DDS_ReturnCode_t 
DDS_DomainParticipantFactory_save_xml_element_children(
        DDS_DomainParticipantFactory * self,
        struct RTIXMLSaveContext * dst,
        const char * xml_element_full_name);

 extern DDSCDllVariable 
const struct DDS_DomainParticipantConfigParams_t
    DDS_PARTICIPANT_CONFIG_PARAMS_DEFAULT;

typedef DDS_ReturnCode_t 
(*DDS_DomainParticipantFactory_RegisterTypeFunction)(
        DDS_DomainParticipant * participant,
        const char * type_name);

extern DDSCDllExport 
DDS_DomainParticipant * 
DDS_DomainParticipantFactory_create_participant_from_config(
        DDS_DomainParticipantFactory * self,
        const char * configuration_name);

extern DDSCDllExport 
DDS_DomainParticipant * 
DDS_DomainParticipantFactory_create_participant_from_config_w_params(
        DDS_DomainParticipantFactory * self,
        const char * configuration_name,
        const struct DDS_DomainParticipantConfigParams_t * params);

extern DDSCDllExport 
DDS_DomainParticipant * DDS_DomainParticipantFactory_lookup_participant_by_name(
        DDS_DomainParticipantFactory * self,
        const char * participant_name);

extern DDSCDllExport 
DDS_ReturnCode_t DDS_DomainParticipantFactory_register_type_support(
        DDS_DomainParticipantFactory * self,
        DDS_DomainParticipantFactory_RegisterTypeFunction _type_fcn,
        const char * type_name);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantFactory_get_participants(
        DDS_DomainParticipantFactory *self,
        struct DDS_DomainParticipantSeq *participants);

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantFactory_get_participant_count(
        DDS_DomainParticipantFactory *self,
        DDS_Long *participant_count);

 extern DDSCDllVariable 
struct DDS_ThreadFactory DDS_THREAD_FACTORY_USE_DEFAULT;

extern DDSCDllExport
DDS_ReturnCode_t DDS_DomainParticipantFactory_set_thread_factory(
        DDS_DomainParticipantFactory * self,
        const struct DDS_ThreadFactory * thread_factory);

extern DDSCDllExport
struct DDS_ThreadFactory
DDS_DomainParticipantFactory_get_thread_factory(
        DDS_DomainParticipantFactory * self);

typedef struct DDS_LocatorReachabilityData {
    struct DDS_LocatorReachabilityLocator_tSeq locator_list;

} DDS_LocatorReachabilityData;

struct DDS_RtpsAppIdGenerator;

typedef struct DDS_RtpsAppIdGenerator DDS_RtpsAppIdGenerator;

extern DDSCDllExport
struct RTIClock * DDS_DomainParticipantGlobals_get_system_clock(void);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* dds_c_domain_h */
