/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)disc_rtps.h    generated by: makeheader    Sat Mar  9 09:39:00 2024
 *
 *		built from:	rtps.ifc
 */

#ifndef disc_rtps_h
#define disc_rtps_h


  #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
  #endif
  #ifndef netio_common_h
    #include "netio/netio_common.h"
  #endif
  #ifndef mig_rtps_h
    #include "mig/mig_rtps.h"
  #endif
  #ifndef disc_dll_h
    #include "disc/disc_dll.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif


  #define DISC_RTPS_OBJECT_ID_PARTICIPANT  MIG_RTPS_OBJECT_ID_PARTICIPANT


  #define DISC_RTPS_OBJECT_ID_WRITER_SDP_PARTICIPANT \
            MIG_RTPS_OBJECT_ID_SPDP_PARTICIPANT_WRITER


  #define DISC_RTPS_OBJECT_ID_READER_SDP_PARTICIPANT \
            MIG_RTPS_OBJECT_ID_SPDP_PARTICIPANT_READER


  #define DISC_RTPS_OBJECT_ID_SECURE_RELIABLE_WRITER_SDP_PARTICIPANT \
        MIG_RTPS_OBJECT_ID_SECURE_SPDP_BUILTIN_PARTICIPANT_RELIABLE_WRITER


  #define DISC_RTPS_OBJECT_ID_SECURE_RELIABLE_READER_SDP_PARTICIPANT \
        MIG_RTPS_OBJECT_ID_SECURE_SPDP_BUILTIN_PARTICIPANT_RELIABLE_READER


  #define DISC_RTPS_OBJECT_ID_WRITER_SDP_PARTICIPANT_PROXY (0x000300C2)


  #define DISC_RTPS_OBJECT_ID_READER_SDP_PARTICIPANT_PROXY (0x000300C7)


  #define DISC_RTPS_OBJECT_ID_WRITER_SDP_PARTICIPANT_STATE (0x000400C2)


  #define DISC_RTPS_OBJECT_ID_READER_SDP_PARTICIPANT_STATE (0x000400C7)


#define DISC_RTPS_OBJECT_ID_SPDP2_PARTICIPANT_BOOTSTRAP_WRITER \
  MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_BOOTSTRAP_WRITER


#define DISC_RTPS_OBJECT_ID_SPDP2_PARTICIPANT_BOOTSTRAP_READER \
  MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_BOOTSTRAP_READER


#define DISC_RTPS_OBJECT_ID_SPDP2_PARTICIPANT_CONFIG_WRITER \
  MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_RELIABLE_WRITER


#define DISC_RTPS_OBJECT_ID_SPDP2_PARTICIPANT_CONFIG_READER \
  MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_RELIABLE_READER


#define DISC_RTPS_OBJECT_ID_SPDP2_PARTICIPANT_SECURE_CONFIG_WRITER \
  MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_SECURE_RELIABLE_WRITER


#define DISC_RTPS_OBJECT_ID_SPDP2_PARTICIPANT_SECURE_CONFIG_READER \
  MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_SECURE_RELIABLE_READER


  #define DISC_RTPS_OBJECT_ID_WRITER_TOPICS (0x000002C2)


  #define DISC_RTPS_OBJECT_ID_READER_TOPICS (0x000002C7)


#define DISC_RTPS_OBJECT_ID_WRITER_PUBLICATIONS \
  NDDS_TRANSPORT_RTPS_OBJECT_ID_PUB_WRITER


#define DISC_RTPS_OBJECT_ID_READER_PUBLICATIONS \
  NDDS_TRANSPORT_RTPS_OBJECT_ID_PUB_READER


#define DISC_RTPS_OBJECT_ID_WRITER_SUBSCRIPTIONS \
  NDDS_TRANSPORT_RTPS_OBJECT_ID_SUB_WRITER


#define DISC_RTPS_OBJECT_ID_READER_SUBSCRIPTIONS \
  NDDS_TRANSPORT_RTPS_OBJECT_ID_SUB_READER


  #define DISC_RTPS_OBJECT_ID_SECURE_WRITER_PUBLICATIONS (0xFF0003C2)


  #define DISC_RTPS_OBJECT_ID_SECURE_READER_PUBLICATIONS (0xFF0003C7)


  #define DISC_RTPS_OBJECT_ID_SECURE_WRITER_SUBSCRIPTIONS (0xFF0004C2)


  #define DISC_RTPS_OBJECT_ID_SECURE_READER_SUBSCRIPTIONS (0xFF0004C7)

typedef RTI_UINT16 DISCRtpsParameterId;


#define DISC_RTPS_PID_PAD  MIG_RTPS_PID_PAD 


#define DISC_RTPS_PID_SENTINEL   MIG_RTPS_PID_SENTINEL 


#define DISC_RTPS_PID_EXTENDED   MIG_RTPS_PID_EXTENDED 


#define DISC_RTPS_PID_USER_DATA  MIG_RTPS_PID_USER_DATA


#define DISC_RTPS_PID_DATA_REPRESENTATION MIG_RTPS_PID_DATA_REPRESENTATION


#define DISC_RTPS_PID_TOPIC_NAME   MIG_RTPS_PID_TOPIC_NAME 


#define DISC_RTPS_PID_TYPE_NAME   MIG_RTPS_PID_TYPE_NAME 


#define DISC_RTPS_PID_GROUP_DATA    MIG_RTPS_PID_GROUP_DATA 


#define DISC_RTPS_PID_TOPIC_DATA    MIG_RTPS_PID_TOPIC_DATA


#define DISC_RTPS_PID_DURABILITY    MIG_RTPS_PID_DURABILITY 


#define DISC_RTPS_PID_DURABILITY_SERVICE   MIG_RTPS_PID_DURABILITY_SERVICE 


#define DISC_RTPS_PID_DEADLINE   MIG_RTPS_PID_DEADLINE 


#define DISC_RTPS_PID_LATENCY_BUDGET   MIG_RTPS_PID_LATENCY_BUDGET 


#define DISC_RTPS_PID_LIVELINESS   MIG_RTPS_PID_LIVELINESS  


#define DISC_RTPS_PID_RELIABILITY   MIG_RTPS_PID_RELIABILITY  


#define DISC_RTPS_PID_LIFESPAN    MIG_RTPS_PID_LIFESPAN 


#define DISC_RTPS_PID_DESTINATION_ORDER  MIG_RTPS_PID_DESTINATION_ORDER


#define DISC_RTPS_PID_HISTORY   MIG_RTPS_PID_HISTORY  


#define DISC_RTPS_PID_RESOURCE_LIMITS  MIG_RTPS_PID_RESOURCE_LIMITS 


#define DISC_RTPS_PID_OWNERSHIP     MIG_RTPS_PID_OWNERSHIP  


#define DISC_RTPS_PID_OWNERSHIP_STRENGTH MIG_RTPS_PID_OWNERSHIP_STRENGTH 


#define DISC_RTPS_PID_PRESENTATION     MIG_RTPS_PID_PRESENTATION  


#define DISC_RTPS_PID_PARTITION       MIG_RTPS_PID_PARTITION  


#define DISC_RTPS_PID_TIME_BASED_FILTER  MIG_RTPS_PID_TIME_BASED_FILTER 


#define DISC_RTPS_PID_PROTOCOL_VERSION   MIG_RTPS_PID_PROTOCOL_VERSION   


#define DISC_RTPS_PID_VENDOR_ID      MIG_RTPS_PID_VENDOR_ID            


#define DISC_RTPS_PID_UNICAST_LOCATOR6    MIG_RTPS_PID_UNICAST_LOCATOR6 


#define DISC_RTPS_PID_MULTICAST_LOCATOR6    MIG_RTPS_PID_MULTICAST_LOCATOR6 


#define DISC_RTPS_PID_MULTICAST_IPADDRESS  MIG_RTPS_PID_MULTICAST_IPADDRESS 


#define DISC_RTPS_PID_DEFAULT_UNICAST_LOCATOR6   MIG_RTPS_PID_DEFAULT_UNICAST_LOCATOR6  


#define DISC_RTPS_PID_DEFAULT_MULTICAST_LOCATOR6   MIG_RTPS_PID_DEFAULT_MULTICAST_LOCATOR6  


#define DISC_RTPS_PID_METATRAFFIC_UNICAST_LOCATOR6  MIG_RTPS_PID_METATRAFFIC_UNICAST_LOCATOR6 


#define DISC_RTPS_PID_METATRAFFIC_MULTICAST_LOCATOR6  MIG_RTPS_PID_METATRAFFIC_MULTICAST_LOCATOR6 


#define DISC_RTPS_PID_DEFAULT_UNICAST_IPADDRESS    MIG_RTPS_PID_DEFAULT_UNICAST_IPADDRESS 


#define DISC_RTPS_PID_DEFAULT_UNICAST_PORT   MIG_RTPS_PID_DEFAULT_UNICAST_PORT   


#define DISC_RTPS_PID_METATRAFFIC_UNICAST_IPADDRESS  MIG_RTPS_PID_METATRAFFIC_UNICAST_IPADDRESS 


#define DISC_RTPS_PID_METATRAFFIC_UNICAST_PORT  MIG_RTPS_PID_METATRAFFIC_UNICAST_PORT 


#define DISC_RTPS_PID_METATRAFFIC_MULTICAST_IPADDRESS  MIG_RTPS_PID_METATRAFFIC_MULTICAST_IPADDRESS 


#define DISC_RTPS_PID_METATRAFFIC_MULTICAST_PORT  MIG_RTPS_PID_METATRAFFIC_MULTICAST_PORT 


#define DISC_RTPS_PID_EXPECTS_INLINE_QOS     MIG_RTPS_PID_EXPECTS_INLINE_QOS 


#define DISC_RTPS_PID_MANUAL_LIVELINESS_COUNT  MIG_RTPS_PID_MANUAL_LIVELINESS_COUNT   


#define DISC_RTPS_PID_PARTICIPANT_BUILTIN_ENDPOINTS   MIG_RTPS_PID_PARTICIPANT_BUILTIN_ENDPOINTS 


#define DISC_RTPS_PID_LEASE_DURATION     MIG_RTPS_PID_LEASE_DURATION      


#define DISC_RTPS_PID_CONTENT_FILTER_PROPERTY      MIG_RTPS_PID_CONTENT_FILTER_PROPERTY   


#define DISC_RTPS_PID_PROPERTY_LIST 	       MIG_RTPS_PID_PROPERTY_LIST      


#define DISC_RTPS_PID_DATA_TAGS                MIG_RTPS_PID_DATA_TAGS


#define DISC_RTPS_PID_PARTICIPANT_GUID        MIG_RTPS_PID_PARTICIPANT_GUID       


#define DISC_RTPS_PID_PARTICIPANT_ENTITY_ID       MIG_RTPS_PID_PARTICIPANT_ENTITY_ID   


#define DISC_RTPS_PID_GROUP_GUID        MIG_RTPS_PID_GROUP_GUID        


#define DISC_RTPS_PID_GROUP_ENTITY_ID        MIG_RTPS_PID_GROUP_ENTITY_ID      


#define DISC_RTPS_PID_ENDPOINT_GUID        MIG_RTPS_PID_ENDPOINT_GUID        


#define DISC_RTPS_PID_BUILTIN_ENDPOINT_MASK      MIG_RTPS_PID_BUILTIN_ENDPOINT_MASK     


#define DISC_RTPS_PID_MAX_SAMPLE_SERIALIZED_SIZE    MIG_RTPS_PID_MAX_SAMPLE_SERIALIZED_SIZE 


#define DISC_RTPS_PID_ENTITY_NAME   MIG_RTPS_PID_ENTITY_NAME   


#define DISC_RTPS_PID_TYPE_OBJECT    MIG_RTPS_PID_TYPE_OBJECT   


#define DISC_RTPS_PID_TYPE_CONSISTENCY    MIG_RTPS_PID_TYPE_CONSISTENCY


#define DISC_RTPS_PID_EQUIVALENT_TYPE_NAME    MIG_RTPS_PID_EQUIVALENT_TYPE_NAME   


#define DISC_RTPS_PID_BASE_TYPE_NAME    MIG_RTPS_PID_BASE_TYPE_NAME


#define DISC_RTPS_PID_BUILTIN_ENDPOINT_QOS    MIG_RTPS_PID_BUILTIN_ENDPOINT_QOS


#define DISC_RTPS_PID_IDENTITY_TOKEN MIG_RTPS_PID_IDENTITY_TOKEN
#define DISC_RTPS_PID_PERMISSIONS_TOKEN MIG_RTPS_PID_PERMISSIONS_TOKEN
#define DISC_RTPS_PID_ENDPOINT_SECURITY_PROTECTION_INFO \
    MIG_RTPS_PID_ENDPOINT_SECURITY_PROTECTION_INFO
#define DISC_RTPS_PID_PARTICIPANT_SECURITY_PROTECTION_INFO \
    MIG_RTPS_PID_PARTICIPANT_SECURITY_PROTECTION_INFO
#define DISC_RTPS_PID_PARTICIPANT_SECURITY_DIGITAL_SIGNATURE_ALGO \
    MIG_RTPS_PID_PARTICIPANT_SECURITY_DIGITAL_SIGNATURE_ALGO
#define DISC_RTPS_PID_PARTICIPANT_SECURITY_KEY_ESTABLISHMENT_ALGO \
    MIG_RTPS_PID_PARTICIPANT_SECURITY_KEY_ESTABLISHMENT_ALGO
#define DISC_RTPS_PID_PARTICIPANT_SECURITY_SYMMETRIC_CIPHER_ALGO \
    MIG_RTPS_PID_PARTICIPANT_SECURITY_SYMMETRIC_CIPHER_ALGO
#define DISC_RTPS_PID_ENDPOINT_SECURITY_SYMMETRIC_CIPHER_ALGO \
    MIG_RTPS_PID_ENDPOINT_SECURITY_SYMMETRIC_CIPHER_ALGO


#define DISC_RTPS_PID_PRODUCT_VERSION MIG_RTPS_PID_PRODUCT_VERSION


#define DISC_RTPS_PID_PLUGIN_PROMISCUITY_KIND_DEPRECATED \
    MIG_RTPS_PID_PLUGIN_PROMISCUITY_KIND_DEPRECATED


#define DISC_RTPS_PID_ENTITY_VIRTUAL_GUID MIG_RTPS_PID_ENTITY_VIRTUAL_GUID


#define DISC_RTPS_PID_SERVICE MIG_RTPS_PID_SERVICE


#define DISC_RTPS_PID_TYPECODE MIG_RTPS_PID_TYPECODE


#define DISC_RTPS_PID_DISABLE_ACKS MIG_RTPS_PID_DISABLE_ACKS


#define DISC_RTPS_PID_LOCATOR_FILTER_LIST MIG_RTPS_PID_LOCATOR_FILTER_LIST


#define DISC_RTPS_PID_UNICAST_LOCATOR6_EX MIG_RTPS_PID_UNICAST_LOCATOR6_EX


#define DISC_RTPS_PID_MULTICAST_LOCATOR6_EX MIG_RTPS_PID_MULTICAST_LOCATOR6_EX


#define DISC_RTPS_PID_EXPECTS_VIRTUAL_HB MIG_RTPS_PID_EXPECTS_VIRTUAL_HB


#define DISC_RTPS_PID_ROLE_NAME MIG_RTPS_PID_ROLE_NAME


#define DISC_RTPS_PID_ACK_KIND MIG_RTPS_PID_ACK_KIND


#define DISC_RTPS_PID_PRESENTATION_EX MIG_RTPS_PID_PRESENTATION_EX


#define DISC_RTPS_PID_GROUP_VIRTUAL_GUID MIG_RTPS_PID_GROUP_VIRTUAL_GUID


#define DISC_RTPS_PID_PEER_HOST_EPOCH_DEPRECATED \
        MIG_RTPS_PID_PEER_HOST_EPOCH_DEPRECATED


#define DISC_RTPS_PID_DOMAIN_ID MIG_RTPS_PID_DOMAIN_ID


#define DISC_RTPS_PID_RTI_DOMAIN_ID MIG_RTPS_PID_RTI_DOMAIN_ID


#define DISC_RTPS_PID_DOMAIN_TAG MIG_RTPS_PID_DOMAIN_TAG


#define DISC_RTPS_PID_TRANSPORT_INFO_LIST MIG_RTPS_PID_TRANSPORT_INFO_LIST


#define DISC_RTPS_PID_DIRECT_COMMUNICATION MIG_RTPS_PID_DIRECT_COMMUNICATION


#define DISC_RTPS_PID_TOPIC_QUERY_PUBLICATION MIG_RTPS_PID_TOPIC_QUERY_PUBLICATION


#define DISC_RTPS_PID_ENDPOINT_PROPERTY_CHANGE_EPOCH MIG_RTPS_PID_ENDPOINT_PROPERTY_CHANGE_EPOCH


#define DISC_RTPS_PID_REACHABILITY_LEASE_DURATION MIG_RTPS_PID_REACHABILITY_LEASE_DURATION


#define DISC_RTPS_PID_VENDOR_BUILTIN_ENDPOINT_MASK MIG_RTPS_PID_VENDOR_BUILTIN_ENDPOINT_MASK


#define DISC_RTPS_PID_ENDPOINT_SECURITY_ATTRIBUTES MIG_RTPS_PID_ENDPOINT_SECURITY_ATTRIBUTES


#define DISC_RTPS_PID_TYPE_OBJECT_LB MIG_RTPS_PID_TYPE_OBJECT_LB


#define DISC_RTPS_PID_ISC_KIND MIG_RTPS_PID_ISC_KIND


#define DISC_RTPS_PID_VENDOR_PARTICIPANT_SECURITY_PROTECTION_INFO \
        MIG_RTPS_PID_VENDOR_PARTICIPANT_SECURITY_PROTECTION_INFO


#define DISC_RTPS_PID_PERSISTENCE_DEPRECATED MIG_RTPS_PID_PERSISTENCE_DEPRECATED


#define DISC_RTPS_PID_TYPE_CHECKSUM_DEPRECATED \
    MIG_RTPS_PID_TYPE_CHECKSUM_DEPRECATED


#define DISC_RTPS_PID_TYPE2_NAME_DEPRECATED MIG_RTPS_PID_TYPE2_NAME_DEPRECATED


#define DISC_RTPS_PID_TYPE2_CHECKSUM_DEPRECATED \
    MIG_RTPS_PID_TYPE2_CHECKSUM_DEPRECATED


#define DISC_RTPS_PID_EXPECTS_ACK_DEPRECATED MIG_RTPS_PID_EXPECTS_ACK_DEPRECATED


#define DISC_RTPS_PID_MANAGER_KEY_DEPRECATED MIG_RTPS_PID_MANAGER_KEY_DEPRECATED


#define DISC_RTPS_PID_SEND_QUEUE_SIZE_DEPRECATED \
    MIG_RTPS_PID_SEND_QUEUE_SIZE_DEPRECATED


#define DISC_RTPS_PID_VARGAPPS_SEQUENCE_NUMBER_LAST_DEPRECATED \
    MIG_RTPS_PID_VARGAPPS_SEQUENCE_NUMBER_LAST_DEPRECATED


#define DISC_RTPS_PID_RECV_QUEUE_SIZE_DEPRECATED \
    MIG_RTPS_PID_RECV_QUEUE_SIZE_DEPRECATED


#define DISC_RTPS_PID_TYPECODE_DEPRECATED MIG_RTPS_PID_TYPECODE_DEPRECATED


/*e \ingroup DISCRtpsPortModule
  default value for domain base port
*/
#define DISC_RTPS_BASE_PORT_DEFAULT (7400)
/*e \ingroup DISCRtpsPortModule
  default value for domain index
*/
#define DISC_RTPS_DOMAIN_INDEX_DEFAULT (0)
/*e \ingroup DISCRtpsPortModule
  default value for application number
*/
#define DISC_RTPS_APP_INDEX_DEFAULT (0)

extern DISCDllExport NDDS_Transport_Port_t
DISCRtps_getWellKnownMulticastPort(
    int domain_id, NDDS_Transport_Port_t port_base, 
    int domain_id_gain, int port_offset);

extern DISCDllExport NDDS_Transport_Port_t
DISCRtps_getWellKnownUnicastPort(
    int domain_id, int participant_id, NDDS_Transport_Port_t port_base, 
    int domain_id_gain, int participant_id_gain, int port_offset);



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#include "disc/disc_rtps_impl.h"


#endif /* disc_rtps_h */
