/*

(c) Copyright, Real-Time Innovations, 2023.
All rights reserved.

No duplications, whole or partial, manual or electronic, may be made
without express written permission.  Any such copies, or
revisions thereof, must display this notice unaltered.
This code contains trade secrets of Real-Time Innovations, Inc.
*/

#ifndef RTI_DIST_LOGGER_MACROS_HPP_
#define RTI_DIST_LOGGER_MACROS_HPP_

#if defined(RTI_WIN32) || defined(RTI_WINCE) || defined(RTI_INTIME)
  #if defined(RTI_dl_cpp2_DLL_EXPORT)
    #  define RTIDLCPP2DllExport __declspec( dllexport )
  #else
    #  define RTIDLCPP2DllExport
  #endif

  #if defined(RTI_dl_cpp2_DLL_VARIABLE) 
    #if defined(RTI_dl_cpp2_DLL_EXPORT)
      #define RTIDLCPP2DllVariable __declspec( dllexport )
      #define RTIDLCPP2DllClassVariable
    #else
      #define RTIDLCPP2DllVariable __declspec( dllimport )
      #define RTIDLCPP2DllClassVariable __declspec( dllimport )
    #endif /* RTI_dl_cpp2_DLL_EXPORT */
  #else 
    #define RTIDLCPP2DllVariable
    #define RTIDLCPP2DllClassVariable
  #endif /* RTI_dl_cpp2_DLL_VARIABLE */
#else
  #define RTIDLCPP2DllExport
  #define RTIDLCPP2DllVariable
  #define RTIDLCPP2DllClassVariable
#endif /* RTI_WIN32 || RTI_WINCE || RTI_INTIME */

#endif // RTI_DIST_LOGGER_MACROS_HPP_
