/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)mig_generator_impl.h    generated by: makeheader    Sat Mar  9 09:38:18 2024
 *
 *		built from:	generator_impl.ifc
 */

#ifndef mig_generator_impl_h
#define mig_generator_impl_h


  #ifndef osapi_bufferUtils_h
    #include "osapi/osapi_bufferUtils.h"
  #endif
  #ifndef reda_worker_h
    #include "reda/reda_worker.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif


struct MIGGenerator {
    MIGRtpsHostId _hostId;
    MIGRtpsAppId _appId;
    MIGRtpsInstanceId _instanceId; /*RTPS.2.0*/
    struct REDAWorkerFactory *_workerFactory;
    struct REDAObjectPerWorker *_contextPerWorker;
    struct MIGGeneratorProperty _property;
    char _header[MIG_RTPS_HEADER_SIZE];
    char _headerExt[MIG_RTPS_HEADER_SIZE];
    struct RTINetioSender *_sender;
    struct RTIClock *_clock;
    struct RTINtpTime _timeOfFirstSample;
    struct MIGGeneratorListener _listener;
    struct RTINetioCapManager *_netioCapManager;
};



#define MIGGenerator_addDataFrag( \
        __me, \
        __size, \
        __readerGuidIn, \
        __writerObjectId, \
        __readerDirectedInterceptorHandles, \
        __sample, \
        __numFragsToAdd, \
        __firstFragNumber, \
        __numFragsAdded, \
        __use43DataFragFormat, \
        __encapsulationIndex, \
        __worker) \
    MIGGenerator_addDataFragEx( \
        __me, \
        __size, \
        __readerGuidIn, \
        __writerObjectId, \
        __readerDirectedInterceptorHandles, \
        __sample, \
        __numFragsToAdd, \
        __firstFragNumber, \
        __numFragsAdded, \
        __use43DataFragFormat, \
        __encapsulationIndex, \
        RTI_FALSE, /* addVirtualSn */ \
        __worker)

#define MIGGeneratorSample_isValid(me, index)           \
    (me != NULL &&                             \
     (((me)->serializedData[index].serializedData.pointer == NULL ||       \
       ((me)->serializedData[index].serializedData.length & 0x3) == 0)) && \
     (((me)->protocolParameters.pointer == NULL ||      \
       ((me)->protocolParameters.length & 0x3) == 0)))

#define MIG_GENERATOR_SAMPLE_BIT_NONE      (0x0)
#define MIG_GENERATOR_SAMPLE_BIT_TIMESTAMP (0x01)

#define MIGGeneratorSample_isTimestamped(me) \
    (((me)->_bitmap & MIG_GENERATOR_SAMPLE_BIT_TIMESTAMP) != 0)

#define MIGGeneratorSample_compare ((REDAOrderedDataTypeCompareFunction) \
                                  REDASequenceNumber_compare)

#define MIGGeneratorSample_copy(me, src) \
    RTIOsapiMemory_copy(me, src, sizeof(struct MIGGeneratorSample))

#define  MIGGeneratorSample_setAndInitializeParameterStream(sample__, stream__) \
    (sample__)->protocolStream = (stream__); \
    if (((sample__)->flags & MIG_RTPS_ENDIAN_FLAG) == 0) { \
        RTICdrStream_setEndian((stream__), RTI_CDR_ENDIAN_BIG); \
    } else { \
        RTICdrStream_setEndian((stream__), RTI_CDR_ENDIAN_LITTLE); \
    } \
    if ((sample__)->protocolParameters.pointer != NULL) { \
        RTICdrStream_set( \
            (stream__), \
            (sample__)->protocolParameters.pointer, \
            REDAFastBufferPool_getBufferSize((sample__)->protocolPool)); \
    }

#define MIGGeneratorSample_getAndInitializeParameterStream(sample__, stream__) \
    if ((sample__)->protocolParameters.pointer == NULL) { \
        (sample__)->protocolParameters.pointer =  \
                REDAFastBufferPool_getBuffer((sample__)->protocolPool); \
        (sample__)->protocolParameters.length = 0; \
    } \
    if ((sample__)->protocolParameters.pointer != NULL) { \
        *stream__ = (sample__)->protocolStream; \
        RTICdrStream_set( \
                (sample__)->protocolStream, \
                (sample__)->protocolParameters.pointer, \
                (RTI_UINT32) REDAFastBufferPool_getBufferSize((sample__)->protocolPool)); \
        RTICdrStream_setCurrentPositionOffset( \
                (sample__)->protocolStream, \
                (sample__)->inlineQosOffset); \
    }

#define MIGGeneratorSample_restoreProtocolBuffer(sample__) \
    if ((sample__)->inlineQosOffset == 0) { \
        /* No inline QoS */ \
        (sample__)->protocolParameters.length = 0; \
        (sample__)->flags &= (MIGRtpsSubmessageFlag) ~MIG_RTPS_DATA_Q_FLAG; \
    } else if ((sample__)->protocolParameters.pointer != NULL \
        && (sample__)->protocolParameters.length > \
            ((sample__)->inlineQosOffset \
                + RTI_CDR_PARAMETER_SHORT_HEADER_SIZE)) { \
        /* Filter signature was serialized. We have to undo the op */ \
        RTICdrStream_set( \
                (sample__)->protocolStream, \
                (sample__)->protocolParameters.pointer, \
                (RTI_UINT32) REDAFastBufferPool_getBufferSize((sample__)->protocolPool)); \
        RTICdrStream_setCurrentPositionOffset( \
                (sample__)->protocolStream, \
                (sample__)->inlineQosOffset); \
        MIGRtps_serializeParameterSequenceSentinelFast( \
                (sample__)->protocolStream); \
        (sample__)->protocolParameters.length = \
                (sample__)->inlineQosOffset + RTI_CDR_PARAMETER_SHORT_HEADER_SIZE; \
    }

MIGDllVariable extern struct REDAObjectPerWorker *MIG_GENERATOR_STAT_PER_WORKER;

#define MIGGeneratorWorkerStat_getStorageLazy(statPtr, worker) \
    (*(statPtr) =                                              \
             REDAWorker_assertObject(worker, MIG_GENERATOR_STAT_PER_WORKER))

#define MIGGeneratorSecurityProperty_setDirectedInterceptorHandles( \
        __self, \
        __interceptorHandles) \
    MIGGeneratorSecurityProperty_removeDirectedInterceptorHandles(__self); \
    (__self)->clearDirectedInterceptorHandleLists = RTI_FALSE; \
    MIGGeneratorSecurityProperty_assertDirectedInterceptorHandles( \
            __self, \
            __interceptorHandles);

/*
 * @brief Filter signature length
 */
#define MIG_RTPS_FILTER_SIGNATURE_LENGTH_FOR_FOUR_READERS 64

#define MIGGenerator_getBatchSampleInfoRtpsOverhead( \
        rtpsOverhead__, \
        sample__, \
        encapsulationCount__) \
{ \
    RTI_UINT32 i__; \
 \
    *(rtpsOverhead__) = 0; \
    for (i__ = 0; i__ < (encapsulationCount__); i__++) { \
        if ((RTI_UINT32) (sample__)->batchSampleInfoData[i__].length \
                >  *(rtpsOverhead__)) { \
             *(rtpsOverhead__) = \
                    (RTI_UINT32) (sample__)->batchSampleInfoData[i__].length; \
        } \
    } \
}

#define MIGGenerator_getSampleRtpsOverhead( \
        self__, \
        rtpsOverhead__, \
        sample__, \
        securityProp__, \
        batch__, \
        dataFrag__, \
        multiSession__, \
        encapsulationCount__, \
        isReliable__) \
{ \
    /* Add space for RTPS Header, INFO_DST, and Sentinel in inlineQoS */ \
    RTI_UINT32 localRtpsOverhead__ = \
            MIG_RTPS_HEADER_SIZE + MIG_RTPS_INFO_DESTINATION_SIZE + \
            RTI_CDR_PARAMETER_SHORT_HEADER_SIZE; \
 \
    if ((self__)->_property.crcEnabled) { \
        /* \
         * The CRC overhead has to be considered at the same level than the \
         * RTPS header overhead. \
         */ \
        localRtpsOverhead__ += MIG_RTPS_CRC_SIZE; \
    } \
 \
    if (MIGGeneratorSample_isTimestamped((sample__))) { \
        /* Add space for INFO_TS */ \
        localRtpsOverhead__ += MIG_RTPS_INFO_TS_SIZE; \
    } \
 \
    if ((batch__)) { \
        RTI_UINT32 maxBatchSampleInfoDataLength__ = 0; \
        /* \
         * For batching the submessage DATA_BATCH is the same regardless of \
         * the number of sessions \
         */ \
        localRtpsOverhead__ += MIG_RTPS_DATA_BATCH_SIZE; \
        /* Add batch sample info */ \
        MIGGenerator_getBatchSampleInfoRtpsOverhead( \
            &maxBatchSampleInfoDataLength__, \
            sample__, \
            encapsulationCount__) \
 \
        localRtpsOverhead__ += maxBatchSampleInfoDataLength__; \
    } else if ((multiSession__)) { \
        if ((dataFrag__)) { \
            /* \
            * With DATA_FRAG, fragments must be aligned to 4-byte boundary. Here, \
            * we are adding overhead for the padding \
            */ \
            localRtpsOverhead__ += MIG_RTPS_DATA_FRAG_SESSION_SIZE + 4; \
        } else { \
            localRtpsOverhead__ += MIG_RTPS_DATA_SESSION_SIZE; \
        } \
    } else { \
        if ((dataFrag__)) { \
            /* \
            * With DATA_FRAG, fragments must be aligned to 4-byte boundary. Here, \
            * we are adding overhead for the padding \
            */ \
            localRtpsOverhead__ += MIG_RTPS_DATA_FRAG_SIZE + 4; \
        } else { \
            localRtpsOverhead__ += MIG_RTPS_DATA_SIZE; \
        } \
    } \
 \
    /* Add sample inlineQoS */ \
    localRtpsOverhead__ += (RTI_UINT32) (sample__)->inlineQosOffset; \
 \
    if (!(batch__) && (!(dataFrag__) || !(isReliable__))) { \
        /* \
         * Add filter signature inline QoS as it is not part of inlineQosOffset. \
         * At this point we support up to 4 signatures per DATA msg. \
         * \
         * Batching does not support writer side filtering. \
         * \
         * Also, we do not support filter signature in inlineQoS when using \
         * fragmentation unless the DW is best-effort. \
         */ \
        localRtpsOverhead__ += RTI_CDR_PARAMETER_SHORT_HEADER_SIZE \
                + MIG_RTPS_FILTER_SIGNATURE_PARAMETER_LENGTH_WITHOUT_SIGNATURES \
                + MIG_RTPS_FILTER_SIGNATURE_LENGTH_FOR_FOUR_READERS; \
    } \
 \
    /* \
     * The check here assumes an RTPS message can only be from one endpoint \
     * (writer or reader). This is true in our implementation. \
     */ \
    if ((securityProp__)->encodeRtpsMessage) { \
        localRtpsOverhead__ += (RTI_UINT32) \
                (self__)->_property.encodedMessageMaxOverhead; \
    } else if ((securityProp__)->encodeRtpsMessageWithPresharedKey) { \
        localRtpsOverhead__ += (RTI_UINT32) \
                (self__)->_property.encodedMessageWithPresharedKeyMaxOverhead; \
    } \
 \
    if ((securityProp__)->encodeSubmessage) { \
        localRtpsOverhead__ += \
                (RTI_UINT32) (self__)->_property.encodedSubmessageMaxOverhead; \
    } \
 \
    *(rtpsOverhead__) = localRtpsOverhead__; \
}

#define MIGGenerator_getBatchSampleRtpsOverhead( \
        self__, \
        rtpsOverhead__, \
        sample__, \
        securityProp__, \
        encapsulationCount__) \
    MIGGenerator_getSampleRtpsOverhead( \
            self__, \
            rtpsOverhead__, \
            sample__, \
            securityProp__, \
            RTI_TRUE, /* batch__ */ \
            RTI_FALSE, /* dataFrag__ */ \
            RTI_FALSE, /* multiSession__ */ \
            encapsulationCount__, \
            /* \
             * isReliable can be set to any value because is ignored when \
             * using batching \
             */ \
            RTI_TRUE /* isReliable__ */)



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* mig_generator_impl_h */
