/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)mig_rtps_impl.h    generated by: makeheader    Sat Mar  9 09:38:19 2024
 *
 *		built from:	rtps_impl.ifc
 */

#ifndef mig_rtps_impl_h
#define mig_rtps_impl_h



#ifndef mig_rtps_h
#include "mig/mig_rtps.h"
#endif
#ifndef reda_sequenceNumber_h
#include "reda/reda_sequenceNumber.h"
#endif
#ifndef reda_orderedDataType_h
#include "reda/reda_orderedDataType.h"
#endif

#include "xcdr/xcdr_stream.h"

#ifdef __cplusplus
    extern "C" {
#endif



/* --------------------------------------------------------- */
    /* DO NOT USE! The isReserved macro is deprecated and should not be used
       anymore. Use MIGRtpsObjectSuffix_isUser or
       MIGRtpsObjectSuffix_isVendorSpecific below. See CORE-6948 for details. */
  #define MIGRtpsObjectSuffix_isReserved(osx) \
    ((osx) & MIG_RTPS_OBJECT_KIND_R_BIT)

  #define MIGRtpsObjectSuffix_isMeta(osx) \
    ((osx) & MIG_RTPS_OBJECT_KIND_M_BIT)

  /* This macro checks for the combination of 00 in the two most-significant
   * bits of the entityKind. This is the bit combination that is used by the
   * DDS specification for user-defined entities. This check covers all
   * entities that are accessible to the user. */
  #define MIGRtpsObjectSuffix_isUser(osx) \
    (!((osx) & MIG_RTPS_OBJECT_KIND_M_BIT) && \
     !((osx) & MIG_RTPS_OBJECT_KIND_R_BIT) )

  #define MIGRtpsObjectSuffix_isVirtual(osx) \
    (((osx) == MIG_RTPS_OBJECT_NORMAL_USER_VIRTUAL_SUBSCRIPTION || \
      (osx) == MIG_RTPS_OBJECT_NORMAL_USER_VIRTUAL_CST_READER || \
      (osx) == MIG_RTPS_OBJECT_NORMAL_USER_VIRTUAL_READER_GROUP || \
      (osx) == MIG_RTPS_OBJECT_NORMAL_USER_VIRTUAL_TOPIC) ? \
      RTI_TRUE : RTI_FALSE)

  #define MIGRtpsObjectSuffix_isKeyed(osx) \
    (((osx) == MIG_RTPS_OBJECT_NORMAL_USER_CST_WRITER || \
      (osx) == MIG_RTPS_OBJECT_RESERVED_META_CST_WRITER || \
      (osx) == MIG_RTPS_OBJECT_NORMAL_USER_CST_READER || \
      (osx) == MIG_RTPS_OBJECT_RESERVED_META_CST_READER) ? \
      RTI_TRUE : RTI_FALSE)

  /* This macro checks for entities that were explicitly created by the user.
   * This check will exclude virtual entities that the user still has access
   * to, such as the builtin readers and topics  */
  #define MIGRtpsObjectSuffix_isUserCreated(osx) \
    (MIGRtpsObjectSuffix_isUser(osx) && \
     !MIGRtpsObjectSuffix_isVirtual(osx))

  /*
   * This macro checks for entities that were explicitly created by the user and
   * are keyed.
   */
  #define MIGRtpsObjectSuffix_isUserCreatedKeyed(osx) \
    (MIGRtpsObjectSuffix_isUserCreated(osx) && \
        MIGRtpsObjectSuffix_isKeyed(osx))

  /* This macro checks for the combinations of 01 or 10 in the two
   * most-significant bits of the entityKind. These are the bit combinations
   * that are used by the DDS specification for vendor-specific entities */
  #define MIGRtpsObjectSuffix_isVendorSpecific(osx) \
    ((!((osx) & MIG_RTPS_OBJECT_KIND_M_BIT) && \
      ((osx) & MIG_RTPS_OBJECT_KIND_R_BIT)) || \
     (((osx) & MIG_RTPS_OBJECT_KIND_M_BIT) && \
      !((osx) & MIG_RTPS_OBJECT_KIND_R_BIT)))

/* --------------------------------------------------------- */
  #define MIGRtpsObjectSuffix_getRWType(osx) \
    ((((osx) & 0x3F) == 0x02 || ((osx) & 0x3F) == 0x03 || \
    ((osx) & 0x3F) == 0x0C) ? MIG_RTPS_RW_TYPE_WRITER : \
    ((((osx) & 0x3F) == 0x04 || ((osx) & 0x3F) == 0x07 || \
      ((osx) & 0x3F) == 0x3C || ((osx) & 0x3F) == 0x3D || \
      ((osx) & 0x3F) == 0x0D) ? MIG_RTPS_RW_TYPE_READER : \
       MIG_RTPS_RW_TYPE_UNKNOWN))

/* --------------------------------------------------------- */
#define MIGRtpsRWType_toString(rwType) \
        ((rwType) == MIG_RTPS_RW_TYPE_WRITER \
                ? ADVLOG_ENTITY_SHORTNAME_DATAWRITER \
                : ((rwType) == MIG_RTPS_RW_TYPE_READER) \
                        ? ADVLOG_ENTITY_SHORTNAME_DATAREADER \
                        : "UNKNOWN")

/* --------------------------------------------------------- */
  #define MIGRtpsObjectSuffix_isWriterGroup(osx__) \
    (((osx__) & 0x3F) == 0x08)

/* --------------------------------------------------------- */
  #define MIGRtpsObjectSuffix_isReaderGroup(osx__) \
    (((osx__) & 0x3F) == 0x09)

/* --------------------------------------------------------- */
  #define MIGRtpsObjectSuffix_getSampleType(osx) \
    ((((osx) & 0x3F) == 0x02 || ((osx) & 0x3F) == 0x07 || \
      ((osx) & 0x3F) == 0x3D || ((osx) & 0x3F) == 0x0E || \
      ((osx) & 0x3F) == 0x0B) \
        ? MIG_RTPS_SAMPLE_TYPE_CST \
        : ((((osx) & 0x3F) == 0x03 || ((osx) & 0x3F) == 0x04 || \
            ((osx) & 0x3F) == 0x3C || ((osx) & 0x3F) == 0x0C || \
            ((osx) & 0x3F) == 0x0D) \
              ? MIG_RTPS_SAMPLE_TYPE_PS \
              : MIG_RTPS_SAMPLE_TYPE_UNKNOWN))

/* --------------------------------------------------------- */
/*
 * This macro converts an object ID suffix to a string that describes
 * what kind of object the suffix is for.
 */
#define MIGRtpsObjectSuffix_getString(osx__) \
    ((osx__) == MIG_RTPS_OBJECT_NORMAL_USER_CST_WRITER) \
    ? "keyed user datawriter" \
    : ((osx__) == MIG_RTPS_OBJECT_NORMAL_USER_PUBLICATION) \
        ? "unkeyed user datawriter" \
        : ((osx__) == MIG_RTPS_OBJECT_NORMAL_USER_SUBSCRIPTION) \
        ? "unkeyed user datareader" \
            : ((osx__) == MIG_RTPS_OBJECT_NORMAL_USER_CST_READER) \
            ? "keyed user datareader" \
                : ((osx__) == MIG_RTPS_OBJECT_NORMAL_USER_WRITER_GROUP) \
                ? "user publisher" \
                    : ((osx__) == MIG_RTPS_OBJECT_NORMAL_USER_READER_GROUP) \
                    ? "user subscriber" \
                        : ((osx__) == MIG_RTPS_OBJECT_NORMAL_USER_TOPIC) \
                        ? "user topic" \
                            : (((osx__) == MIG_RTPS_OBJECT_NORMAL_META_CST_WRITER) || \
                               ((osx__) == MIG_RTPS_OBJECT_RESERVED_META_CST_WRITER) || \
                               ((osx__) == MIG_RTPS_OBJECT_NORMAL_META_PUBLICATION) || \
                               ((osx__) == MIG_RTPS_OBJECT_RESERVED_META_PUBLICATION)) \
                            ? "builtin datawriter" \
                                : (((osx__) == MIG_RTPS_OBJECT_NORMAL_META_CST_READER) || \
                                   ((osx__) == MIG_RTPS_OBJECT_RESERVED_META_CST_READER) || \
                                   ((osx__) == MIG_RTPS_OBJECT_NORMAL_META_SUBSCRIPTION) || \
                                   ((osx__) == MIG_RTPS_OBJECT_RESERVED_META_SUBSCRIPTION)) \
                                ? "builtin datareader" \
                                    : (((osx__) == MIG_RTPS_OBJECT_RESERVED_META_GROUP_READER) || \
                                       ((osx__) == MIG_RTPS_OBJECT_NORMAL_META_GROUP_READER)) \
                                    ? "builtin group datareader" \
                                        : (((osx__) == MIG_RTPS_OBJECT_RESERVED_META_GROUP_WRITER) || \
                                           ((osx__) == MIG_RTPS_OBJECT_NORMAL_META_GROUP_WRITER)) \
                                        ? "builtin group datawriter" \
                                            : ""

/* --------------------------------------------------------- */

/* --------------------------------------------------------- */
  /*RTPS.2.0*/
  #define MIGRtpsGuid_toString REDAOrderedDataType_toStringQuadInt
/* --------------------------------------------------------- */
/*RTPS.2.0*/
#define MIGRtpsGuid_copy(to__, from__) \
    RTIOsapiRtpsGuid_copy((to__), (from__))

/* --------------------------------------------------------- */
  /*RTPS.2.0*/
  #define MIGRtpsGuid_equals(a, b)   \
    RTIOsapiRtpsGuid_equals(a, b)

/* --------------------------------------------------------- */
  #define MIGRtpsGuid_isUnknown(me)   \
    ((me)->prefix.hostId   == MIG_RTPS_HOST_ID_UNKNOWN && \
     (me)->prefix.appId    == MIG_RTPS_APP_ID_UNKNOWN &&  \
     (me)->prefix.instanceId    == MIG_RTPS_INSTANCE_ID_UNKNOWN &&  \
     (me)->objectId == MIG_RTPS_OBJECT_ID_UNKNOWN)

/* --------------------------------------------------------- */
  #define MIGRtpsGuid_isAuto(me)   \
    ((me)->prefix.hostId   == MIG_RTPS_HOST_ID_AUTO && \
     (me)->prefix.appId    == MIG_RTPS_APP_ID_AUTO &&  \
     (me)->prefix.instanceId    == MIG_RTPS_INSTANCE_ID_AUTO &&  \
     (me)->objectId == MIG_RTPS_OBJECT_ID_AUTO)

/* --------------------------------------------------------- */
  #define MIGRtpsGuid_expand(me) \
    (me)->prefix.hostId, \
    (me)->prefix.appId, \
    (me)->prefix.instanceId, \
    (me)->objectId

/* --------------------------------------------------------- */
  /*
   * Expands the provided guid to 5 values: a string representing entity's
   * shortname ("DW", "DR", "DP") and expansion of the guid itself via
   * MIGRtpsGuid_expand.
   * @param me__ \b In. The guid of the entity.
   */
  #define MIGRtpsGuid_expandWithShortname(me__) \
    MIGRtpsObjectSuffix_getRWType(MIGRtpsGuid_getObjectSuffix(me__)) \
            == MIG_RTPS_RW_TYPE_WRITER \
                    ? ADVLOG_ENTITY_SHORTNAME_DATAWRITER \
                    : (MIGRtpsObjectSuffix_getRWType(MIGRtpsGuid_getObjectSuffix(me__)) \
                            == MIG_RTPS_RW_TYPE_READER \
                                    ? ADVLOG_ENTITY_SHORTNAME_DATAREADER \
                                    : ADVLOG_ENTITY_SHORTNAME_PARTICIPANT), \
            MIGRtpsGuid_expand(me__)

/* --------------------------------------------------------- */
#define MIGRtpsGuidPrefix_isUnknown(me__) \
    RTIOsapiGuidPrefix_isUnknown(me__)

/* --------------------------------------------------------- */
  #define MIGRtpsGuidPrefix_setUnknown(me)   \
    (me)->hostId = MIG_RTPS_HOST_ID_UNKNOWN; \
    (me)->appId = MIG_RTPS_APP_ID_UNKNOWN;  \
    (me)->instanceId = MIG_RTPS_INSTANCE_ID_UNKNOWN

/* --------------------------------------------------------- */
  #define MIGRtpsGuid_setUnknown(me)   \
    MIGRtpsGuidPrefix_setUnknown(&((me)->prefix)); \
    (me)->objectId = MIG_RTPS_OBJECT_ID_UNKNOWN

/* --------------------------------------------------------- */
  #define MIGRtpsGuidPrefix_expand(me) \
    (me)->hostId, \
    (me)->appId, \
    (me)->instanceId

/* --------------------------------------------------------- */
  /*
   * Expands the provided guid prefix to 4 values: a string representing
   * DP's shortname ("DP") and expansion of the guid prefix itself via
   * MIGRtpsGuidPrefix_expand.
   * @param me__ \b In. The guid prefix of the participant.
   */
  #define MIGRtpsGuidPrefix_expandWithShortname(me__) \
    ADVLOG_ENTITY_SHORTNAME_PARTICIPANT, \
    MIGRtpsGuidPrefix_expand(me__)

/* --------------------------------------------------------- */
  /*RTPS.2.0*/
  #define MIGRtpsParticipantId_equals(a, b) \
    RTIOsapiRtpsGuidPrefix_equals(a, b)

#define MIGRtpsGuidPrefix_equals MIGRtpsParticipantId_equals

#define MIGRtpsGuidPrefix_copy(me__, src__) \
    RTIOsapiRtpsGuidPrefix_copy((me__), (src__))

/* --------------------------------------------------------- */
  #define MIGRtpsObjectId_getObjectKey(oid) \
    ((MIGRtpsObjectKey)((oid) >> 8))
/* --------------------------------------------------------- */
  #define MIGRtpsObjectId_getObjectSuffix(oid) \
    ((MIGRtpsObjectSuffix)((oid) & 0x000000ff))
/* --------------------------------------------------------- */
  #define MIGRtpsObjectId_generate(oky, osx) \
    ((MIGRtpsObjectId)(((oky) << 8) | (osx)))
/* --------------------------------------------------------- */
/*
 * A group builtin entity's object ID is calculated using the containing
 * group's object ID. The objectId (that contains 1 byte of "kind" and 3 bytes
 * of "key") is formed by taking the key from the group entity, and setting
 * the kind to a X_GROUP_READER/WRITER. The reason for this (as opposed to
 * statically defining the object ID as we do for other builtin entities) is
 * that there can be multiple builtin group writer/reader per topic per
 * participant (up to 1 per group).
 *
 * We also support secure group builtins. These are identified by setting the
 * first byte of the objectId to 0xFF. This means that maximum
 * objectId for publishers and subscribers is 0x00FFFFFFXX (where XX denotes
 * the kind of entity).
 */
  #define MIGRtpsObjectId_makeGroupBuiltinSecure(oid) ((oid) | 0xFF000000)
/* --------------------------------------------------------- */
/*
 * @brief Removes the given suffix__ from a given objectId__. This operation
 * is the opposite of MIGRtpsObjectId_generate.
 */
  #define MIGRtpsObjectId_removeSuffix(objectId__, suffix__) \
    ((MIGRtpsObjectId) (((objectId__) & ~(suffix__)) >> 8))
/* --------------------------------------------------------- */
/* Only objects that are exposed in the dds_c layer have user objects.
 * This includes:
 * 1) All non-meta entities (those that are not used for discovery).
 * 2) Non-anonymous vendor-specific meta-entities.
 * 3) Security-related meta-entities.
 * 4) Group level reader / writers.
 */
  #define MIGRtpsObjectId_hasUserObject(oid) \
  ((!MIGRtpsObjectSuffix_isMeta(MIGRtpsObjectId_getObjectSuffix(oid))) || \
   ((MIGRtpsObjectSuffix_isMeta(MIGRtpsObjectId_getObjectSuffix(oid))) && \
    (((!MIGRtpsObjectSuffix_isReserved(MIGRtpsObjectId_getObjectSuffix(oid))) && \
      (oid != MIG_RTPS_OBJECT_ID_LOCATOR_PING_MESSAGE_WRITER) && \
      (oid != MIG_RTPS_OBJECT_ID_LOCATOR_PING_MESSAGE_READER) && \
      (oid != MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_BOOTSTRAP_READER) && \
      (oid != MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_BOOTSTRAP_WRITER) && \
      (oid != MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_RELIABLE_READER) && \
      (oid != MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_RELIABLE_WRITER) && \
      (oid != MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_SECURE_RELIABLE_READER) && \
      (oid != MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_SECURE_RELIABLE_WRITER)) || \
     (oid == MIG_RTPS_OBJECT_ID_STATELESS_MESSAGE_WRITER) || \
     (oid == MIG_RTPS_OBJECT_ID_STATELESS_MESSAGE_READER) || \
     (oid == MIG_RTPS_OBJECT_ID_SECURE_VOLATILE_MESSAGE_WRITER) || \
     (oid == MIG_RTPS_OBJECT_ID_SECURE_VOLATILE_MESSAGE_READER) || \
     MIGRtpsObjectSuffix_isGroupReaderWriter(MIGRtpsObjectId_getObjectSuffix(oid)))))

/* --------------------------------------------------------- */
/*
 * This covers all of the bootstrapping endpoints: those endpoints up to
 * (including) authentication.
 */
#define MIGRtpsObjectId_isBootstrappingWriter(oid__) \
    ((oid__) == MIG_RTPS_OBJECT_ID_STATELESS_MESSAGE_WRITER \
        || MIGRtpsObjectId_isParticipantAnnouncementWriter(oid__))

#define MIGRtpsObjectId_isBootstrappingReader(oid__) \
    ((oid__) == MIG_RTPS_OBJECT_ID_STATELESS_MESSAGE_READER \
        || MIGRtpsObjectId_isParticipantAnnouncementReader(oid__))

/*
 * This covers all of the endpoints that do not use regular RTPS protection
 * (but they can still use PSK-based RTPS protection).
 *
 * It includes the bootstrapping endpoints, and the secure volatile writer and
 * reader. The secure volatile endpoints can't have regular RTPS protection
 * because they are the ones used for sharing the keys.
 */
#define MIGRtpsObjectId_isNeverRtpsProtectedWriter(oid__) \
    (MIGRtpsObjectId_isBootstrappingWriter(oid__) \
        || (oid__) == MIG_RTPS_OBJECT_ID_SECURE_VOLATILE_MESSAGE_WRITER)

#define MIGRtpsObjectId_isNeverRtpsProtectedReader(oid__) \
    (MIGRtpsObjectId_isBootstrappingReader(oid__) \
        || (oid__) == MIG_RTPS_OBJECT_ID_SECURE_VOLATILE_MESSAGE_READER)

/* --------------------------------------------------------- */
/*
 * Return the maximum length of a sample for a given channel. Useful to
 * protect the never encoding channels from some tampered messages that
 * force big memory allocations
 */
#define MIGRtpsObjectId_getMaxSampleLength(objectId__, unprotectedMaxLength__) \
    ((MIGRtpsObjectId_isBootstrappingWriter(objectId__)                \
             || MIGRtpsObjectId_isBootstrappingReader(objectId__))     \
                    ? (unprotectedMaxLength__)                         \
                    : RTI_CDR_MAX_SERIALIZED_SIZE)

#define MIGRtpsObjectSuffix_isGroupReaderWriter(osx__) \
    (((osx__) & 0x0F) == 0x0B || ((osx__) & 0x0F) == 0x0C || \
     ((osx__) & 0x0F) == 0x0D || ((osx__) & 0x0F) == 0x0E)

/* --------------------------------------------------------- */
/*
 * This macro checks if the endpoint supports directed writes.
 * Currently, the only endpoints not supporting directed writes are the pure
 * anonymous ones. For more information about "pure" and "non-pure" anonymous
 * endpoints, please refer to COMMENDAnonWriterService.
 */
  #define MIGRtpsObjectId_supportsDirectedWrites(oid) \
    (((oid) != MIG_RTPS_OBJECT_ID_SPDP_PARTICIPANT_WRITER) && \
     ((oid) != MIG_RTPS_OBJECT_ID_LOCATOR_PING_MESSAGE_WRITER) && \
     ((oid) != MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_BOOTSTRAP_WRITER))

/* --------------------------------------------------------- */
/*
 * This macro checks if the endpoint is a secure builtin endpoint.
 */
  #define MIGRtpsObjectId_isSecureBuiltin(oid) \
    ((MIGRtpsObjectSuffix_isMeta(MIGRtpsObjectId_getObjectSuffix(oid))) \
        && ((0xFF000000 & oid) == 0xFF000000))
/* --------------------------------------------------------- */
/*
 * This macro checks if the endpoint is a non-secure builtin endpoint.
 */
  #define MIGRtpsObjectId_isNonSecureBuiltin(oid) \
    ((MIGRtpsObjectSuffix_isMeta(MIGRtpsObjectId_getObjectSuffix(oid))) \
        && ((0xFF000000 & oid) != 0xFF000000))
/* --------------------------------------------------------- */
/*
 * This macro checks if the endpoint supports using the secure volatile channel
 * for key exchange. With the exception of the secure volatile endpoints
 * themselves, this includes all the endpoints exposed to the user and
 * secure builtin endpoints.
 */
  #define MIGRtpsObjectId_supportsKeyExchange(oid) \
    (((oid) != MIG_RTPS_OBJECT_ID_SECURE_VOLATILE_MESSAGE_WRITER) \
            && ((oid) != MIG_RTPS_OBJECT_ID_SECURE_VOLATILE_MESSAGE_READER) \
            && (MIGRtpsObjectId_hasUserObject(oid) \
                    || ((0xFF000000 & (oid)) == 0xFF000000)))
/*
 * This macro converts an object ID to a string that describes what kind of
 * object the ID is for.
 */
 #define MIGRtpsObjectId_getString(oid__) \
    MIGRtpsObjectSuffix_getString(MIGRtpsObjectId_getObjectSuffix(oid__))

/*
 * Check if a objectId belongs to an external builtin endpoint.
 * A external built-in endpoints are built-in endpoints created by the application
 * (e.g, Monitoring library).
 */
#define MIGRtpsObjectId_isExternalBuiltin(oid__) \
    ((oid__) == MIG_RTPS_OBJECT_ID_MONITORING_PERIODIC_WRITER \
            || (oid__) == MIG_RTPS_OBJECT_ID_MONITORING_PERIODIC_READER \
            || (oid__) == MIG_RTPS_OBJECT_ID_MONITORING_EVENT_WRITER \
            || (oid__) == MIG_RTPS_OBJECT_ID_MONITORING_EVENT_READER \
            || (oid__) == MIG_RTPS_OBJECT_ID_MONITORING_LOGGING_WRITER \
            || (oid__) == MIG_RTPS_OBJECT_ID_MONITORING_LOGGING_READER)

/* --------------------------------------------------------- */
/* This macro checks if a given entity is stateless. Currently, this means
 * that the commend entity is anonymous. Since this macro uses instance ids
 * as input, it also requires providing isMeta and isVendor flags. Note that
 * we are shifting the reference object-ids, and therefore we only need to use
 * one of them (writer or reader) per channel. */
#define MIGRtpsObjectKey_isStateless(oky, isMeta, isVendor) \
    (!isMeta ? RTI_FALSE : \
            (isVendor \
                    ? ((oky == (MIG_RTPS_OBJECT_ID_LOCATOR_PING_MESSAGE_WRITER >> 8)) \
                            || (oky == (MIG_RTPS_OBJECT_ID_SPDP2_BUILTIN_PARTICIPANT_BOOTSTRAP_WRITER >> 8))) \
                    : ((oky == (MIG_RTPS_OBJECT_ID_SPDP_PARTICIPANT_WRITER >> 8))\
                            || (oky == (MIG_RTPS_OBJECT_ID_STATELESS_MESSAGE_WRITER >> 8)))))

/* --------------------------------------------------------- */
  #define MIGRtpsGuid_getObjectSuffix(guid) \
    ((MIGRtpsObjectSuffix)((guid)->objectId & 0x000000ff))
/* --------------------------------------------------------- */
  #define MIGRtpsProtocolVersion_getMajor(version) (*(version) >> 8)
/* --------------------------------------------------------- */
  #define MIGRtpsProtocolVersion_getMinor(version) (*(version) & 0x00ff)

/* --------------------------------------------------------- */
  #define MIGRtpsProductVersion_expand(version__) \
    (version__).major, \
    (version__).minor, \
    (version__).release, \
    (version__).revision


/* --------------------------------------------------------- */
  #define MIGRtpsVendorId_isPro(vendor) \
          (*(vendor) == MIG_RTPS_VENDOR_ID_RTI)

/* --------------------------------------------------------- */
  #define MIGRtpsVendorId_isMicro(vendor) \
          (*(vendor) == MIG_RTPS_VENDOR_ID_RTI_MICRO)

/* --------------------------------------------------------- */
  #define MIGRtpsVendorId_isRTI(vendor) \
        (MIGRtpsVendorId_isPro(vendor) || MIGRtpsVendorId_isMicro(vendor))

/* --------------------------------------------------------- */
  #define MIGRtpsVendorId_getMajor(vendor)         (*(vendor) >> 8)
/* --------------------------------------------------------- */
  #define MIGRtpsVendorId_getMinor(vendor)         (*(vendor) & 0x00ff)

/* --------------------------------------------------------- */
  #define MIGRtpsSequenceNumber_deserializeMacro(sn, streamPtr, needByteSwap) \
    (                                                                  \
      needByteSwap ? (                                                 \
        *(((char *)(&((sn)->high))) + 3) = *((*(streamPtr))++),        \
        *(((char *)(&((sn)->high))) + 2) = *((*(streamPtr))++),        \
        *(((char *)(&((sn)->high))) + 1) = *((*(streamPtr))++),        \
        *(((char *)(&((sn)->high)))    ) = *((*(streamPtr))++),        \
        *(((char *)(&((sn)->low)))  + 3) = *((*(streamPtr))++),        \
        *(((char *)(&((sn)->low)))  + 2) = *((*(streamPtr))++),        \
        *(((char *)(&((sn)->low)))  + 1) = *((*(streamPtr))++),        \
        *(((char *)(&((sn)->low)))     ) = *((*(streamPtr))++),        \
        RTI_TRUE                                                       \
      ) : (                                                            \
        (sn)->high = *((RTI_INT32 *)(*(streamPtr))), *(streamPtr) += 4,\
	(sn)->low = *((RTI_UINT32 *)(*(streamPtr))), *(streamPtr) += 4,\
        RTI_TRUE                                                       \
      )                                                                \
    )

  #ifndef RTI_PRECONDITION_TEST
    #define MIGRtpsSequenceNumber_deserialize \
      MIGRtpsSequenceNumber_deserializeMacro
  #endif

/* --------------------------------------------------------- */
  #define MIGRtpsEpoch_deserializeMacro(me, streamPtr, needByteSwap) \
    (                                                                 \
      needByteSwap ? (                                                \
        *(((char *)(me)) + 3) = *((*(streamPtr))++),                  \
        *(((char *)(me)) + 2) = *((*(streamPtr))++),                  \
        *(((char *)(me)) + 1) = *((*(streamPtr))++),                  \
        *(((char *)(me))    ) = *((*(streamPtr))++),                  \
        RTI_TRUE                                                      \
      ) : (                                                           \
        *(me) = *((REDAEpoch*)(*(streamPtr))), *(streamPtr) += 4,     \
        RTI_TRUE                                                      \
      )                                                               \
    )

  #ifndef RTI_PRECONDITION_TEST
    #define MIGRtpsEpoch_deserialize MIGRtpsEpoch_deserializeMacro
  #endif

/* --------------------------------------------------------- */
    #define MIGRtps_deserializeUnsignedShortMacro(twobytes, data, needByteSwap) \
    (                                                                           \
        needByteSwap ? (                                                        \
            *(((char *)(twobytes)) + 1) = *((*(data))++),                       \
            *(((char *)(twobytes))    ) = *((*(data))++),                       \
            RTI_TRUE                                                            \
        ) : (                                                                   \
            *(twobytes) = *((unsigned short *)(*(data))),                       \
            *(data) += 2,                                                       \
            RTI_TRUE                                                            \
        )                                                                       \
    )                                                                           \

    #ifndef RTI_PRECONDITION_TEST
        #define MIGRtps_deserializeUnsignedShort MIGRtps_deserializeUnsignedShortMacro
    #endif

/* --------------------------------------------------------- */
    #define MIGRtps_deserializeUnsignedLongMacro(fourbytes, data, needByteSwap) \
    (                                                                           \
        needByteSwap ? (                                                        \
            *(((char *)(fourbytes)) + 3) = *((*(data))++),                      \
            *(((char *)(fourbytes)) + 2) = *((*(data))++),                      \
            *(((char *)(fourbytes)) + 1) = *((*(data))++),                      \
            *(((char *)(fourbytes))    ) = *((*(data))++),                      \
            RTI_TRUE                                                            \
        ) : (                                                                   \
            *(fourbytes) = *((RTI_UINT32 *)(*(data))),                       \
            *(data) += 4,                                                       \
            RTI_TRUE                                                            \
        )                                                                       \
    )                                                                           \

    #ifndef RTI_PRECONDITION_TEST
        #define MIGRtps_deserializeUnsignedLong MIGRtps_deserializeUnsignedLongMacro
    #endif

/* --------------------------------------------------------- */
    #define MIGRtps_skipNBytesFast(stream, n) \
	stream+=n

/* --------------------------------------------------------- */
    #define MIGRtpsGuidPrefix_compareMacro(left, right) \
        (((left)->hostId > (right)->hostId) ? 1 : \
          (((left)->hostId < (right)->hostId) ? -1 : \
           (((left)->appId > (right)->appId) ? 1 : \
            (((left)->appId < (right)->appId) ? -1 : \
             (((left)->instanceId > (right)->instanceId) ? 1 : \
              (((left)->instanceId < (right)->instanceId) ? -1 : 0))))))

  #ifndef RTI_PRECONDITION_TEST
    #define MIGRtpsGuidPrefix_compare MIGRtpsGuidPrefix_compareMacro
  #endif

/* --------------------------------------------------------- */
#define MIGRtpsGuid_compareMacro(left__, right__) \
        ((MIGRtpsGuidPrefix_compare(&(left__)->prefix, &(right__)->prefix) != 0) \
                ? MIGRtpsGuidPrefix_compare(&(left__)->prefix, &(right__)->prefix) \
                : (((left__)->objectId > (right__)->objectId) \
                        ? 1 \
                        : (((left__)->objectId < (right__)->objectId) \
                                ? -1 \
                                : 0)))

#ifndef RTI_PRECONDITION_TEST
    #define MIGRtpsGuid_compare MIGRtpsGuid_compareMacro
#endif

struct MIGRtpsBitmap {
    /* lead sequence */
    struct REDASequenceNumber _lead;
    /* The size of the bitmap in the number of bits. */
    RTI_INT32 _bitCount;
    /* The bitmap stored as an array of integers.

       NOTE1: This must be unsigned in order to apply the >> operator.
       NOTE2: There are two approaches to handle bits outside bitCount:
                  1) They must always be zeroed.
		  2) They can be anything.
	      The first approach puts the burden on otherwise simple
	      methods such as truncate to zero out truncated bits, whereas
	      the second approach puts the burden on methods such as shift
	      to make sure bits beyond the bitCount are not shifted in.
	      In our implementation, we have opted for the second approach. */
    RTI_UINT32 _bits[MIG_RTPS_BITMAP_32BITS_ARRAY_SIZE_MAX];
};


  #define MIGRtpsBitmap_INITIALIZER { \
    REDA_SEQUENCE_NUMBER_ZERO, /* _lead */ \
    0, /* _bitCount */ \
    {0, 0, 0, 0, 0, 0, 0, 0}, /* _bits */ \
  }

/* --------------------------------------------------------- */
  #define MIGRtpsBitmap_getLead(a) (&(a)->_lead)
/* --------------------------------------------------------- */
  #define MIGRtpsBitmap_getBitCount(a) (a)->_bitCount
/* --------------------------------------------------------- */
  #define MIGRtpsBitmap_resetMacro(a, seqNum, bitCount)                     \
  {                                                                    \
    register int MIGRtpsBitmap_g_resetI = 0;                           \
    (a)->_lead = *(seqNum);                                            \
    (a)->_bitCount = (bitCount);                                       \
    for (MIGRtpsBitmap_g_resetI=0;                                     \
         MIGRtpsBitmap_g_resetI<MIG_RTPS_BITMAP_32BITS_ARRAY_SIZE_MAX; \
         ++MIGRtpsBitmap_g_resetI) {                                   \
        (a)->_bits[MIGRtpsBitmap_g_resetI] = 0;                      \
    }                                                                  \
  }
  #ifndef RTI_PRECONDITION_TEST
    #define MIGRtpsBitmap_reset MIGRtpsBitmap_resetMacro
  #endif

/* --------------------------------------------------------- */
  #define MIGRtpsBitmap_containsBitMacro(bitMap__, seqNum__) \
      ((REDASequenceNumber_compare((seqNum__), &(bitMap__)->_lead) < 0) \
              ? RTI_FALSE \
              : (!MIGRtpsBitmap_isDistanceValid( \
                      (bitMap__), \
                      MIGRtpsSequenceNumber_getDistance(&(bitMap__)->_lead, (seqNum__)))) \
                              ? RTI_FALSE : RTI_TRUE)
    
  #ifndef RTI_PRECONDITION_TEST
    #define MIGRtpsBitmap_containsBit MIGRtpsBitmap_containsBitMacro
  #endif

/* --------------------------------------------------------- */
  #define MIGRtpsBitmap_getSerializedSize(bitmap) \
      12 + (int) sizeof(RTI_INT32)*(((bitmap)->_bitCount + 31)/32)
/* --------------------------------------------------------- */
  #define MIGRtpsBitmap_isMalformed(me__) \
    (((me__)->_bitCount > MIG_RTPS_BITMAP_SIZE_MAX) || ((me__)->_bitCount < 0))
/* --------------------------------------------------------- */
  #define MIGRtpsBitmap_isDistanceValid(me__, distance__) \
        ((distance__ ) >= 0 && (distance__) < (me__)->_bitCount)
/* --------------------------------------------------------- */

/*i
 * We are going to translate from submessage ID to submessage name.
 * In order to do that conversion efficient, we are going to create three arrays:
 * - Common RTPS submessages MIG_RTPS_SUBMESSAGE_BASIC_NAMES
 * - Secure RTPS submessages MIG_RTPS_SUBMESSAGE_SECURE_NAMES
 * - Vendor RTPS submessages MIG_RTPS_SUBMESSAGE_VENDOR_NAMES
 *
 * The reason of creating three instead of one is because we want to avoid having
 * holes in the array. So, we are going to be able to map directly (without any
 * conversion) the numeric value of the submessage Id to array indexes.
 *
 * For each array we are going to have a maximum and a minimum in order to know
 * which array to use.
 *  -If: Id < MIG_RTPS_SUBMESSAGE_BASIC_ID_MAX -> MIG_RTPS_SUBMESSAGE_BASIC_NAMES
 *  -Else If Id < MIG_RTPS_SUBMESSAGE_SECURE_ID_MAX -> MIG_RTPS_SUBMESSAGE_SECURE_NAMES
 *  -Else If Id < MIG_RTPS_SUBMESSAGE_VENDOR_ID_MAX -> MIG_RTPS_SUBMESSAGE_VENDOR_NAMES
 *
 * We are directly mapping submessage ids to positions in the array
 * without any conversion for better performance.
 * Therefore we compute the size of the array as number of submessage
 * kind elements in the range, then we add the starting offset for the first
 * element.
 */
#define MIG_RTPS_SUBMESSAGE_BASIC_ID_MIN MIG_RTPS_HEADER_EXTENSION
#define MIG_RTPS_SUBMESSAGE_BASIC_ID_MAX MIG_RTPS_HEARTBEAT_VIRTUAL
#define MIG_RTPS_SUBMESSAGE_BASIC_KINDS_SIZE \
        MIG_RTPS_SUBMESSAGE_BASIC_ID_MAX + 1

#define MIG_RTPS_SUBMESSAGE_SECURE_ID_MIN MIG_RTPS_SECURE_BODY
#define MIG_RTPS_SUBMESSAGE_SECURE_ID_MAX MIG_RTPS_SECURE_RTPS_POSTFIX
#define MIG_RTPS_SUBMESSAGE_SECURE_KINDS_SIZE \
        MIG_RTPS_SUBMESSAGE_SECURE_ID_MAX \
        - MIG_RTPS_SUBMESSAGE_SECURE_ID_MIN \
        + 1

#define MIG_RTPS_SUBMESSAGE_VENDOR_ID_MIN MIG_RTPS_CRC32
#define MIG_RTPS_SUBMESSAGE_VENDOR_ID_MAX MIG_RTPS_BINDING_PING
#define MIG_RTPS_SUBMESSAGE_VENDOR_KINDS_SIZE \
        MIG_RTPS_SUBMESSAGE_VENDOR_ID_MAX \
        - MIG_RTPS_SUBMESSAGE_VENDOR_ID_MIN \
        + 1

#define MIG_RTPS_SUBMESSAGE_ID_MIN MIG_RTPS_SUBMESSAGE_BASIC_ID_MIN
#define MIG_RTPS_SUBMESSAGE_ID_MAX MIG_RTPS_SUBMESSAGE_VENDOR_ID_MAX

extern MIGDllVariable
const char *MIG_RTPS_SUBMESSAGE_BASIC_NAMES[MIG_RTPS_SUBMESSAGE_BASIC_KINDS_SIZE];

extern MIGDllVariable
const char *MIG_RTPS_SUBMESSAGE_SECURE_NAMES[MIG_RTPS_SUBMESSAGE_SECURE_KINDS_SIZE];

extern MIGDllVariable
const char *MIG_RTPS_SUBMESSAGE_VENDOR_NAMES[MIG_RTPS_SUBMESSAGE_VENDOR_KINDS_SIZE];


/*e \ingroup MIGRtpsClass
 * @brief Get submessage name for diagnosis
 * @param id__ \b In. The submessage Id.
 * @pre  MIG_RTPS_SUBMESSAGE_ID_MIN =< id__ =< MIG_RTPS_SUBMESSAGE_ID_MAX
 *
 * It is macroed for performance
 */
extern MIGDllExport const char *MIGRtpsSubmessageId_toString(RTI_UINT8 id);


/*
 * IMPORTANT: A copy of this macro is implemented as a function in
 * mig.2.0/src/rtps/SubmessageId.c for #ifdef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
 */
#ifndef RTI_ENABLE_CPPCHECK_SUPPRESSIONS
  #define MIGRtpsSubmessageId_toString(id__) \
      (MIGRtpsSubmessageId_isOutsideValidRange(id__)) \
          ? "INVALID" \
          : (((id__) <= MIG_RTPS_SUBMESSAGE_BASIC_ID_MAX) \
              ? MIG_RTPS_SUBMESSAGE_BASIC_NAMES[(id__)] \
              : ((id__) <= MIG_RTPS_SUBMESSAGE_SECURE_ID_MAX) \
                  ? MIG_RTPS_SUBMESSAGE_SECURE_NAMES[( \
                          id__) -MIG_RTPS_SUBMESSAGE_SECURE_ID_MIN] \
                  : MIG_RTPS_SUBMESSAGE_VENDOR_NAMES[( \
                          id__) -MIG_RTPS_SUBMESSAGE_VENDOR_ID_MIN])
#endif



struct MIGRtpsSubmessageStats {
    /*
     * Count for each type of submessages received.
     * - Those counters are incremented using MIGRtpsSubmessageStats_incrementCount
     * - Those counters are got using MIGRtpsSubmessageStats_getCount
     */
    unsigned int basicSubmessageCount[MIG_RTPS_SUBMESSAGE_BASIC_KINDS_SIZE];
    unsigned int secureSubmessageCount[MIG_RTPS_SUBMESSAGE_SECURE_KINDS_SIZE];
    unsigned int vendorSubmessageCount[MIG_RTPS_SUBMESSAGE_VENDOR_KINDS_SIZE];
};


#define MIGRtpsSubmessageStats_INITIALIZER {                         \
    {0}, /* basicSubmessageCount[MIG_RTPS_SUBMESSAGE_BASIC_KINDS_SIZE] */ \
    {0}, /* secureSubmessageCount[MIG_RTPS_SUBMESSAGE_SECURE_KINDS_SIZE] */ \
    {0}, /* vendorSubmessageCount[MIG_RTPS_SUBMESSAGE_VENDOR_KINDS_SIZE] */ \
}

#define MIGRtpsSubmessageId_isOutsideValidRange(id__) \
    ((id__) > MIG_RTPS_SUBMESSAGE_ID_MAX \
            || (id__) < MIG_RTPS_SUBMESSAGE_ID_MIN \
            || ((id__) > MIG_RTPS_SUBMESSAGE_BASIC_ID_MAX \
                    && (id__) < MIG_RTPS_SUBMESSAGE_SECURE_ID_MIN) \
            || ((id__) > MIG_RTPS_SUBMESSAGE_SECURE_ID_MAX \
                    && (id__) < MIG_RTPS_SUBMESSAGE_VENDOR_ID_MIN))

/*e \ingroup MIGRtpsClass
 * @brief Increment by one the counter assigned to submessage Id statistic.
 * @param submessageStats__ \b In. The submenssage statistic
 * @param id__ \b In. The submessage Id.
 *
 * It is macroed for performance
 */
#define MIGRtpsSubmessageStats_incrementCount(submessageStats__, id__) \
    if (MIGRtpsSubmessageId_isOutsideValidRange(id__)) { \
        /* value is outside valid ranges: noop */ \
    } else if ((id__) <= MIG_RTPS_SUBMESSAGE_BASIC_ID_MAX) { \
        ++(submessageStats__)->basicSubmessageCount[(id__)]; \
    } else if ((id__) <= MIG_RTPS_SUBMESSAGE_SECURE_ID_MAX) { \
        ++(submessageStats__)->secureSubmessageCount[(id__)  - MIG_RTPS_SUBMESSAGE_SECURE_ID_MIN]; \
    } else if ((id__) <= MIG_RTPS_SUBMESSAGE_VENDOR_ID_MAX) { \
        ++(submessageStats__)->vendorSubmessageCount[(id__) - MIG_RTPS_SUBMESSAGE_VENDOR_ID_MIN]; \
    }

/*e \ingroup MIGRtpsClass
 * @brief Get the statistic for a submessage Id.
 * @param submessageStats__ \b In. The submenssage statistic
 * @param id__ \b In. The submessage Id.
 *
 * It is macroed for performance
 */
#define MIGRtpsSubmessageStats_getCount(submessageStats__, id__) \
( \
    (MIGRtpsSubmessageId_isOutsideValidRange(id__)) \
        ? 0 \
        : (((id__) <= MIG_RTPS_SUBMESSAGE_BASIC_ID_MAX) \
            ? ((submessageStats__)->basicSubmessageCount[(id__)]) \
            : (((id__) <= MIG_RTPS_SUBMESSAGE_SECURE_ID_MAX) \
                ? ((submessageStats__)->secureSubmessageCount[(id__) - MIG_RTPS_SUBMESSAGE_SECURE_ID_MIN]) \
                : ((submessageStats__)->vendorSubmessageCount[(id__) - MIG_RTPS_SUBMESSAGE_VENDOR_ID_MIN]))) \
)

/* --------------------------------------------------------- */


extern MIGDllExport
RTIBool MIGRtps_serialize2Octets(
    void *endpointData,
    const RTICdrUnsignedShort *in,
    struct RTICdrStream *stream,
    RTIBool serializeEncapsulation,
    RTIEncapsulationId encapsulationId,
    RTIBool serializeSample,
    void *endpointPluginQos);

extern MIGDllExport
RTIBool MIGRtps_deserialize2Octets(
    RTICdrUnsignedShort *out,
    struct RTICdrStream *stream);

extern MIGDllExport
unsigned int MIGRtps_get2OctetsMaxSizeSerialized(
    unsigned int size);


  #define MIGRtps_serializeProtocolVersion   MIGRtps_serialize2Octets
  #define MIGRtps_deserializeProtocolVersion MIGRtps_deserialize2Octets
  #define MIGRtps_getProtocolVersionMaxSizeSerialized \
     MIGRtps_get2OctetsMaxSizeSerialized

  #define MIGRtps_serializeVendorId   MIGRtps_serialize2Octets
  #define MIGRtps_deserializeVendorId MIGRtps_deserialize2Octets
  #define MIGRtps_getVendorIdMaxSizeSerialized \
     MIGRtps_get2OctetsMaxSizeSerialized

#define MIGRtpsKeyHash_compare(_left, _right)  	                                        \
    (((_left)->length < (_right)->length) ? -1 :		                        \
	 ((_left)->length > (_right)->length) ? 1 :		                        \
	 RTIOsapiMemory_compare((_left)->value, (_right)->value, (_left)->length))    

#define MIGRtpsKeyHash_copy(_dest, _src) (*(_dest) = *(_src))

#define MIGRtpsKeyHash_setDefault(keyHash__) {   \
struct MIGRtpsKeyHash _defaultKeyHash =         \
MIG_RTPS_KEY_HASH_DEFAULT;                      \
MIGRtpsKeyHash_copy(                            \
(keyHash__), &_defaultKeyHash);                  \
}

#define MIGRtpsKeyHash_equals(_left, _right)        \
(MIGRtpsKeyHash_compare((_left), (_right)) == 0)

#ifdef RTI_ENDIAN_LITTLE
#define MIGRtpsKeyHash_fromGuid(keyHash__, guid__)                                                    \
(keyHash__)->length = MIG_RTPS_KEY_HASH_MAX_LENGTH;                                                  \
*((keyHash__)->value    ) = *((const RTICdrOctet *)(&(guid__)->prefix.hostId) + 3);                         \
*((keyHash__)->value + 1) = *((const RTICdrOctet *)(&(guid__)->prefix.hostId) + 2);                         \
*((keyHash__)->value + 2) = *((const RTICdrOctet *)(&(guid__)->prefix.hostId) + 1);                         \
*((keyHash__)->value + 3) = *((const RTICdrOctet *)(&(guid__)->prefix.hostId)    );                         \
*((keyHash__)->value + 4) = *((const RTICdrOctet *)(&(guid__)->prefix.appId) + 3);                          \
*((keyHash__)->value + 5) = *((const RTICdrOctet *)(&(guid__)->prefix.appId) + 2);                          \
*((keyHash__)->value + 6) = *((const RTICdrOctet *)(&(guid__)->prefix.appId) + 1);                          \
*((keyHash__)->value + 7) = *((const RTICdrOctet *)(&(guid__)->prefix.appId)    );                          \
*((keyHash__)->value + 8) = *((const RTICdrOctet *)(&(guid__)->prefix.instanceId) + 3);                     \
*((keyHash__)->value + 9) = *((const RTICdrOctet *)(&(guid__)->prefix.instanceId) + 2);                     \
*((keyHash__)->value + 10) = *((const RTICdrOctet *)(&(guid__)->prefix.instanceId) + 1);                    \
*((keyHash__)->value + 11) = *((const RTICdrOctet *)(&(guid__)->prefix.instanceId)    );                    \
*((keyHash__)->value + 12) = *((const RTICdrOctet *)(&(guid__)->objectId) + 3);                             \
*((keyHash__)->value + 13) = *((const RTICdrOctet *)(&(guid__)->objectId) + 2);                             \
*((keyHash__)->value + 14) = *((const RTICdrOctet *)(&(guid__)->objectId) + 1);                             \
*((keyHash__)->value + 15) = *((const RTICdrOctet *)(&(guid__)->objectId)    );                             
#else
#define MIGRtpsKeyHash_fromGuid(keyHash__, guid__)                        \
(keyHash__)->length = MIG_RTPS_KEY_HASH_MAX_LENGTH;                      \
*(RTI_UINT32 *)((keyHash__)->value) = (guid__)->prefix.hostId;            \
*(RTI_UINT32 *)((keyHash__)->value + 4) = (guid__)->prefix.appId;         \
*(RTI_UINT32 *)((keyHash__)->value + 8) = (guid__)->prefix.instanceId;    \
*(RTI_UINT32 *)((keyHash__)->value + 12) = (guid__)->objectId;                                
#endif

#ifdef RTI_ENDIAN_LITTLE
#define MIGRtpsGuid_fromKeyHash(guid__, keyHash__)                                        \
*((RTICdrOctet *)(&(guid__)->prefix.hostId)    ) = *((keyHash__)->value + 3);             \
*((RTICdrOctet *)(&(guid__)->prefix.hostId) + 1) = *((keyHash__)->value + 2);             \
*((RTICdrOctet *)(&(guid__)->prefix.hostId) + 2) = *((keyHash__)->value + 1);             \
*((RTICdrOctet *)(&(guid__)->prefix.hostId) + 3) = *((keyHash__)->value    );             \
*((RTICdrOctet *)(&(guid__)->prefix.appId)    ) = *((keyHash__)->value + 7);              \
*((RTICdrOctet *)(&(guid__)->prefix.appId) + 1) = *((keyHash__)->value + 6);              \
*((RTICdrOctet *)(&(guid__)->prefix.appId) + 2) = *((keyHash__)->value + 5);              \
*((RTICdrOctet *)(&(guid__)->prefix.appId) + 3) = *((keyHash__)->value + 4);              \
*((RTICdrOctet *)(&(guid__)->prefix.instanceId)    ) = *((keyHash__)->value + 11);        \
*((RTICdrOctet *)(&(guid__)->prefix.instanceId) + 1) = *((keyHash__)->value + 10);        \
*((RTICdrOctet *)(&(guid__)->prefix.instanceId) + 2) = *((keyHash__)->value + 9);         \
*((RTICdrOctet *)(&(guid__)->prefix.instanceId) + 3) = *((keyHash__)->value + 8);         \
*((RTICdrOctet *)(&(guid__)->objectId)    ) = *((keyHash__)->value + 15);                 \
*((RTICdrOctet *)(&(guid__)->objectId) + 1) = *((keyHash__)->value + 14);                 \
*((RTICdrOctet *)(&(guid__)->objectId) + 2) = *((keyHash__)->value + 13);                 \
*((RTICdrOctet *)(&(guid__)->objectId) + 3) = *((keyHash__)->value + 12);                        
#else
#define MIGRtpsGuid_fromKeyHash(guid__, keyHash__ )                       \
(guid__)->prefix.hostId = *(RTI_UINT32 *)((keyHash__)->value);            \
(guid__)->prefix.appId = *(RTI_UINT32 *)((keyHash__)->value + 4);         \
(guid__)->prefix.instanceId = *(RTI_UINT32 *)((keyHash__)->value + 8);    \
(guid__)->objectId = *(RTI_UINT32 *)((keyHash__)->value + 12);                                
#endif



#define MIGRtpsWriterInfoList_saveState(me,state) \
    if ((me)->_writerInfoList != NULL) { \
        (state)->_currentWriterInfo = (me)->_currentNode; \
        if ((state)->_currentWriterInfo != NULL) { \
            (state)->_currentVirtualWriterInfo = (state)->_currentWriterInfo->_currentNode; \
        } else { \
            (state)->_currentVirtualWriterInfo = NULL; \
        } \
    } else { \
        (state)->_currentWriterInfo = NULL; \
        (state)->_currentVirtualWriterInfo = NULL; \
        (state)->_virtualWriterInfoList = *(me); \
    }

#define MIGRtpsWriterInfoList_restoreState(me,state) \
    if ((me)->_writerInfoList != NULL) { \
        (me)->_currentNode = (state)->_currentWriterInfo; \
        if ((me)->_currentNode != NULL) { \
            (me)->_currentNode->_currentNode = (state)->_currentVirtualWriterInfo; \
        } \
    } else { \
        *(me) = (state)->_virtualWriterInfoList; \
    }


#define MIGRtpsDomainTag_compare(tag1, tag2) \
    (REDAString_compare((tag1 == NULL) ? "" : tag1, (tag2 == NULL) ? "" : tag2))


#define MIGRtpsDomainTag_isDefault(self) \
    (MIGRtpsDomainTag_compare(self, MIG_RTPS_DOMAIN_TAG_DEFAULT) == 0)


#define MIGRtps_serializeParameterSequenceSentinelFast(stream__) \
    { \
        RTIXCdrUnsignedShort sentinel__ = MIG_RTPS_PID_SENTINEL; \
        RTIXCdrUnsignedShort zero__ = 0; \
        RTIXCdrStream_serialize2ByteFast( \
                (stream__), \
                &sentinel__); \
        RTIXCdrStream_serialize2ByteFast( \
                (stream__), \
                &zero__); \
    }



/* Number of bitmaps (4) + bitmap value (4) + number of signatures (4) */
#define MIG_RTPS_FILTER_SIGNATURE_PARAMETER_LENGTH_WITHOUT_SIGNATURES 12

#define MIGRtps_serializeFilterSignatureParameterPrefixFast( \
          stream__, \
          bitmap__, \
          signatureCount__) \
    { \
        RTIXCdrUnsignedShort sentinel__ = MIG_RTPS_PID_FILTER_SIGNATURE; \
        RTIXCdrUnsignedLong numBitmaps__ = 1; \
        RTIXCdrUnsignedLong bitmapVal__ = \
                (RTIXCdrUnsignedLong) bitmap__; \
        RTIXCdrUnsignedLong signatureCountVal__ = \
                (RTIXCdrUnsignedLong) signatureCount__; \
        /* Parameter header */ \
        RTIXCdrStream_serialize2ByteFast((stream__), &sentinel__); \
        sentinel__ = (RTIXCdrUnsignedShort) \
                (MIG_RTPS_FILTER_SIGNATURE_PARAMETER_LENGTH_WITHOUT_SIGNATURES \
                        + (signatureCount__) * sizeof(struct COMMENDFilterSignature)); \
        RTIXCdrStream_serialize2ByteFast( \
                (stream__), \
                &sentinel__); \
        /* Number of bitmaps */ \
        RTICdrStream_serialize4ByteFast((stream__), &numBitmaps__); \
        /* Signature bitmap containing filtering results */ \
        RTICdrStream_serialize4ByteFast((stream__), &bitmapVal__); \
        /* Number of signatures */ \
        RTICdrStream_serialize4ByteFast((stream__), &signatureCountVal__); \
    }



/*
 * Translates RTPS Header Extension's flag to CRC algorithm kind.
 *
 * The RTPS 2.5 specification defines three different possible checksum kinds,
 * which depend on the combination of both MIG_RTPS_HE_CHECKSUM1_FLAG and
 * MIG_RTPS_HE_CHECKSUM2_FLAG. The translation of the values to the checksum
 * length is provided in Table 9.8 of the specification:
 * 0 0 -> no checksum
 * 0 1 -> 32b
 * 1 0 -> 64b
 * 1 1 -> 128b
 */
#define MIGRtps_getCrcKind(heFlags__) \
        ((heFlags__) & MIG_RTPS_HE_CHECKSUM1_FLAG) != 0 \
                ? ((heFlags__) & MIG_RTPS_HE_CHECKSUM2_FLAG) != 0 \
                        ? MIG_RTPS_CRC_KIND_128 \
                        : MIG_RTPS_CRC_KIND_64 \
                : ((heFlags__) & MIG_RTPS_HE_CHECKSUM2_FLAG) != 0\
                        ? MIG_RTPS_CRC_KIND_32 \
                        : MIG_RTPS_CRC_KIND_INVALID


/*
 * Returns MIGRtpsCrcKind size in bytes.
 */
#define MIGRtpsCrcKind_getCrcSize(crcKind__) \
        ((crcKind__) == MIG_RTPS_CRC_KIND_32) \
                ? MIG_RTPS_CRC_32_SIZE \
                : ((crcKind__) == MIG_RTPS_CRC_KIND_64) \
                        ? MIG_RTPS_CRC_64_SIZE \
                        : ((crcKind__) == MIG_RTPS_CRC_KIND_128) \
                                ? MIG_RTPS_CRC_128_SIZE \
                                : 0


/*
 * Translates MIGRtpsCrcKind to RTIOsapiHashAlgorithmKind.
 */
#define MIGRtpsCrcKind_toHashAlgorithmKind(crcKind__) \
        ((crcKind__) == MIG_RTPS_CRC_KIND_32) \
                ? RTI_OSAPI_HASH_ALGORITHM_KIND_CRC32C \
                : ((crcKind__) == MIG_RTPS_CRC_KIND_64) \
                        ? RTI_OSAPI_HASH_ALGORITHM_KIND_XZ \
                        : ((crcKind__) == MIG_RTPS_CRC_KIND_128) \
                                ? RTI_OSAPI_HASH_ALGORITHM_KIND_MD5 \
                                : RTI_OSAPI_HASH_ALGORITHM_KIND_INVALID



#define MIGRtps_serializeTimeFast(stream__, time__) \
{ \
    struct RTIRtpsTime rtpsTime__; \
    RTIRtpsTime_fromNtptime(&(rtpsTime__), (time__)); \
    RTICdrStream_serializeUnsignedLongFast((stream__), &(rtpsTime__).sec); \
    RTICdrStream_serializeUnsignedLongFast((stream__), &(rtpsTime__).frac); \
}

#define MIGRtps_deserializeTimeFast(time__, stream__) \
{ \
    struct RTIRtpsTime rtpsTime__; \
    RTICdrStream_deserializeUnsignedLongFast((stream__), &(rtpsTime__).sec); \
    RTICdrStream_deserializeUnsignedLongFast((stream__), &(rtpsTime__).frac); \
    RTIRtpsTime_toNtptime(&(rtpsTime__), (time__)); \
}

#define MIGRtps_deserializeDurationFast(duration__, stream__) \
{ \
    struct RTIRtpsDuration rtpsDuration__; \
    RTICdrStream_deserializeLongFast((stream__), &(rtpsDuration__).sec); \
    RTICdrStream_deserializeUnsignedLongFast((stream__), &(rtpsDuration__).frac); \
    RTIRtpsDuration_toNtptime(&(rtpsDuration__), (duration__)); \
}



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* mig_rtps_impl_h */
