/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_alignment.h    generated by: makeheader    Sat Mar  9 09:37:07 2024
 *
 *		built from:	alignment.ifc
 */

#ifndef osapi_alignment_h
#define osapi_alignment_h


  #ifndef osapi_dll_h
    #include "osapi/osapi_dll.h"
  #endif
  #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif

typedef int RTIOsapiAlignment;


#define RTI_OSAPI_ALIGNMENT_DEFAULT (-1)


#define RTI_OSAPI_ALIGNMENT_ERROR (0)

extern RTIOsapiDllExport RTIOsapiAlignment
RTIOsapiAlignment_getDefaultAlignment(void);

extern RTIOsapiDllExport void *RTIOsapiAlignment_alignAddressUp(void *location,
                               RTIOsapiAlignment alignment);

extern RTIOsapiDllExport
size_t RTIOsapiAlignment_alignSizeUp(
        size_t size,
        RTIOsapiAlignment alignment);

extern RTIOsapiDllExport
RTI_INT32 RTIOsapiAlignment_alignInt32Up(
        RTI_INT32 size,
        RTIOsapiAlignment alignment);

extern RTIOsapiDllExport
RTI_UINT32 RTIOsapiAlignment_alignUInt32Up(
        RTI_UINT32 size,
        RTIOsapiAlignment alignment);

extern RTIOsapiDllExport RTI_INT64
RTIOsapiAlignment_alignInt64Up(RTI_INT64 size, RTIOsapiAlignment alignment);

extern RTIOsapiDllExport
RTI_UINT64 RTIOsapiAlignment_alignUInt64Up(
        RTI_UINT64 size,
        RTIOsapiAlignment alignment);

extern RTIOsapiDllExport int RTIOsapiAlignment_isAligned(void *location,
                             RTIOsapiAlignment alignment);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

  #include "osapi/osapi_alignment_impl.h"

#endif /* osapi_alignment_h */
