/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_heapContext.h    generated by: makeheader    Sat Mar  9 09:37:09 2024
 *
 *		built from:	heapContext.ifc
 */

#ifndef osapi_heapContext_h
#define osapi_heapContext_h



#ifndef osapi_context_h
  #include "osapi/osapi_context.h"
#endif
#ifdef __cplusplus
    extern "C" {
#endif


struct RTIOsapiHeapContextStackEntry {
    RTIBool poolAlloc;
    int poolBufferCount;
    int poolBufferSize;
    const char *topicName;
    const char *functionName;
};


#define RTIOsapiHeapContextStackEntry_INITIALIZER { \
    RTI_FALSE, \
    0, \
    0, \
    "unknown", \
    "unknown" \
}

extern RTIOsapiDllExport
RTIBool RTIOsapiHeapContextSupport_assertContextTss(RTIBool addContextTssToGlobalList);

extern RTIOsapiDllExport
RTIBool RTIOsapiHeapContext_mergeEntries(
        struct RTIOsapiHeapContextStackEntry *outputEntry);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_begin(void);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_start(
        RTIBool poolAlloc,
        int poolBufferCount,
        int poolBufferSize,
        const char *topicName,
        const char *functionName);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_startPool(
        RTIBool poolAlloc,
        int poolBufferCount,
        int poolBufferSize);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_startActivity(const char *topicName);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_enterActivity(const char *topicName);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_leaveEntries(void);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_end(void);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_enterTestFunction(const char *functionName);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_leaveTestFunction(void);

extern RTIOsapiDllExport
void RTIOsapiHeapContextScope_finalizeTestSupport(void);

extern RTIOsapiDllExport
RTI_UINT32 RTIOsapiHeapContext_getDepth(void);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

#include "osapi/osapi_heapContext_impl.h"

#endif /* osapi_heapContext_h */
