/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_heapContext_impl.h    generated by: makeheader    Sat Mar  9 09:37:09 2024
 *
 *		built from:	heapContext_impl.ifc
 */

#ifndef osapi_heapContext_impl_h
#define osapi_heapContext_impl_h


#ifdef __cplusplus
    extern "C" {
#endif



/* ========================================= */
/*  ContextSupport                           */
/* ========================================= */

#define RTIOsapiHeapContextSupport_assertContextTss( \
            addContextTssToGlobalList__) \
    RTIOsapiContextSupport_assertContextTss( \
            RTI_OSAPI_HEAP_CONTEXT_INDEX, \
            (addContextTssToGlobalList__), \
            RTI_OSAPI_CONTEXT_STACK_SIZE_DEFAULT, \
            RTI_FALSE)

#define RTIOsapiHeapContext_getDepth() \
    RTIOsapiContext_getDepth(RTI_OSAPI_HEAP_CONTEXT_INDEX)

/* ========================================= */
/*  ContextScope                             */
/* ========================================= */

#define RTIOsapiHeapContextScope_begin() \
    RTIOsapiContextScope_begin() \
    struct RTIOsapiHeapContextStackEntry heapContextEntry__; \
    RTI_UINT32 heapContextEntryCount__ = 0

#define RTIOsapiHeapContextScope_start( \
        poolAllocParam__, \
        poolBufferCountParam__, \
        poolBufferSizeParam__, \
        topicNameParam__, \
        functionNameParam__) \
    RTIOsapiHeapContextScope_begin(); \
    if (RTIOsapiHeap_isMonitoringEnabled()) { \
        heapContextEntry__.poolAlloc = (poolAllocParam__); \
        heapContextEntry__.poolBufferCount = (poolBufferCountParam__); \
        heapContextEntry__.poolBufferSize = (poolBufferSizeParam__); \
        heapContextEntry__.topicName = (topicNameParam__); \
        heapContextEntry__.functionName = (functionNameParam__); \
        RTIOsapiContext_enter( \
                NULL, /* context */ \
                RTI_OSAPI_HEAP_CONTEXT_INDEX, \
                &heapContextEntry__); \
        heapContextEntryCount__++; \
    }

#define RTIOsapiHeapContextScope_startPool( \
        poolAllocParam__, \
        poolBufferCountParam__, \
        poolBufferSizeParam__) \
    RTIOsapiHeapContextScope_begin(); \
    if (RTIOsapiHeap_isMonitoringEnabled()) { \
        heapContextEntry__.poolAlloc = (poolAllocParam__); \
        heapContextEntry__.poolBufferCount = (poolBufferCountParam__); \
        heapContextEntry__.poolBufferSize = (poolBufferSizeParam__); \
        heapContextEntry__.topicName = NULL; \
        heapContextEntry__.functionName = NULL; \
        RTIOsapiContext_enter( \
                NULL, /* context */ \
                RTI_OSAPI_HEAP_CONTEXT_INDEX, \
                &heapContextEntry__); \
        heapContextEntryCount__++; \
    }

#define RTIOsapiHeapContextScope_enterActivity(topicNameParam__) \
    if (RTIOsapiHeap_isMonitoringEnabled()) { \
        heapContextEntry__.poolAlloc = RTI_FALSE; \
        heapContextEntry__.poolBufferCount = 0; \
        heapContextEntry__.poolBufferSize = 0; \
        heapContextEntry__.topicName = (topicNameParam__); \
        heapContextEntry__.functionName = RTI_FUNCTION_NAME; \
        RTIOsapiContext_enter( \
                NULL, /* context */ \
                RTI_OSAPI_HEAP_CONTEXT_INDEX, \
                &heapContextEntry__); \
        heapContextEntryCount__++; \
    }

#define RTIOsapiHeapContextScope_startActivity(topicNameParam__) \
    RTIOsapiHeapContextScope_begin(); \
    RTIOsapiHeapContextScope_enterActivity(topicNameParam__)

#define RTIOsapiHeapContextScope_leaveEntries() \
    if (RTIOsapiHeap_isMonitoringEnabled()) { \
        RTIOsapiContext_leaveGroup( \
                NULL, /* heapContext */ \
                RTI_OSAPI_HEAP_CONTEXT_INDEX, \
                heapContextEntryCount__); \
        heapContextEntryCount__ = 0; \
    }

#define RTIOsapiHeapContextScope_end() \
    RTIOsapiHeapContextScope_leaveEntries() \
    RTIOsapiContextScope_end()

#define RTIOsapiHeapContext_getCategory(self__, category__) \
    RTIOsapiContext_getCategory( \
            (self__), \
            (category__), \
            RTI_OSAPI_HEAP_CONTEXT_INDEX)

#define RTIOsapiHeapContext_setCategory(self__, category__) \
    RTIOsapiContext_setCategory( \
            (self__), \
            RTI_OSAPI_HEAP_CONTEXT_INDEX, \
            (category__))

#define RTIOsapiHeapContext_addCategory(self__, category__) \
    RTIOsapiContext_addCategory( \
            (self__), \
            RTI_OSAPI_HEAP_CONTEXT_INDEX, \
            (category__))

#define RTIOsapiHeapContext_resetCategory(self__, category__) \
    RTIOsapiContext_resetCategory( \
            (self__), \
            RTI_OSAPI_HEAP_CONTEXT_INDEX, \
            (category__))

#define RTIOsapiHeapContext_addAndCacheCategory( \
        self__, \
        cachedCategory__, \
        category__) \
    RTIOsapiContext_addAndCacheCategory( \
            (self__), \
            (cachedCategory__), \
            RTI_OSAPI_HEAP_CONTEXT_INDEX, \
            (category__))



#ifdef __cplusplus
    }	/* extern "C" */
#endif


#endif /* osapi_heapContext_impl_h */
