/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_process_impl.h    generated by: makeheader    Sat Mar  9 09:37:09 2024
 *
 *		built from:	process_impl.ifc
 */

#ifndef osapi_process_impl_h
#define osapi_process_impl_h



#if !defined(RLIM_SAVED_CUR)
  #define RLIM_SAVED_CUR RTI_UINT64_MAX
#endif

#if !defined(RLIM_SAVED_MAX)
  #define RLIM_SAVED_MAX RTI_UINT64_MAX
#endif

#if (ENABLE_FACE_COMPLIANCE > FACE_COMPLIANCE_LEVEL_NONE)
  /* getrlimit is not allowed in any FACE profile */
  #define RTIOsapiProcess_getrlimitMacro(resc__, limit__) \
      ((limit__)->rlim_cur = RLIM_SAVED_CUR, (limit__)->rlim_max= RLIM_SAVED_MAX, 0)
#elif (defined(RTI_64BIT) && (defined(RTI_SOL2) || defined(RTI_QNX) || defined(RTI_ANDROID)))
  #define RTIOsapiProcess_getrlimitMacro(resc__, limit__) \
      getrlimit64((resc__),(limit__))
#elif (defined(RTI_LINUX) || defined(RTI_SOL2) || defined(RTI_QNX) || defined(RTI_DARWIN))
  #define RTIOsapiProcess_getrlimitMacro(resc__, limit__) \
      getrlimit((resc__),(limit__))
#else
  /* Set to the maximum possible value as we don't know if there is a limit */
  #define RTIOsapiProcess_getrlimitMacro(resc__, limit__) \
      ((limit__)->rlim_cur = RLIM_SAVED_CUR, (limit__)->rlim_max= RLIM_SAVED_MAX, 0)
#endif

#define RTIOsapiProcess_getrlimit RTIOsapiProcess_getrlimitMacro

#endif /* osapi_process_impl_h */
