/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)osapi_thread_impl.h    generated by: makeheader    Sat Mar  9 09:37:10 2024
 *
 *		built from:	thread_impl.ifc
 */

#ifndef osapi_thread_impl_h
#define osapi_thread_impl_h


  
#ifdef cplusplus
    extern "C" {
#endif


#define RTIOsapiThread_spin(spinCount__)                 \
{                                                        \
    RTI_UINT64 spin__;                                   \
    RTI_UINT64 ad__, bd__, cd__;                         \
    volatile RTI_UINT64 *a__, *b__, *c__;                \
    a__ = &ad__;                                         \
    b__ = &bd__;                                         \
    c__ = &cd__;                                         \
    for (spin__ = 0; spin__ < (spinCount__); ++spin__) { \
        *a__ = 3;                                        \
        *b__ = 1;                                        \
        *c__ = (*a__ / (*b__)) * spin__;                 \
    }                                                    \
}



#ifdef RTI_OSAPI_SIGNAL_HANDLER_SUPPORTED

extern RTIOsapiDllExport
void RTIOsapiThread_setRaiseSignalOnHandler(RTIBool raiseSignalOnHandler);


#endif /* RTI_OSAPI_SIGNAL_HANDLER_SUPPORTED */


#ifdef RTI_FUNCTION_HISTORY_SUPPORTED
    #define RTIOsapiThread_addFunctionToDebugInfo(pointerFuncName)   \
    {                                                                \
        if (RTILog_addToFunctionHistory != NULL) {                   \
            RTILog_addToFunctionHistory(pointerFuncName);            \
        }                                                            \
    }

#else

    #define RTIOsapiThread_addFunctionToDebugInfo(pointerFuncName) \
        ((void) 0);

#endif /* RTI_FUNCTION_HISTORY_SUPPORTED */

extern RTIOsapiDllExport
void RTIOsapiThread_setCreateContextOnSpawned(RTIBool createContext);


#define RTIOsapiThread_getTssAsInteger(key__) \
    RTIOsapiUtility_pointerToInt(RTIOsapiThread_getTss((key__)))

#define RTIOsapiThread_setTssAsInteger(key__, value__) \
    RTIOsapiThread_setTss((key__), RTIOsapiUtility_intToPointer((value__)))



#ifdef cplusplus
    }	/* extern "C" */
#endif

#endif /* osapi_thread_impl_h */
