/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)pres_psReaderWriter_impl.h    generated by: makeheader    Sat Mar  9 09:38:36 2024
 *
 *		built from:	psReaderWriter_impl.ifc
 */

#ifndef pres_psReaderWriter_impl_h
#define pres_psReaderWriter_impl_h


  #ifndef pres_service_h
    #include "mig/mig_generator.h"
  #endif
  #ifndef pres_service_h
    #include "pres/pres_service.h"
  #endif
  #ifndef pres_writerHistoryDriver_h
    #include "pres/pres_writerHistoryDriver.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif



/*---------------------------------------------------------------------------*/
#define PRESPsWriter_getUserObject(me) ((me)->parent.userObject)
#define PRESPsReader_getUserObject(me) ((me)->parent.userObject)
/*---------------------------------------------------------------------------*/

/*
 * For the case where me is the endpoint in a writer/reader record,
 * the check for '(me) != NULL' should not be really needed because 'me'
 * is set to NULL only when we finalize writer and/or reader record. At
 * this point this macro should not be used anymore because the record
 * should not be accessible
 *
 * So, '(me) != NULL' is a potentially unnecessary safety measure
 */
#define PRESPsWriter_isEnabled(me) \
    ((me) != NULL && (me)->parent.state == PRES_ENTITY_STATE_ENABLED)
#define PRESPsReader_isEnabled(me) \
    ((me) != NULL && (me)->parent.state == PRES_ENTITY_STATE_ENABLED)

/*---------------------------------------------------------------------------*/
#define PRESPsWriter_getProperty(me, p, worker)                          \
    (me)->_service->getLocalEndpointProperty((me)->_service, p, me, worker)

#define PRESPsWriter_setProperty(me, failReason, p, worker)                \
    (me)->_service->setLocalEndpointProperty( \
            (me)->_service, \
            failReason, \
            me, \
            p, \
            RTI_TRUE, /* propagateThroughDiscovery */ \
            worker)

#define PRESPsWriter_setPropertyEx( \
        me, \
        failReason, \
        p, \
        propagateThroughDiscovery, \
        worker) \
    (me)->_service->setLocalEndpointProperty( \
            (me)->_service, \
            failReason, \
            me, \
            p, \
            propagateThroughDiscovery, \
            worker)

/*---------------------------------------------------------------------------*/

#define PRESPsReader_getProperty(me, p, worker)                          \
    (me)->_service->getLocalEndpointProperty((me)->_service, p, me, worker)

#define PRESPsReader_setProperty(me, failReason, p, worker)                  \
    (me)->_service->setLocalEndpointProperty( \
            (me)->_service, \
            failReason, \
            me, \
            p, \
            RTI_TRUE, /* propagateThroughDiscovery */ \
            worker)

#define PRESPsReader_setPropertyEx( \
        me, \
        failReason, \
        p, \
        propagateThroughDiscovery, \
        worker) \
    (me)->_service->setLocalEndpointProperty( \
            (me)->_service, \
            failReason, \
            me, \
            p, \
            propagateThroughDiscovery, \
            worker)

/*---------------------------------------------------------------------------*/

#define PRESPsWriter_getListener(me, worker)                          \
    (me)->_service->getLocalEndpointListener((me)->_service, me, worker)

#define PRESPsWriter_setListener(               \
        me__,                                   \
        failReason__,                           \
        listener__,                             \
        mask__,                                 \
        worker__)                               \
    (me__)->_service->setLocalEndpointListener( \
            (me__)->_service,                   \
            (failReason__),                     \
            (me__),                             \
            (listener__),                       \
            (mask__), /* internalMask */        \
            (mask__), /* userMask */            \
            (worker__))

    /*---------------------------------------------------------------------------*/

#define PRESPsReader_getListener(me, worker)                          \
    (me)->_service->getLocalEndpointListener((me)->_service, me, worker)

#define PRESPsReader_setListener(               \
        me__,                                   \
        failReason__,                           \
        listener__,                             \
        internalMask__,                         \
        userMask__,                             \
        worker__)                               \
    (me__)->_service->setLocalEndpointListener( \
            (me__)->_service,                   \
            (failReason__),                     \
            (me__),                             \
            (listener__),                       \
            (internalMask__),                   \
            (userMask__),                       \
            (worker__))

/*---------------------------------------------------------------------------*/

#define PRESPsReader_enable(me, fr, worker)                          \
    (me)->_service->enableLocalEndpoint((me)->_service, fr, me, worker)

#define PRESPsWriter_enable(me, fr, worker)                          \
    (me)->_service->enableLocalEndpoint((me)->_service, fr, me, worker)

/*---------------------------------------------------------------------------*/

#define PRESPsReader_getGuid(__me, __guid)                          \
    (*(__guid)) = (__me)->parent.guid

#define PRESPsWriter_getGuid(__me, __guid)                          \
    (*(__guid)) = (__me)->parent.guid

/*---------------------------------------------------------------------------*/
#define PRESPsReader_get_cdr_support_mask(reader) \
    ((reader)->_cdrSupportMask)

#define PRESPsReader_get_security_attributes(reader) \
    (reader)->_security.attributes

/*---------------------------------------------------------------------------*/

PRESDllExport
RTIBool PRESPsWriter_writeInternal(
        struct PRESPsWriter *writer,
        struct REDASequenceNumber *sentSn,
        int *failReason,
        MIGGeneratorEndian endian,
        const struct PRESInstanceHandle *directedReaderHandle,
        const struct PRESOriginalWriterInfo *originalWriterInfo,
        const void *instanceData,
        struct PRESWriteParams *writeParams,
        struct REDAWorker *worker);

#define PRESPsWriter_write( \
    __me, __failReason, __data, __writeParams, __worker) \
    PRESPsWriter_writeInternal( \
        __me, NULL, __failReason, MIG_GENERATOR_ENDIAN_UNKNOWN, NULL, NULL, __data, __writeParams, __worker)

#define PRESPsWriter_writeWithSentSn( \
    __me, __sentSn, __failReason, __data, __writeParams, __worker) \
    PRESPsWriter_writeInternal( \
        __me, __sentSn, __failReason, MIG_GENERATOR_ENDIAN_UNKNOWN, NULL, NULL, __data, __writeParams, __worker)

#define PRESPsWriter_writeEndian( \
    __me, __failReason, __endian, __data, __writeParams, __worker) \
    PRESPsWriter_writeInternal( \
        __me, NULL, __failReason, __endian, NULL, NULL, __data, __writeParams, __worker)

#define PRESPsWriter_writeDirected( \
    __me, __failReason, __directedReaderHandle, __data, __writeParams, __worker) \
    PRESPsWriter_writeInternal( \
        __me, NULL, __failReason, MIG_GENERATOR_ENDIAN_UNKNOWN, __directedReaderHandle, NULL, __data, __writeParams, __worker)

#define PRESPsWriter_writeDirectedEndian( \
    __me, __failReason, __endian, __directedReaderHandle, __data, __writeParams, __worker) \
    PRESPsWriter_writeInternal( \
        __me, NULL, __failReason, __endian, __directedReaderHandle, NULL, __data, __writeParams, __worker)

/*---------------------------------------------------------------------------*/

PRESDllExport RTIBool
PRESPsWriter_writeBatchInternal(struct PRESPsWriter *writer, int *failReason,
                                PRESWriterHistoryDriverSampleKind sampleKind,
                                MIGGeneratorEndian endian,
                                const struct PRESInstanceHandle *directedReaderHandle,
                                const struct PRESOriginalWriterInfo * originalWriterInfo,
                                const void *instanceData,
                                struct PRESWriterHistoryDriver * whDriver, /* Only enabled for non-protected access */
                                struct PRESWriteParams *writeParams,
                                struct REDAWorker *worker);

#define PRESPsWriter_batchWrite( \
    __me,__failReason,__endian,__directedReaderHandle,__originalWriterInfo, __instanceData,\
    __whDriver,__writeParams,__worker) \
    PRESPsWriter_writeBatchInternal( \
        __me,__failReason,PRES_WRITER_HISTORY_DRIVER_DATA_SAMPLE_KIND, \
        __endian,__directedReaderHandle,__originalWriterInfo, __instanceData,\
        __whDriver,__writeParams,__worker)

#define PRESPsWriter_batchUnregisterInstance( \
    __me,__failReason,__directedReaderHandle,__originalWriterInfo, __instanceData,\
    __whDriver,__writeParams,__worker) \
    PRESPsWriter_writeBatchInternal( \
        __me,__failReason,PRES_WRITER_HISTORY_DRIVER_UNREGISTER_SAMPLE_KIND, \
        MIG_GENERATOR_ENDIAN_UNKNOWN,__directedReaderHandle,__originalWriterInfo, __instanceData,\
        __whDriver,__writeParams,__worker)

#define PRESPsWriter_batchDispose( \
    __me,__failReason,__directedReaderHandle,__originalWriterInfo, __instanceData,\
    __whDriver,__writeParams,__worker) \
    PRESPsWriter_writeBatchInternal( \
        __me,__failReason,PRES_WRITER_HISTORY_DRIVER_DISPOSE_SAMPLE_KIND, \
        MIG_GENERATOR_ENDIAN_UNKNOWN,__directedReaderHandle,__originalWriterInfo,__instanceData,\
        __whDriver,__writeParams,__worker)

/*---------------------------------------------------------------------------*/
PRESDllExport RTIBool
PRESPsWriter_flushBatchInternal(
    struct PRESPsWriter *writer, 
    int *failReason,
    RTIBool block,
    struct REDAWorker *worker);

/*---------------------------------------------------------------------------*/

PRESDllExport RTIBool
PRESPsWriter_unregisterInstanceInternal(
    struct PRESPsWriter *writer, int* failReason,
    const struct PRESInstanceHandle *directedReaderHandle,
    const void *keyHolder,
    const struct PRESOriginalWriterInfo * originalWriterInfo,
    struct PRESWriteParams * writeParams,
    struct REDAWorker *worker);

#define PRESPsWriter_unregisterInstance( \
    __me, __failReason, __keyHolder, __originalWriterInfo, __writeParams,__worker) \
    PRESPsWriter_unregisterInstanceInternal( \
        __me, __failReason, NULL, __keyHolder, __originalWriterInfo, __writeParams, __worker)

#define PRESPsWriter_unregisterInstanceDirected( \
    __me, __failReason, __directedReaderHandle, __keyHolder, __originalWriterInfo, __writeParams,__worker) \
    PRESPsWriter_unregisterInstanceInternal( \
        __me, __failReason, __directedReaderHandle, __keyHolder, __originalWriterInfo, __writeParams, __worker)

/*---------------------------------------------------------------------------*/

PRESDllExport RTIBool
PRESPsWriter_disposeInternal(struct PRESPsWriter *writer, int* failReasonOut,
           		     const struct PRESInstanceHandle *directedReaderHandle,
                             const struct PRESOriginalWriterInfo * originalWriterInfo,
                             const void *keyHolderIn,
                             struct PRESWriteParams *writeParams,
                             struct REDAWorker *worker);

#define PRESPsWriter_dispose( \
    __me, __failReason, __keyHolder, __writeParams, __worker) \
    PRESPsWriter_disposeInternal( \
    __me, __failReason, NULL, NULL, __keyHolder, __writeParams, __worker)

#define PRESPsWriter_disposeDirected( \
    __me, __failReason, __directedReaderHandle, __keyHolder, __writeParams, __worker) \
    PRESPsWriter_disposeInternal( \
    __me, __failReason, __directedReaderHandle, NULL, __keyHolder, __writeParams, __worker)

#define PRESPsWriter_get_cdr_support_mask(writer) \
    ((writer)->_cdrSupportMask)

#define PRESPsWriter_get_security_attributes(writer) \
    (writer)->_security.attributes



#ifdef __cplusplus
    }	/* extern "C" */
#endif

#endif /* pres_psReaderWriter_impl_h */
