/* (c) Copyright 2003-2021, Real-Time Innovations, Inc. All rights reserved. */
/*
 * @(#)reda_cursor.h    generated by: makeheader    Sat Mar  9 09:37:39 2024
 *
 *		built from:	cursor.ifc
 */

#ifndef reda_cursor_h
#define reda_cursor_h


  #ifndef osapi_type_h
    #include "osapi/osapi_type.h"
  #endif
  #ifndef reda_dll_h
    #include "reda/reda_dll.h"
  #endif
  #ifndef reda_log_h
    #include "reda/reda_log.h"
  #endif
  #ifndef reda_buffer_h
    #include "reda/reda_buffer.h"
  #endif
  #ifndef reda_epoch_h
    #include "reda/reda_epoch.h"
  #endif

#ifdef __cplusplus
    extern "C" {
#endif

struct REDACursor;

struct REDAWeakReference;

struct REDAWorker;

struct REDATable;


  #define REDA_CURSOR_SUCCESS /*                          (0) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 0)


  #define REDA_CURSOR_FAIL_PRECONDITION /*                (1) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 1)


  #define REDA_CURSOR_FAIL_AT_END_OF_TABLE /*             (2) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 2)


  #define REDA_CURSOR_FAIL_KEY_WAS_NOT_FOUND /*           (3) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 3)


  #define REDA_CURSOR_FAIL_TABLE_HAS_NO_READ_ONLY_AREA  /* (4) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 4)


  #define REDA_CURSOR_FAIL_TABLE_HAS_NO_READ_WRITE_AREA /* (5) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 5)


  #define REDA_CURSOR_FAIL_TABLE_HAS_BEEN_DELETED /*      (6) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 6)


  #define REDA_CURSOR_FAIL_RECORD_HAS_BEEN_DELETED /*     (7) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 7)


  #define REDA_CURSOR_FAIL_TABLE_IS_FULL /*               (8) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 8)


  #define REDA_CURSOR_FAIL_UNIQUE_KEY_VIOLATION /*        (9) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 9)


  #define REDA_CURSOR_FAIL_UNEXPECTED_EXCEPTION /*       (10) */ \
    RTI_LOG_formSubmoduleSpecificNumber(MODULE_REDA, SUBMODULE_REDA_TABLE, 10)

extern REDADllExport
RTIBool 
REDACursor_startFnc(struct REDACursor *me, int* failReasonPtr);

extern REDADllExport
void
REDACursor_gotoTopFnc(struct REDACursor *me);

extern REDADllExport
RTIBool 
REDACursor_gotoNextFnc(struct REDACursor *me);

extern REDADllExport RTIBool REDACursor_gotoKey(
        struct REDACursor *me,
        RTIBool *preciseMatch,
        int *failReason,
        void *searchKey);

extern REDADllExport RTIBool
REDACursor_gotoKeyEqual(struct REDACursor *me,
			int *failReason,
			void* searchKey);

extern REDADllExport RTIBool 
REDACursor_gotoKeyLargerOrEqual(struct REDACursor *me, 
	                        int *failReason,
		                void *searchKey);

extern REDADllExport RTIBool 
REDACursor_gotoWeakReference(struct REDACursor *me,
                             int *failReason,
                             const struct REDAWeakReference *reference);

extern REDADllExport
RTIBool REDACursor_isWeakReferenceInTableFnc(
        struct REDACursor *me,
        const struct REDAWeakReference *reference);

extern REDADllExport RTIBool 
REDACursor_getWeakReference(const struct REDACursor *me,
			    int *failReason,
                            struct REDAWeakReference *reference);

extern REDADllExport RTIBool 
REDACursor_lookupWeakReference(const struct REDACursor *me,
			       int *failReason,
			       struct REDAWeakReference *reference);

extern REDADllExport const void *
REDACursor_getKeyFnc(const struct REDACursor *me);

extern REDADllExport const void *
REDACursor_getReadOnlyAreaFnc(const struct REDACursor *me);

extern REDADllExport
struct REDAExclusiveArea * REDACursor_getRecordEAFnc(const struct REDACursor *me);

extern REDADllExport void *
REDACursor_modifyReadWriteArea(struct REDACursor *me, int *failReason);

extern REDADllExport
const void *REDACursor_getTableUserDataFnc(const struct REDACursor *me);

extern REDADllExport
int REDACursor_getTableRecordCountFnc(const struct REDACursor *me);

extern REDADllExport struct REDAExclusiveArea *
REDACursor_getTableEAFnc(const struct REDACursor *me);

extern REDADllExport RTIBool REDACursor_lockTable(struct REDACursor *me,
						  int *failReason);

extern REDADllExport void *
REDACursor_assertAndModifyReadWriteArea(struct REDACursor *me,
					int *failReason,
					RTIBool *alreadyExisted,
					struct REDAWeakReference *weakReference,
					void *key, 
					void *readOnlyArea,
					struct REDAExclusiveArea *recordEA);

extern REDADllExport RTIBool 
REDACursor_assertAndReplaceRecord(struct REDACursor *me,
				  int *failReason,
				  RTIBool *alreadyExisted,
				  struct REDAWeakReference *weakReference,
				  void *key, 
			          void *readOnlyArea,
				  void *readWriteArea,
				  struct REDAExclusiveArea *recordEA);

extern REDADllExport RTIBool 
REDACursor_assertRecord(struct REDACursor *me,
			int *failReason,
			RTIBool *alreadyExisted,
			struct REDAWeakReference *weakReference,
			void *key, 
			void *readOnlyArea);

extern REDADllExport RTIBool REDACursor_copyReadWriteArea(
        struct REDACursor *me,
        int *failReason,
        void *buffer,
        size_t numBytesToCopy,
        size_t offset,
        RTIBool noRecordLock);

extern REDADllExport
RTIBool REDACursor_copyReadWriteAreaUnsafe(
        struct REDACursor *cursor,
        RTI_INT32 *fr,
        void **buffer,
        RTI_UINT32 portionCount,
        const RTI_UINT32 *numBytesToCopy,
        const RTI_UINT32 *recordOffset);

/* ----------------------------------------------------------------- */
/*e \ingroup REDACursorClass

  @brief Remove the record from the table.
  
  @pre A cursor in the state "table-locked" or "table+record-locked"
  
  @invariant The cursor stays in the same state, positioned at the
  same record

  @post On success (RTI_TRUE is returned): the record the cursor is 
  currently positioned at is marked for removal. The position of the 
  cursor is not changed so it is still possible for this cursor 
  (and other cursors that were already pointing to that record) 
  to access the record.

  This function marks for removal the record the cursor is pointing
  to. The record will not physically be removed until all cursors that
  are currently bound to the table have "seen" this change. It is
  still possible for other bound cursors (operated by other threads)
  to see the "marked record" if they happen to already be positioned
  at that same record. The table will ensure that cursors don't see
  the record if they were not "already" positioned at the record
  ("already" is to be understood as also meaning they can be in the
  process of pointing to it though one of the re-positioning
  operations like gotoKeyEqual or gotoNext or gotoWeakReference).

  The table will not physically remove the record until it is
  thread-safe to do so and that accounts for making sure all the bound
  cursors have "seen" the change and thus are not and will not be able
  to position at the record.

  Records maked for removal are ohysically removed when it is safe by
  the thread that calls REDATable_cleanup. That thread will also call
  the registered REDATableRecordFinalizeFunction (if any) on the
  records as it physically removes them.

  @param failReason \b Out.  An optional parameter in which the
  reason of failure (returning FALSE) will be returned.  This may
  be NULL in case the caller is not interested in the reason of
  failure.

  @param alreadyRemoved \b Out. 
             If the function is successful, this boolean denotes
             whether the record was no longer in the table (so no
             removal action was taken) or the function removed the
             record. This is an optional parameter, ignored if NULL
	     is passed in.

  @return RTI_TRUE if successfully removed or already removed.  
          RTI_FALSE on failure.

  @mtsafety unsafe. Only the thread/worker that is bound to the cursor
  can use it. Refer to the description of how \ref
  DOXANCHOR_CursorWorkerBinding "cursors are bound to threads" for
  more details.
*/
extern REDADllExport RTIBool REDACursor_removeRecord(struct REDACursor *me,
						     int *failReason,
						     RTIBool *alreadyRemoved);

extern REDADllExport RTIBool REDACursor_removeTable(struct REDACursor *me,
						    int *failReason, 
						    RTIBool *alreadyRemoved);

extern REDADllExport void
REDACursor_finishReadWriteArea(struct REDACursor *me);

extern REDADllExport RTIBool
REDACursor_unfreezeReadWriteAreaFnc(struct REDACursor *me);

extern REDADllExport void REDACursor_unlockTable(struct REDACursor *me);

extern REDADllExport void REDACursor_finish(struct REDACursor *me);

extern REDADllExport void
REDACursor_unbind(struct REDACursor *me,
                  struct REDAWorker *worker);

extern REDADllExport RTIBool
REDACursor_tableHasReadOnlyAreaFnc(const struct REDACursor *me);

extern REDADllExport RTIBool
REDACursor_tableHasReadWriteAreaFnc(const struct REDACursor *me);

extern REDADllExport int
REDACursor_getReadWriteAreaSizeFnc(const struct REDACursor *me);

extern REDADllExport
void REDACursor_printKey(
        const struct REDACursor *me,
        const char *desc,
        int indent);

extern REDADllExport
void REDACursor_printReadOnlyArea(
        const struct REDACursor *me,
        const char *desc,
        int indent);

extern REDADllExport
void REDACursor_printReadWriteArea(
        struct REDACursor *me,
        const char *desc,
        int indent);

extern REDADllExport
void REDACursor_printAdminArea(
        struct REDACursor *c,
        const char *desc,
        int indent);

extern REDADllExport void
REDACursor_printTableStatus(const struct REDACursor *me,
			    int indent);


#ifdef __cplusplus
    }	/* extern "C" */
#endif

/* pick up hidden performance boosting macros and optimizations */
  #include "reda/reda_cursor_impl.h"

#endif /* reda_cursor_h */
