/*
 * (c) Copyright, Real-Time Innovations, 2022.
 * All rights reserved.
 * No duplications, whole or partial, manual or electronic, may be made
 * without express written permission.  Any such copies, or
 * revisions thereof, must display this notice unaltered.
 * This code contains trade secrets of Real-Time Innovations, Inc.
 */
#ifndef test_log_msg_h
#define test_log_msg_h

#include "rtitest/test_dll.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @defgroup RTITestLogTemplatesClass Log Templates
 * @ingroup RTITestLogging
 * @brief Log templates used in the log functions. The names of the templates are
 * self-descriptive.
 */

/* clang-format off */
/**
 * @ingroup RTITestLogTemplatesClass
 */
extern RTITestDllVariable const struct RTITestLogMessage RTI_TEST_LOG_BAD_PARAMETER_TEMPLATE;
/**
 * @ingroup RTITestLogTemplatesClass
 */
extern RTITestDllVariable const struct RTITestLogMessage RTI_TEST_LOG_EMPTY_TEMPLATE;
/**
 * @ingroup RTITestLogTemplatesClass
 */
extern RTITestDllVariable const struct RTITestLogMessage RTI_TEST_LOG_FAILURE_TEMPLATE;
/**
 * @ingroup RTITestLogTemplatesClass
 */
extern RTITestDllVariable const struct RTITestLogMessage RTI_TEST_LOG_GET_FAILURE_TEMPLATE;
/**
 * @ingroup RTITestLogTemplatesClass
 */
extern RTITestDllVariable const struct RTITestLogMessage RTI_TEST_LOG_OS_FAILURE_TEMPLATE;
/**
 * @ingroup RTITestLogTemplatesClass
 */
extern RTITestDllVariable const struct RTITestLogMessage RTI_TEST_LOG_SET_FAILURE_TEMPLATE;
/**
 * @ingroup RTITestLogTemplatesClass
 */
/* clang-format on */

#ifdef __cplusplus
}
#endif

#endif /* test_log_msg_h */