/*
 (c) Copyright, Real-Time Innovations, 2018
 All rights reserved.
 No duplications, whole or partial, manual or electronic, may be made
 without express written permission.  Any such copies, or
 revisions thereof, must display this notice unaltered.
 This code contains trade secrets of Real-Time Innovations, Inc.

=========================================================================*/

#ifndef security_version_h
#define security_version_h

#ifndef security_dll_h
  #include "security/security_dll.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*i
 * \file
 * \brief Version facilities for the security module
 */

/*e
 * \defgroup RTI_SecurityVersionModule
 * \brief Security Plugin version
 */


/*e
 * \ingroup RTI_SecurityVersionModule
 * \brief The Security Plugin version.
 */
typedef struct RTI_Security_LibraryVersion {
    char major;
    char minor;
    char release;
    char revision;
} RTI_Security_LibraryVersion;

/*e \ingroup RTI_SecurityVersionModule
 *
 * Gets the security library version
 */
extern RTISecurityDllExport
const RTI_Security_LibraryVersion *RTI_Security_get_library_version(void);

/*e \ingroup RTI_SecurityVersionModule
 *
 * Gets the security library build version string
 */
extern RTISecurityDllExport
const char *RTI_Security_get_build_version_string(void);


#ifdef __cplusplus
}    /* extern "C" */
#endif

#endif
